#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 866
#define LARGE_STATE_COUNT 5
#define SYMBOL_COUNT 129
#define ALIAS_COUNT 0
#define TOKEN_COUNT 69
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 0
#define MAX_ALIAS_SEQUENCE_LENGTH 6
#define PRODUCTION_ID_COUNT 1

enum {
  sym_identifier = 1,
  sym__comment = 2,
  anon_sym_return = 3,
  anon_sym_break = 4,
  anon_sym_SEMI = 5,
  anon_sym_LPAREN = 6,
  anon_sym_RPAREN = 7,
  anon_sym_COMMA = 8,
  anon_sym_as = 9,
  anon_sym_PIPE = 10,
  anon_sym_CARET = 11,
  sym_command_text = 12,
  aux_sym_command_argument_token1 = 13,
  aux_sym_command_argument_token2 = 14,
  anon_sym_async = 15,
  anon_sym_LBRACE = 16,
  anon_sym_RBRACE = 17,
  sym_range = 18,
  sym_integer = 19,
  aux_sym_float_token1 = 20,
  anon_sym_Infinity = 21,
  anon_sym_infinity = 22,
  anon_sym_NaN = 23,
  anon_sym_nan = 24,
  anon_sym_true = 25,
  anon_sym_false = 26,
  anon_sym_LBRACK = 27,
  anon_sym_RBRACK = 28,
  anon_sym_EQ = 29,
  anon_sym_COLON = 30,
  anon_sym_PLUS = 31,
  anon_sym_DASH = 32,
  anon_sym_STAR = 33,
  anon_sym_SLASH = 34,
  anon_sym_PERCENT = 35,
  anon_sym_EQ_EQ = 36,
  anon_sym_BANG_EQ = 37,
  anon_sym_AMP_AMP = 38,
  anon_sym_PIPE_PIPE = 39,
  anon_sym_GT = 40,
  anon_sym_LT = 41,
  anon_sym_GT_EQ = 42,
  anon_sym_LT_EQ = 43,
  anon_sym_PLUS_EQ = 44,
  anon_sym_DASH_EQ = 45,
  anon_sym_if = 46,
  anon_sym_elseif = 47,
  anon_sym_else = 48,
  anon_sym_match = 49,
  anon_sym_DASH_GT = 50,
  anon_sym_COLON_COLON = 51,
  anon_sym_loop = 52,
  anon_sym_while = 53,
  anon_sym_for = 54,
  anon_sym_asyncfor = 55,
  anon_sym_in = 56,
  anon_sym_any = 57,
  anon_sym_bool = 58,
  anon_sym_collection = 59,
  anon_sym_float = 60,
  anon_sym_int = 61,
  anon_sym_list = 62,
  anon_sym_map = 63,
  anon_sym_none = 64,
  anon_sym_num = 65,
  anon_sym_str = 66,
  anon_sym_enum = 67,
  anon_sym_struct = 68,
  sym_root = 69,
  sym_statement = 70,
  sym_statement_kind = 71,
  sym_expression = 72,
  sym__expression_kind = 73,
  aux_sym__expression_list = 74,
  sym_as_node = 75,
  sym_pipe = 76,
  sym_command = 77,
  sym_command_argument = 78,
  sym_block = 79,
  sym_value = 80,
  sym_float = 81,
  sym_string = 82,
  sym_boolean = 83,
  sym_list = 84,
  sym_map = 85,
  sym_index = 86,
  sym_index_expression = 87,
  sym_math = 88,
  sym_math_operator = 89,
  sym_logic = 90,
  sym_logic_operator = 91,
  sym_assignment = 92,
  sym_index_assignment = 93,
  sym_assignment_operator = 94,
  sym_if_else = 95,
  sym_if = 96,
  sym_else_if = 97,
  sym_else = 98,
  sym_match = 99,
  sym_match_pattern = 100,
  sym_enum_pattern = 101,
  sym_loop_node = 102,
  sym_while = 103,
  sym_for = 104,
  sym_type_specification = 105,
  sym_type = 106,
  sym_function = 107,
  sym_function_expression = 108,
  sym__function_expression_kind = 109,
  sym_function_call = 110,
  sym_type_definition = 111,
  sym_type_arguments = 112,
  sym_enum_definition = 113,
  sym_enum_instance = 114,
  sym_struct_definition = 115,
  sym_struct_instance = 116,
  aux_sym_root_repeat1 = 117,
  aux_sym_command_repeat1 = 118,
  aux_sym_list_repeat1 = 119,
  aux_sym_map_repeat1 = 120,
  aux_sym_if_else_repeat1 = 121,
  aux_sym_match_repeat1 = 122,
  aux_sym_type_repeat1 = 123,
  aux_sym_type_repeat2 = 124,
  aux_sym_function_repeat1 = 125,
  aux_sym_enum_definition_repeat1 = 126,
  aux_sym_enum_definition_repeat2 = 127,
  aux_sym_struct_definition_repeat1 = 128,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym__comment] = "_comment",
  [anon_sym_return] = "return",
  [anon_sym_break] = "break",
  [anon_sym_SEMI] = ";",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_COMMA] = ",",
  [anon_sym_as] = "as",
  [anon_sym_PIPE] = "|",
  [anon_sym_CARET] = "^",
  [sym_command_text] = "command_text",
  [aux_sym_command_argument_token1] = "command_argument_token1",
  [aux_sym_command_argument_token2] = "command_argument_token2",
  [anon_sym_async] = "async",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [sym_range] = "range",
  [sym_integer] = "integer",
  [aux_sym_float_token1] = "float_token1",
  [anon_sym_Infinity] = "Infinity",
  [anon_sym_infinity] = "infinity",
  [anon_sym_NaN] = "NaN",
  [anon_sym_nan] = "nan",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_EQ] = "=",
  [anon_sym_COLON] = ":",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_GT] = ">",
  [anon_sym_LT] = "<",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_if] = "if",
  [anon_sym_elseif] = "else if",
  [anon_sym_else] = "else",
  [anon_sym_match] = "match",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_loop] = "loop",
  [anon_sym_while] = "while",
  [anon_sym_for] = "for",
  [anon_sym_asyncfor] = "async for",
  [anon_sym_in] = "in",
  [anon_sym_any] = "any",
  [anon_sym_bool] = "bool",
  [anon_sym_collection] = "collection",
  [anon_sym_float] = "float",
  [anon_sym_int] = "int",
  [anon_sym_list] = "list",
  [anon_sym_map] = "map",
  [anon_sym_none] = "none",
  [anon_sym_num] = "num",
  [anon_sym_str] = "str",
  [anon_sym_enum] = "enum",
  [anon_sym_struct] = "struct",
  [sym_root] = "root",
  [sym_statement] = "statement",
  [sym_statement_kind] = "statement_kind",
  [sym_expression] = "expression",
  [sym__expression_kind] = "_expression_kind",
  [aux_sym__expression_list] = "_expression_list",
  [sym_as_node] = "as_node",
  [sym_pipe] = "pipe",
  [sym_command] = "command",
  [sym_command_argument] = "command_argument",
  [sym_block] = "block",
  [sym_value] = "value",
  [sym_float] = "float",
  [sym_string] = "string",
  [sym_boolean] = "boolean",
  [sym_list] = "list",
  [sym_map] = "map",
  [sym_index] = "index",
  [sym_index_expression] = "index_expression",
  [sym_math] = "math",
  [sym_math_operator] = "math_operator",
  [sym_logic] = "logic",
  [sym_logic_operator] = "logic_operator",
  [sym_assignment] = "assignment",
  [sym_index_assignment] = "index_assignment",
  [sym_assignment_operator] = "assignment_operator",
  [sym_if_else] = "if_else",
  [sym_if] = "if",
  [sym_else_if] = "else_if",
  [sym_else] = "else",
  [sym_match] = "match",
  [sym_match_pattern] = "match_pattern",
  [sym_enum_pattern] = "enum_pattern",
  [sym_loop_node] = "loop_node",
  [sym_while] = "while",
  [sym_for] = "for",
  [sym_type_specification] = "type_specification",
  [sym_type] = "type",
  [sym_function] = "function",
  [sym_function_expression] = "function_expression",
  [sym__function_expression_kind] = "_function_expression_kind",
  [sym_function_call] = "function_call",
  [sym_type_definition] = "type_definition",
  [sym_type_arguments] = "type_arguments",
  [sym_enum_definition] = "enum_definition",
  [sym_enum_instance] = "enum_instance",
  [sym_struct_definition] = "struct_definition",
  [sym_struct_instance] = "struct_instance",
  [aux_sym_root_repeat1] = "root_repeat1",
  [aux_sym_command_repeat1] = "command_repeat1",
  [aux_sym_list_repeat1] = "list_repeat1",
  [aux_sym_map_repeat1] = "map_repeat1",
  [aux_sym_if_else_repeat1] = "if_else_repeat1",
  [aux_sym_match_repeat1] = "match_repeat1",
  [aux_sym_type_repeat1] = "type_repeat1",
  [aux_sym_type_repeat2] = "type_repeat2",
  [aux_sym_function_repeat1] = "function_repeat1",
  [aux_sym_enum_definition_repeat1] = "enum_definition_repeat1",
  [aux_sym_enum_definition_repeat2] = "enum_definition_repeat2",
  [aux_sym_struct_definition_repeat1] = "struct_definition_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [sym__comment] = sym__comment,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_CARET] = anon_sym_CARET,
  [sym_command_text] = sym_command_text,
  [aux_sym_command_argument_token1] = aux_sym_command_argument_token1,
  [aux_sym_command_argument_token2] = aux_sym_command_argument_token2,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [sym_range] = sym_range,
  [sym_integer] = sym_integer,
  [aux_sym_float_token1] = aux_sym_float_token1,
  [anon_sym_Infinity] = anon_sym_Infinity,
  [anon_sym_infinity] = anon_sym_infinity,
  [anon_sym_NaN] = anon_sym_NaN,
  [anon_sym_nan] = anon_sym_nan,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_elseif] = anon_sym_elseif,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_match] = anon_sym_match,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_loop] = anon_sym_loop,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_asyncfor] = anon_sym_asyncfor,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_any] = anon_sym_any,
  [anon_sym_bool] = anon_sym_bool,
  [anon_sym_collection] = anon_sym_collection,
  [anon_sym_float] = anon_sym_float,
  [anon_sym_int] = anon_sym_int,
  [anon_sym_list] = anon_sym_list,
  [anon_sym_map] = anon_sym_map,
  [anon_sym_none] = anon_sym_none,
  [anon_sym_num] = anon_sym_num,
  [anon_sym_str] = anon_sym_str,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_struct] = anon_sym_struct,
  [sym_root] = sym_root,
  [sym_statement] = sym_statement,
  [sym_statement_kind] = sym_statement_kind,
  [sym_expression] = sym_expression,
  [sym__expression_kind] = sym__expression_kind,
  [aux_sym__expression_list] = aux_sym__expression_list,
  [sym_as_node] = sym_as_node,
  [sym_pipe] = sym_pipe,
  [sym_command] = sym_command,
  [sym_command_argument] = sym_command_argument,
  [sym_block] = sym_block,
  [sym_value] = sym_value,
  [sym_float] = sym_float,
  [sym_string] = sym_string,
  [sym_boolean] = sym_boolean,
  [sym_list] = sym_list,
  [sym_map] = sym_map,
  [sym_index] = sym_index,
  [sym_index_expression] = sym_index_expression,
  [sym_math] = sym_math,
  [sym_math_operator] = sym_math_operator,
  [sym_logic] = sym_logic,
  [sym_logic_operator] = sym_logic_operator,
  [sym_assignment] = sym_assignment,
  [sym_index_assignment] = sym_index_assignment,
  [sym_assignment_operator] = sym_assignment_operator,
  [sym_if_else] = sym_if_else,
  [sym_if] = sym_if,
  [sym_else_if] = sym_else_if,
  [sym_else] = sym_else,
  [sym_match] = sym_match,
  [sym_match_pattern] = sym_match_pattern,
  [sym_enum_pattern] = sym_enum_pattern,
  [sym_loop_node] = sym_loop_node,
  [sym_while] = sym_while,
  [sym_for] = sym_for,
  [sym_type_specification] = sym_type_specification,
  [sym_type] = sym_type,
  [sym_function] = sym_function,
  [sym_function_expression] = sym_function_expression,
  [sym__function_expression_kind] = sym__function_expression_kind,
  [sym_function_call] = sym_function_call,
  [sym_type_definition] = sym_type_definition,
  [sym_type_arguments] = sym_type_arguments,
  [sym_enum_definition] = sym_enum_definition,
  [sym_enum_instance] = sym_enum_instance,
  [sym_struct_definition] = sym_struct_definition,
  [sym_struct_instance] = sym_struct_instance,
  [aux_sym_root_repeat1] = aux_sym_root_repeat1,
  [aux_sym_command_repeat1] = aux_sym_command_repeat1,
  [aux_sym_list_repeat1] = aux_sym_list_repeat1,
  [aux_sym_map_repeat1] = aux_sym_map_repeat1,
  [aux_sym_if_else_repeat1] = aux_sym_if_else_repeat1,
  [aux_sym_match_repeat1] = aux_sym_match_repeat1,
  [aux_sym_type_repeat1] = aux_sym_type_repeat1,
  [aux_sym_type_repeat2] = aux_sym_type_repeat2,
  [aux_sym_function_repeat1] = aux_sym_function_repeat1,
  [aux_sym_enum_definition_repeat1] = aux_sym_enum_definition_repeat1,
  [aux_sym_enum_definition_repeat2] = aux_sym_enum_definition_repeat2,
  [aux_sym_struct_definition_repeat1] = aux_sym_struct_definition_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__comment] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [sym_command_text] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_command_argument_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_argument_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [sym_range] = {
    .visible = true,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_float_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_Infinity] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_infinity] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_NaN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nan] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elseif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_match] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_loop] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_asyncfor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_any] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bool] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_collection] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_float] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_list] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_map] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_none] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_num] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_str] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [sym_root] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_kind] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__expression_kind] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__expression_list] = {
    .visible = false,
    .named = false,
  },
  [sym_as_node] = {
    .visible = true,
    .named = true,
  },
  [sym_pipe] = {
    .visible = true,
    .named = true,
  },
  [sym_command] = {
    .visible = true,
    .named = true,
  },
  [sym_command_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_value] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym_map] = {
    .visible = true,
    .named = true,
  },
  [sym_index] = {
    .visible = true,
    .named = true,
  },
  [sym_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_math] = {
    .visible = true,
    .named = true,
  },
  [sym_math_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_logic] = {
    .visible = true,
    .named = true,
  },
  [sym_logic_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_index_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_if_else] = {
    .visible = true,
    .named = true,
  },
  [sym_if] = {
    .visible = true,
    .named = true,
  },
  [sym_else_if] = {
    .visible = true,
    .named = true,
  },
  [sym_else] = {
    .visible = true,
    .named = true,
  },
  [sym_match] = {
    .visible = true,
    .named = true,
  },
  [sym_match_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_loop_node] = {
    .visible = true,
    .named = true,
  },
  [sym_while] = {
    .visible = true,
    .named = true,
  },
  [sym_for] = {
    .visible = true,
    .named = true,
  },
  [sym_type_specification] = {
    .visible = true,
    .named = true,
  },
  [sym_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_function_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__function_expression_kind] = {
    .visible = false,
    .named = true,
  },
  [sym_function_call] = {
    .visible = true,
    .named = true,
  },
  [sym_type_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_instance] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_instance] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_root_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_map_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_else_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_match_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_definition_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_struct_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 2,
  [4] = 2,
  [5] = 5,
  [6] = 6,
  [7] = 6,
  [8] = 8,
  [9] = 9,
  [10] = 8,
  [11] = 5,
  [12] = 6,
  [13] = 9,
  [14] = 8,
  [15] = 5,
  [16] = 6,
  [17] = 9,
  [18] = 18,
  [19] = 9,
  [20] = 8,
  [21] = 5,
  [22] = 6,
  [23] = 6,
  [24] = 5,
  [25] = 8,
  [26] = 9,
  [27] = 9,
  [28] = 9,
  [29] = 8,
  [30] = 5,
  [31] = 8,
  [32] = 8,
  [33] = 6,
  [34] = 9,
  [35] = 6,
  [36] = 8,
  [37] = 37,
  [38] = 9,
  [39] = 18,
  [40] = 5,
  [41] = 5,
  [42] = 5,
  [43] = 6,
  [44] = 44,
  [45] = 44,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 48,
  [50] = 50,
  [51] = 44,
  [52] = 47,
  [53] = 53,
  [54] = 54,
  [55] = 48,
  [56] = 56,
  [57] = 44,
  [58] = 58,
  [59] = 48,
  [60] = 47,
  [61] = 47,
  [62] = 48,
  [63] = 63,
  [64] = 47,
  [65] = 44,
  [66] = 66,
  [67] = 66,
  [68] = 66,
  [69] = 66,
  [70] = 66,
  [71] = 66,
  [72] = 66,
  [73] = 66,
  [74] = 66,
  [75] = 66,
  [76] = 76,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 82,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 94,
  [95] = 95,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 100,
  [101] = 98,
  [102] = 102,
  [103] = 103,
  [104] = 103,
  [105] = 102,
  [106] = 106,
  [107] = 106,
  [108] = 108,
  [109] = 109,
  [110] = 110,
  [111] = 95,
  [112] = 112,
  [113] = 113,
  [114] = 114,
  [115] = 115,
  [116] = 116,
  [117] = 117,
  [118] = 112,
  [119] = 119,
  [120] = 120,
  [121] = 114,
  [122] = 122,
  [123] = 119,
  [124] = 115,
  [125] = 125,
  [126] = 126,
  [127] = 127,
  [128] = 128,
  [129] = 129,
  [130] = 130,
  [131] = 131,
  [132] = 132,
  [133] = 127,
  [134] = 134,
  [135] = 135,
  [136] = 136,
  [137] = 137,
  [138] = 138,
  [139] = 129,
  [140] = 92,
  [141] = 77,
  [142] = 82,
  [143] = 97,
  [144] = 96,
  [145] = 95,
  [146] = 78,
  [147] = 100,
  [148] = 81,
  [149] = 99,
  [150] = 76,
  [151] = 80,
  [152] = 85,
  [153] = 94,
  [154] = 90,
  [155] = 88,
  [156] = 84,
  [157] = 86,
  [158] = 91,
  [159] = 87,
  [160] = 89,
  [161] = 93,
  [162] = 162,
  [163] = 163,
  [164] = 163,
  [165] = 163,
  [166] = 166,
  [167] = 162,
  [168] = 166,
  [169] = 169,
  [170] = 162,
  [171] = 162,
  [172] = 162,
  [173] = 169,
  [174] = 166,
  [175] = 175,
  [176] = 163,
  [177] = 177,
  [178] = 166,
  [179] = 177,
  [180] = 169,
  [181] = 166,
  [182] = 166,
  [183] = 177,
  [184] = 163,
  [185] = 163,
  [186] = 186,
  [187] = 177,
  [188] = 169,
  [189] = 166,
  [190] = 169,
  [191] = 177,
  [192] = 163,
  [193] = 163,
  [194] = 166,
  [195] = 98,
  [196] = 109,
  [197] = 108,
  [198] = 103,
  [199] = 199,
  [200] = 200,
  [201] = 201,
  [202] = 202,
  [203] = 203,
  [204] = 204,
  [205] = 199,
  [206] = 206,
  [207] = 204,
  [208] = 116,
  [209] = 206,
  [210] = 203,
  [211] = 203,
  [212] = 206,
  [213] = 199,
  [214] = 95,
  [215] = 102,
  [216] = 201,
  [217] = 106,
  [218] = 110,
  [219] = 219,
  [220] = 219,
  [221] = 203,
  [222] = 199,
  [223] = 206,
  [224] = 203,
  [225] = 200,
  [226] = 206,
  [227] = 202,
  [228] = 199,
  [229] = 206,
  [230] = 199,
  [231] = 231,
  [232] = 199,
  [233] = 199,
  [234] = 206,
  [235] = 206,
  [236] = 206,
  [237] = 199,
  [238] = 117,
  [239] = 120,
  [240] = 206,
  [241] = 122,
  [242] = 199,
  [243] = 138,
  [244] = 103,
  [245] = 126,
  [246] = 132,
  [247] = 136,
  [248] = 106,
  [249] = 131,
  [250] = 102,
  [251] = 128,
  [252] = 134,
  [253] = 135,
  [254] = 125,
  [255] = 137,
  [256] = 102,
  [257] = 130,
  [258] = 258,
  [259] = 259,
  [260] = 106,
  [261] = 103,
  [262] = 262,
  [263] = 112,
  [264] = 264,
  [265] = 119,
  [266] = 119,
  [267] = 115,
  [268] = 114,
  [269] = 114,
  [270] = 119,
  [271] = 271,
  [272] = 114,
  [273] = 113,
  [274] = 129,
  [275] = 97,
  [276] = 102,
  [277] = 99,
  [278] = 112,
  [279] = 106,
  [280] = 103,
  [281] = 103,
  [282] = 127,
  [283] = 283,
  [284] = 102,
  [285] = 106,
  [286] = 112,
  [287] = 96,
  [288] = 288,
  [289] = 288,
  [290] = 288,
  [291] = 291,
  [292] = 288,
  [293] = 99,
  [294] = 288,
  [295] = 128,
  [296] = 296,
  [297] = 96,
  [298] = 97,
  [299] = 299,
  [300] = 112,
  [301] = 110,
  [302] = 108,
  [303] = 303,
  [304] = 304,
  [305] = 128,
  [306] = 306,
  [307] = 112,
  [308] = 308,
  [309] = 299,
  [310] = 299,
  [311] = 299,
  [312] = 299,
  [313] = 313,
  [314] = 299,
  [315] = 315,
  [316] = 316,
  [317] = 317,
  [318] = 318,
  [319] = 319,
  [320] = 320,
  [321] = 321,
  [322] = 322,
  [323] = 320,
  [324] = 324,
  [325] = 325,
  [326] = 326,
  [327] = 327,
  [328] = 315,
  [329] = 329,
  [330] = 330,
  [331] = 329,
  [332] = 332,
  [333] = 333,
  [334] = 334,
  [335] = 335,
  [336] = 336,
  [337] = 337,
  [338] = 338,
  [339] = 339,
  [340] = 317,
  [341] = 341,
  [342] = 341,
  [343] = 343,
  [344] = 344,
  [345] = 344,
  [346] = 82,
  [347] = 347,
  [348] = 348,
  [349] = 348,
  [350] = 82,
  [351] = 348,
  [352] = 348,
  [353] = 348,
  [354] = 348,
  [355] = 98,
  [356] = 92,
  [357] = 78,
  [358] = 90,
  [359] = 96,
  [360] = 100,
  [361] = 103,
  [362] = 99,
  [363] = 77,
  [364] = 258,
  [365] = 80,
  [366] = 87,
  [367] = 86,
  [368] = 85,
  [369] = 98,
  [370] = 93,
  [371] = 76,
  [372] = 88,
  [373] = 84,
  [374] = 106,
  [375] = 97,
  [376] = 91,
  [377] = 259,
  [378] = 94,
  [379] = 81,
  [380] = 89,
  [381] = 102,
  [382] = 95,
  [383] = 102,
  [384] = 106,
  [385] = 103,
  [386] = 262,
  [387] = 106,
  [388] = 103,
  [389] = 102,
  [390] = 112,
  [391] = 283,
  [392] = 109,
  [393] = 96,
  [394] = 103,
  [395] = 117,
  [396] = 102,
  [397] = 106,
  [398] = 296,
  [399] = 112,
  [400] = 119,
  [401] = 291,
  [402] = 115,
  [403] = 110,
  [404] = 97,
  [405] = 99,
  [406] = 127,
  [407] = 116,
  [408] = 95,
  [409] = 108,
  [410] = 112,
  [411] = 114,
  [412] = 113,
  [413] = 114,
  [414] = 103,
  [415] = 115,
  [416] = 122,
  [417] = 417,
  [418] = 103,
  [419] = 102,
  [420] = 109,
  [421] = 92,
  [422] = 92,
  [423] = 106,
  [424] = 102,
  [425] = 425,
  [426] = 425,
  [427] = 120,
  [428] = 428,
  [429] = 429,
  [430] = 110,
  [431] = 304,
  [432] = 313,
  [433] = 129,
  [434] = 117,
  [435] = 119,
  [436] = 120,
  [437] = 108,
  [438] = 308,
  [439] = 106,
  [440] = 122,
  [441] = 417,
  [442] = 442,
  [443] = 135,
  [444] = 109,
  [445] = 306,
  [446] = 428,
  [447] = 329,
  [448] = 315,
  [449] = 136,
  [450] = 100,
  [451] = 451,
  [452] = 429,
  [453] = 127,
  [454] = 126,
  [455] = 78,
  [456] = 94,
  [457] = 137,
  [458] = 80,
  [459] = 96,
  [460] = 138,
  [461] = 461,
  [462] = 76,
  [463] = 81,
  [464] = 95,
  [465] = 78,
  [466] = 134,
  [467] = 85,
  [468] = 125,
  [469] = 112,
  [470] = 99,
  [471] = 86,
  [472] = 87,
  [473] = 337,
  [474] = 97,
  [475] = 131,
  [476] = 96,
  [477] = 116,
  [478] = 322,
  [479] = 77,
  [480] = 85,
  [481] = 114,
  [482] = 130,
  [483] = 339,
  [484] = 321,
  [485] = 119,
  [486] = 316,
  [487] = 93,
  [488] = 89,
  [489] = 91,
  [490] = 95,
  [491] = 97,
  [492] = 88,
  [493] = 84,
  [494] = 84,
  [495] = 91,
  [496] = 89,
  [497] = 137,
  [498] = 135,
  [499] = 99,
  [500] = 93,
  [501] = 333,
  [502] = 77,
  [503] = 320,
  [504] = 132,
  [505] = 88,
  [506] = 116,
  [507] = 325,
  [508] = 336,
  [509] = 130,
  [510] = 319,
  [511] = 126,
  [512] = 90,
  [513] = 138,
  [514] = 317,
  [515] = 87,
  [516] = 86,
  [517] = 335,
  [518] = 99,
  [519] = 97,
  [520] = 520,
  [521] = 95,
  [522] = 96,
  [523] = 94,
  [524] = 128,
  [525] = 81,
  [526] = 332,
  [527] = 318,
  [528] = 132,
  [529] = 80,
  [530] = 326,
  [531] = 327,
  [532] = 129,
  [533] = 76,
  [534] = 324,
  [535] = 95,
  [536] = 338,
  [537] = 334,
  [538] = 330,
  [539] = 90,
  [540] = 100,
  [541] = 317,
  [542] = 320,
  [543] = 119,
  [544] = 544,
  [545] = 117,
  [546] = 546,
  [547] = 547,
  [548] = 548,
  [549] = 549,
  [550] = 544,
  [551] = 544,
  [552] = 552,
  [553] = 120,
  [554] = 110,
  [555] = 548,
  [556] = 556,
  [557] = 108,
  [558] = 552,
  [559] = 122,
  [560] = 546,
  [561] = 546,
  [562] = 548,
  [563] = 110,
  [564] = 549,
  [565] = 556,
  [566] = 549,
  [567] = 544,
  [568] = 546,
  [569] = 544,
  [570] = 556,
  [571] = 571,
  [572] = 552,
  [573] = 573,
  [574] = 114,
  [575] = 546,
  [576] = 549,
  [577] = 556,
  [578] = 556,
  [579] = 108,
  [580] = 548,
  [581] = 114,
  [582] = 119,
  [583] = 116,
  [584] = 549,
  [585] = 552,
  [586] = 573,
  [587] = 112,
  [588] = 117,
  [589] = 136,
  [590] = 546,
  [591] = 548,
  [592] = 112,
  [593] = 556,
  [594] = 549,
  [595] = 544,
  [596] = 122,
  [597] = 548,
  [598] = 544,
  [599] = 136,
  [600] = 556,
  [601] = 546,
  [602] = 552,
  [603] = 120,
  [604] = 131,
  [605] = 125,
  [606] = 126,
  [607] = 607,
  [608] = 607,
  [609] = 130,
  [610] = 132,
  [611] = 611,
  [612] = 134,
  [613] = 613,
  [614] = 135,
  [615] = 137,
  [616] = 137,
  [617] = 607,
  [618] = 125,
  [619] = 619,
  [620] = 131,
  [621] = 134,
  [622] = 622,
  [623] = 607,
  [624] = 128,
  [625] = 607,
  [626] = 607,
  [627] = 607,
  [628] = 138,
  [629] = 126,
  [630] = 138,
  [631] = 128,
  [632] = 130,
  [633] = 132,
  [634] = 135,
  [635] = 635,
  [636] = 636,
  [637] = 637,
  [638] = 637,
  [639] = 639,
  [640] = 637,
  [641] = 636,
  [642] = 637,
  [643] = 643,
  [644] = 639,
  [645] = 643,
  [646] = 646,
  [647] = 636,
  [648] = 636,
  [649] = 643,
  [650] = 650,
  [651] = 650,
  [652] = 650,
  [653] = 637,
  [654] = 639,
  [655] = 646,
  [656] = 656,
  [657] = 639,
  [658] = 636,
  [659] = 650,
  [660] = 643,
  [661] = 639,
  [662] = 650,
  [663] = 643,
  [664] = 639,
  [665] = 643,
  [666] = 666,
  [667] = 636,
  [668] = 639,
  [669] = 643,
  [670] = 102,
  [671] = 106,
  [672] = 103,
  [673] = 103,
  [674] = 102,
  [675] = 106,
  [676] = 112,
  [677] = 677,
  [678] = 112,
  [679] = 108,
  [680] = 110,
  [681] = 329,
  [682] = 682,
  [683] = 683,
  [684] = 683,
  [685] = 329,
  [686] = 315,
  [687] = 315,
  [688] = 688,
  [689] = 688,
  [690] = 688,
  [691] = 688,
  [692] = 92,
  [693] = 693,
  [694] = 688,
  [695] = 695,
  [696] = 696,
  [697] = 697,
  [698] = 695,
  [699] = 699,
  [700] = 700,
  [701] = 701,
  [702] = 702,
  [703] = 699,
  [704] = 699,
  [705] = 705,
  [706] = 706,
  [707] = 707,
  [708] = 708,
  [709] = 699,
  [710] = 697,
  [711] = 699,
  [712] = 702,
  [713] = 713,
  [714] = 714,
  [715] = 705,
  [716] = 695,
  [717] = 717,
  [718] = 701,
  [719] = 719,
  [720] = 707,
  [721] = 708,
  [722] = 708,
  [723] = 707,
  [724] = 702,
  [725] = 695,
  [726] = 726,
  [727] = 705,
  [728] = 728,
  [729] = 707,
  [730] = 708,
  [731] = 731,
  [732] = 732,
  [733] = 705,
  [734] = 734,
  [735] = 719,
  [736] = 736,
  [737] = 737,
  [738] = 708,
  [739] = 699,
  [740] = 740,
  [741] = 702,
  [742] = 701,
  [743] = 713,
  [744] = 744,
  [745] = 707,
  [746] = 702,
  [747] = 695,
  [748] = 701,
  [749] = 702,
  [750] = 740,
  [751] = 705,
  [752] = 752,
  [753] = 753,
  [754] = 705,
  [755] = 755,
  [756] = 756,
  [757] = 728,
  [758] = 701,
  [759] = 707,
  [760] = 708,
  [761] = 117,
  [762] = 695,
  [763] = 763,
  [764] = 764,
  [765] = 764,
  [766] = 766,
  [767] = 122,
  [768] = 764,
  [769] = 769,
  [770] = 770,
  [771] = 771,
  [772] = 764,
  [773] = 773,
  [774] = 774,
  [775] = 775,
  [776] = 771,
  [777] = 774,
  [778] = 778,
  [779] = 779,
  [780] = 780,
  [781] = 781,
  [782] = 782,
  [783] = 770,
  [784] = 771,
  [785] = 770,
  [786] = 778,
  [787] = 778,
  [788] = 764,
  [789] = 789,
  [790] = 771,
  [791] = 770,
  [792] = 778,
  [793] = 770,
  [794] = 794,
  [795] = 120,
  [796] = 771,
  [797] = 797,
  [798] = 778,
  [799] = 778,
  [800] = 770,
  [801] = 771,
  [802] = 802,
  [803] = 803,
  [804] = 804,
  [805] = 802,
  [806] = 806,
  [807] = 807,
  [808] = 808,
  [809] = 802,
  [810] = 803,
  [811] = 802,
  [812] = 802,
  [813] = 807,
  [814] = 808,
  [815] = 815,
  [816] = 816,
  [817] = 817,
  [818] = 818,
  [819] = 807,
  [820] = 808,
  [821] = 808,
  [822] = 802,
  [823] = 802,
  [824] = 802,
  [825] = 825,
  [826] = 803,
  [827] = 807,
  [828] = 808,
  [829] = 802,
  [830] = 802,
  [831] = 831,
  [832] = 832,
  [833] = 833,
  [834] = 807,
  [835] = 808,
  [836] = 802,
  [837] = 807,
  [838] = 808,
  [839] = 807,
  [840] = 840,
  [841] = 802,
  [842] = 842,
  [843] = 802,
  [844] = 806,
  [845] = 804,
  [846] = 808,
  [847] = 847,
  [848] = 807,
  [849] = 806,
  [850] = 850,
  [851] = 802,
  [852] = 840,
  [853] = 847,
  [854] = 806,
  [855] = 803,
  [856] = 803,
  [857] = 818,
  [858] = 833,
  [859] = 803,
  [860] = 860,
  [861] = 860,
  [862] = 806,
  [863] = 807,
  [864] = 802,
  [865] = 806,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(49);
      if (lookahead == '!') ADVANCE(29);
      if (lookahead == '"') ADVANCE(16);
      if (lookahead == '#') ADVANCE(41);
      if (lookahead == '%') ADVANCE(148);
      if (lookahead == '&') ADVANCE(23);
      if (lookahead == '\'') ADVANCE(24);
      if (lookahead == '(') ADVANCE(56);
      if (lookahead == ')') ADVANCE(58);
      if (lookahead == '*') ADVANCE(144);
      if (lookahead == '+') ADVANCE(135);
      if (lookahead == ',') ADVANCE(60);
      if (lookahead == '-') ADVANCE(139);
      if (lookahead == '.') ADVANCE(125);
      if (lookahead == '/') ADVANCE(146);
      if (lookahead == ':') ADVANCE(133);
      if (lookahead == ';') ADVANCE(55);
      if (lookahead == '<') ADVANCE(161);
      if (lookahead == '=') ADVANCE(131);
      if (lookahead == '>') ADVANCE(158);
      if (lookahead == '[') ADVANCE(126);
      if (lookahead == ']') ADVANCE(128);
      if (lookahead == '^') ADVANCE(74);
      if (lookahead == '`') ADVANCE(31);
      if (lookahead == 'a') ADVANCE(115);
      if (lookahead == 'e') ADVANCE(113);
      if (lookahead == '{') ADVANCE(106);
      if (lookahead == '|') ADVANCE(71);
      if (lookahead == '}') ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(123);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 1:
      if (lookahead == '!') ADVANCE(29);
      if (lookahead == '"') ADVANCE(16);
      if (lookahead == '#') ADVANCE(41);
      if (lookahead == '%') ADVANCE(148);
      if (lookahead == '&') ADVANCE(23);
      if (lookahead == '\'') ADVANCE(24);
      if (lookahead == '(') ADVANCE(56);
      if (lookahead == ')') ADVANCE(58);
      if (lookahead == '*') ADVANCE(144);
      if (lookahead == '+') ADVANCE(135);
      if (lookahead == ',') ADVANCE(60);
      if (lookahead == '-') ADVANCE(139);
      if (lookahead == '.') ADVANCE(125);
      if (lookahead == '/') ADVANCE(146);
      if (lookahead == ':') ADVANCE(133);
      if (lookahead == ';') ADVANCE(55);
      if (lookahead == '<') ADVANCE(161);
      if (lookahead == '=') ADVANCE(131);
      if (lookahead == '>') ADVANCE(158);
      if (lookahead == '[') ADVANCE(126);
      if (lookahead == ']') ADVANCE(128);
      if (lookahead == '^') ADVANCE(74);
      if (lookahead == '`') ADVANCE(31);
      if (lookahead == 'a') ADVANCE(118);
      if (lookahead == '{') ADVANCE(106);
      if (lookahead == '|') ADVANCE(71);
      if (lookahead == '}') ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(1)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(123);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 2:
      if (lookahead == '!') ADVANCE(29);
      if (lookahead == '#') ADVANCE(41);
      if (lookahead == '%') ADVANCE(148);
      if (lookahead == '&') ADVANCE(23);
      if (lookahead == '(') ADVANCE(56);
      if (lookahead == ')') ADVANCE(58);
      if (lookahead == '*') ADVANCE(144);
      if (lookahead == '+') ADVANCE(134);
      if (lookahead == '-') ADVANCE(142);
      if (lookahead == '/') ADVANCE(146);
      if (lookahead == ':') ADVANCE(133);
      if (lookahead == '<') ADVANCE(161);
      if (lookahead == '=') ADVANCE(30);
      if (lookahead == '>') ADVANCE(158);
      if (lookahead == 'a') ADVANCE(40);
      if (lookahead == '{') ADVANCE(106);
      if (lookahead == '|') ADVANCE(42);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(2)
      END_STATE();
    case 3:
      if (lookahead == '!') ADVANCE(29);
      if (lookahead == '#') ADVANCE(41);
      if (lookahead == '%') ADVANCE(148);
      if (lookahead == '&') ADVANCE(23);
      if (lookahead == '(') ADVANCE(56);
      if (lookahead == '*') ADVANCE(144);
      if (lookahead == '+') ADVANCE(137);
      if (lookahead == ',') ADVANCE(60);
      if (lookahead == '-') ADVANCE(141);
      if (lookahead == '/') ADVANCE(146);
      if (lookahead == ':') ADVANCE(133);
      if (lookahead == ';') ADVANCE(55);
      if (lookahead == '<') ADVANCE(161);
      if (lookahead == '=') ADVANCE(131);
      if (lookahead == '>') ADVANCE(158);
      if (lookahead == 'a') ADVANCE(118);
      if (lookahead == '|') ADVANCE(73);
      if (lookahead == '}') ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(3)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 4:
      if (lookahead == '!') ADVANCE(29);
      if (lookahead == '#') ADVANCE(41);
      if (lookahead == '%') ADVANCE(148);
      if (lookahead == '&') ADVANCE(23);
      if (lookahead == '(') ADVANCE(56);
      if (lookahead == '*') ADVANCE(144);
      if (lookahead == '+') ADVANCE(137);
      if (lookahead == '-') ADVANCE(141);
      if (lookahead == '/') ADVANCE(146);
      if (lookahead == ':') ADVANCE(133);
      if (lookahead == '<') ADVANCE(161);
      if (lookahead == '=') ADVANCE(131);
      if (lookahead == '>') ADVANCE(158);
      if (lookahead == 'a') ADVANCE(39);
      if (lookahead == '{') ADVANCE(106);
      if (lookahead == '|') ADVANCE(42);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(4)
      END_STATE();
    case 5:
      if (lookahead == '!') ADVANCE(84);
      if (lookahead == '"') ADVANCE(78);
      if (lookahead == '#') ADVANCE(77);
      if (lookahead == '%') ADVANCE(149);
      if (lookahead == '&') ADVANCE(79);
      if (lookahead == '\'') ADVANCE(80);
      if (lookahead == '(') ADVANCE(57);
      if (lookahead == ')') ADVANCE(59);
      if (lookahead == '*') ADVANCE(145);
      if (lookahead == '+') ADVANCE(136);
      if (lookahead == ',') ADVANCE(61);
      if (lookahead == '-') ADVANCE(140);
      if (lookahead == '.') ADVANCE(97);
      if (lookahead == '/') ADVANCE(147);
      if (lookahead == '<') ADVANCE(162);
      if (lookahead == '=') ADVANCE(85);
      if (lookahead == '>') ADVANCE(159);
      if (lookahead == '[') ADVANCE(127);
      if (lookahead == '^') ADVANCE(74);
      if (lookahead == '`') ADVANCE(86);
      if (lookahead == 'a') ADVANCE(92);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(26);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(5)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(82);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(98);
      if (lookahead != 0 &&
          lookahead != ';') ADVANCE(100);
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(84);
      if (lookahead == '"') ADVANCE(78);
      if (lookahead == '#') ADVANCE(77);
      if (lookahead == '%') ADVANCE(149);
      if (lookahead == '&') ADVANCE(79);
      if (lookahead == '\'') ADVANCE(80);
      if (lookahead == '(') ADVANCE(57);
      if (lookahead == '*') ADVANCE(145);
      if (lookahead == '+') ADVANCE(136);
      if (lookahead == ',') ADVANCE(61);
      if (lookahead == '-') ADVANCE(140);
      if (lookahead == '.') ADVANCE(97);
      if (lookahead == '/') ADVANCE(147);
      if (lookahead == ';') ADVANCE(55);
      if (lookahead == '<') ADVANCE(162);
      if (lookahead == '=') ADVANCE(85);
      if (lookahead == '>') ADVANCE(159);
      if (lookahead == '[') ADVANCE(127);
      if (lookahead == '`') ADVANCE(86);
      if (lookahead == 'a') ADVANCE(92);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(71);
      if (lookahead == '}') ADVANCE(109);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(6)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(82);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(98);
      if (lookahead != 0 &&
          lookahead != '^') ADVANCE(100);
      END_STATE();
    case 7:
      if (lookahead == '!') ADVANCE(84);
      if (lookahead == '"') ADVANCE(78);
      if (lookahead == '#') ADVANCE(77);
      if (lookahead == '%') ADVANCE(149);
      if (lookahead == '&') ADVANCE(79);
      if (lookahead == '\'') ADVANCE(80);
      if (lookahead == '(') ADVANCE(57);
      if (lookahead == '*') ADVANCE(145);
      if (lookahead == '+') ADVANCE(136);
      if (lookahead == ',') ADVANCE(61);
      if (lookahead == '-') ADVANCE(140);
      if (lookahead == '.') ADVANCE(97);
      if (lookahead == '/') ADVANCE(147);
      if (lookahead == '<') ADVANCE(162);
      if (lookahead == '=') ADVANCE(85);
      if (lookahead == '>') ADVANCE(159);
      if (lookahead == '[') ADVANCE(127);
      if (lookahead == ']') ADVANCE(129);
      if (lookahead == '^') ADVANCE(74);
      if (lookahead == '`') ADVANCE(86);
      if (lookahead == 'a') ADVANCE(92);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(26);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(7)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(82);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(98);
      if (lookahead != 0 &&
          lookahead != ';') ADVANCE(100);
      END_STATE();
    case 8:
      if (lookahead == '!') ADVANCE(84);
      if (lookahead == '"') ADVANCE(78);
      if (lookahead == '#') ADVANCE(77);
      if (lookahead == '%') ADVANCE(149);
      if (lookahead == '&') ADVANCE(79);
      if (lookahead == '\'') ADVANCE(80);
      if (lookahead == '(') ADVANCE(57);
      if (lookahead == '*') ADVANCE(145);
      if (lookahead == '+') ADVANCE(136);
      if (lookahead == '-') ADVANCE(140);
      if (lookahead == '.') ADVANCE(97);
      if (lookahead == '/') ADVANCE(147);
      if (lookahead == ';') ADVANCE(55);
      if (lookahead == '<') ADVANCE(162);
      if (lookahead == '=') ADVANCE(85);
      if (lookahead == '>') ADVANCE(159);
      if (lookahead == '[') ADVANCE(127);
      if (lookahead == '^') ADVANCE(74);
      if (lookahead == '`') ADVANCE(86);
      if (lookahead == 'a') ADVANCE(91);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(71);
      if (lookahead == '}') ADVANCE(109);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(8)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(82);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(98);
      if (lookahead != 0) ADVANCE(100);
      END_STATE();
    case 9:
      if (lookahead == '!') ADVANCE(84);
      if (lookahead == '"') ADVANCE(78);
      if (lookahead == '#') ADVANCE(77);
      if (lookahead == '%') ADVANCE(149);
      if (lookahead == '&') ADVANCE(79);
      if (lookahead == '\'') ADVANCE(80);
      if (lookahead == ')') ADVANCE(59);
      if (lookahead == '*') ADVANCE(145);
      if (lookahead == '+') ADVANCE(138);
      if (lookahead == '-') ADVANCE(143);
      if (lookahead == '/') ADVANCE(147);
      if (lookahead == '<') ADVANCE(162);
      if (lookahead == '=') ADVANCE(85);
      if (lookahead == '>') ADVANCE(159);
      if (lookahead == '`') ADVANCE(86);
      if (lookahead == 'a') ADVANCE(95);
      if (lookahead == '|') ADVANCE(42);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(9)
      if (lookahead != 0 &&
          lookahead != ';' &&
          lookahead != '^') ADVANCE(100);
      END_STATE();
    case 10:
      if (lookahead == '!') ADVANCE(84);
      if (lookahead == '"') ADVANCE(78);
      if (lookahead == '#') ADVANCE(77);
      if (lookahead == '%') ADVANCE(149);
      if (lookahead == '&') ADVANCE(79);
      if (lookahead == '\'') ADVANCE(80);
      if (lookahead == '*') ADVANCE(145);
      if (lookahead == '+') ADVANCE(138);
      if (lookahead == ',') ADVANCE(61);
      if (lookahead == '-') ADVANCE(143);
      if (lookahead == '/') ADVANCE(147);
      if (lookahead == ';') ADVANCE(55);
      if (lookahead == '<') ADVANCE(162);
      if (lookahead == '=') ADVANCE(85);
      if (lookahead == '>') ADVANCE(159);
      if (lookahead == '`') ADVANCE(86);
      if (lookahead == 'a') ADVANCE(92);
      if (lookahead == '|') ADVANCE(73);
      if (lookahead == '}') ADVANCE(109);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(10)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(98);
      if (lookahead != 0 &&
          lookahead != '^') ADVANCE(100);
      END_STATE();
    case 11:
      if (lookahead == '!') ADVANCE(84);
      if (lookahead == '"') ADVANCE(78);
      if (lookahead == '#') ADVANCE(77);
      if (lookahead == '%') ADVANCE(149);
      if (lookahead == '&') ADVANCE(79);
      if (lookahead == '\'') ADVANCE(80);
      if (lookahead == '*') ADVANCE(145);
      if (lookahead == '+') ADVANCE(138);
      if (lookahead == '-') ADVANCE(143);
      if (lookahead == '/') ADVANCE(147);
      if (lookahead == ';') ADVANCE(55);
      if (lookahead == '<') ADVANCE(162);
      if (lookahead == '=') ADVANCE(85);
      if (lookahead == '>') ADVANCE(159);
      if (lookahead == '`') ADVANCE(86);
      if (lookahead == 'a') ADVANCE(92);
      if (lookahead == '|') ADVANCE(73);
      if (lookahead == '}') ADVANCE(109);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(11)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(98);
      if (lookahead != 0 &&
          lookahead != '^') ADVANCE(100);
      END_STATE();
    case 12:
      if (lookahead == '!') ADVANCE(84);
      if (lookahead == '"') ADVANCE(78);
      if (lookahead == '#') ADVANCE(77);
      if (lookahead == '%') ADVANCE(149);
      if (lookahead == '&') ADVANCE(79);
      if (lookahead == '\'') ADVANCE(80);
      if (lookahead == '*') ADVANCE(145);
      if (lookahead == '+') ADVANCE(138);
      if (lookahead == '-') ADVANCE(143);
      if (lookahead == '/') ADVANCE(147);
      if (lookahead == '<') ADVANCE(162);
      if (lookahead == '=') ADVANCE(85);
      if (lookahead == '>') ADVANCE(159);
      if (lookahead == '`') ADVANCE(86);
      if (lookahead == 'a') ADVANCE(94);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(42);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(12)
      if (lookahead != 0 &&
          lookahead != ';' &&
          lookahead != '^') ADVANCE(100);
      END_STATE();
    case 13:
      if (lookahead == '!') ADVANCE(84);
      if (lookahead == '"') ADVANCE(78);
      if (lookahead == '#') ADVANCE(77);
      if (lookahead == '%') ADVANCE(149);
      if (lookahead == '&') ADVANCE(79);
      if (lookahead == '\'') ADVANCE(80);
      if (lookahead == '*') ADVANCE(145);
      if (lookahead == '+') ADVANCE(138);
      if (lookahead == '-') ADVANCE(143);
      if (lookahead == '/') ADVANCE(147);
      if (lookahead == '<') ADVANCE(162);
      if (lookahead == '=') ADVANCE(85);
      if (lookahead == '>') ADVANCE(159);
      if (lookahead == '`') ADVANCE(86);
      if (lookahead == 'a') ADVANCE(95);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(42);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(13)
      if (lookahead != 0 &&
          lookahead != ';' &&
          lookahead != '^') ADVANCE(100);
      END_STATE();
    case 14:
      if (lookahead == '"') ADVANCE(16);
      if (lookahead == '#') ADVANCE(41);
      if (lookahead == '\'') ADVANCE(24);
      if (lookahead == '(') ADVANCE(56);
      if (lookahead == ')') ADVANCE(58);
      if (lookahead == '*') ADVANCE(144);
      if (lookahead == '+') ADVANCE(27);
      if (lookahead == ',') ADVANCE(60);
      if (lookahead == '-') ADVANCE(25);
      if (lookahead == '.') ADVANCE(125);
      if (lookahead == ';') ADVANCE(55);
      if (lookahead == '<') ADVANCE(160);
      if (lookahead == '=') ADVANCE(130);
      if (lookahead == '>') ADVANCE(157);
      if (lookahead == '[') ADVANCE(126);
      if (lookahead == ']') ADVANCE(128);
      if (lookahead == '^') ADVANCE(74);
      if (lookahead == '`') ADVANCE(31);
      if (lookahead == '{') ADVANCE(106);
      if (lookahead == '|') ADVANCE(72);
      if (lookahead == '}') ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(14)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(123);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 15:
      if (lookahead == '"') ADVANCE(16);
      if (lookahead == '#') ADVANCE(41);
      if (lookahead == '\'') ADVANCE(24);
      if (lookahead == '(') ADVANCE(56);
      if (lookahead == '*') ADVANCE(144);
      if (lookahead == ',') ADVANCE(60);
      if (lookahead == '-') ADVANCE(28);
      if (lookahead == '.') ADVANCE(125);
      if (lookahead == ';') ADVANCE(55);
      if (lookahead == '[') ADVANCE(126);
      if (lookahead == '`') ADVANCE(31);
      if (lookahead == 'e') ADVANCE(113);
      if (lookahead == '{') ADVANCE(106);
      if (lookahead == '}') ADVANCE(108);
      if (lookahead == '+' ||
          lookahead == '|') ADVANCE(27);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(15)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(123);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 16:
      if (lookahead == '"') ADVANCE(101);
      if (lookahead != 0) ADVANCE(16);
      END_STATE();
    case 17:
      if (lookahead == '"') ADVANCE(78);
      if (lookahead == '#') ADVANCE(77);
      if (lookahead == '\'') ADVANCE(80);
      if (lookahead == '(') ADVANCE(57);
      if (lookahead == '*') ADVANCE(145);
      if (lookahead == '+') ADVANCE(81);
      if (lookahead == ',') ADVANCE(61);
      if (lookahead == '-') ADVANCE(81);
      if (lookahead == '.') ADVANCE(97);
      if (lookahead == ';') ADVANCE(55);
      if (lookahead == '[') ADVANCE(127);
      if (lookahead == '`') ADVANCE(86);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(72);
      if (lookahead == '}') ADVANCE(109);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(17)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(82);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(98);
      if (lookahead != 0 &&
          lookahead != '^') ADVANCE(100);
      END_STATE();
    case 18:
      if (lookahead == '"') ADVANCE(78);
      if (lookahead == '#') ADVANCE(77);
      if (lookahead == '\'') ADVANCE(80);
      if (lookahead == '(') ADVANCE(57);
      if (lookahead == '+') ADVANCE(81);
      if (lookahead == '-') ADVANCE(81);
      if (lookahead == '.') ADVANCE(97);
      if (lookahead == ';') ADVANCE(55);
      if (lookahead == '[') ADVANCE(127);
      if (lookahead == '^') ADVANCE(74);
      if (lookahead == '`') ADVANCE(86);
      if (lookahead == 'a') ADVANCE(93);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(72);
      if (lookahead == '}') ADVANCE(109);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(18)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(82);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(98);
      if (lookahead != 0) ADVANCE(100);
      END_STATE();
    case 19:
      if (lookahead == '"') ADVANCE(78);
      if (lookahead == '#') ADVANCE(77);
      if (lookahead == '\'') ADVANCE(80);
      if (lookahead == ',') ADVANCE(61);
      if (lookahead == ';') ADVANCE(55);
      if (lookahead == '`') ADVANCE(86);
      if (lookahead == '|') ADVANCE(70);
      if (lookahead == '}') ADVANCE(109);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(19)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(98);
      if (lookahead != 0 &&
          lookahead != '^') ADVANCE(100);
      END_STATE();
    case 20:
      if (lookahead == '"') ADVANCE(78);
      if (lookahead == '#') ADVANCE(77);
      if (lookahead == '\'') ADVANCE(80);
      if (lookahead == ';') ADVANCE(55);
      if (lookahead == '`') ADVANCE(86);
      if (lookahead == '|') ADVANCE(70);
      if (lookahead == '}') ADVANCE(109);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(20)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(98);
      if (lookahead != 0 &&
          lookahead != '^') ADVANCE(100);
      END_STATE();
    case 21:
      if (lookahead == '#') ADVANCE(41);
      if (lookahead == '(') ADVANCE(56);
      if (lookahead == ',') ADVANCE(60);
      if (lookahead == ';') ADVANCE(55);
      if (lookahead == '|') ADVANCE(70);
      if (lookahead == '}') ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(21)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 22:
      if (lookahead == '#') ADVANCE(75);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(22)
      if (lookahead != 0 &&
          lookahead != ';') ADVANCE(76);
      END_STATE();
    case 23:
      if (lookahead == '&') ADVANCE(154);
      END_STATE();
    case 24:
      if (lookahead == '\'') ADVANCE(101);
      if (lookahead != 0) ADVANCE(24);
      END_STATE();
    case 25:
      if (lookahead == '.') ADVANCE(125);
      if (lookahead == '>') ADVANCE(170);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(122);
      END_STATE();
    case 26:
      if (lookahead == '.') ADVANCE(125);
      if (lookahead == '|') ADVANCE(156);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(27);
      END_STATE();
    case 27:
      if (lookahead == '.') ADVANCE(125);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(27);
      END_STATE();
    case 28:
      if (lookahead == '.') ADVANCE(125);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(122);
      END_STATE();
    case 29:
      if (lookahead == '=') ADVANCE(152);
      END_STATE();
    case 30:
      if (lookahead == '=') ADVANCE(150);
      END_STATE();
    case 31:
      if (lookahead == '`') ADVANCE(101);
      if (lookahead != 0) ADVANCE(31);
      END_STATE();
    case 32:
      if (lookahead == 'c') ADVANCE(102);
      END_STATE();
    case 33:
      if (lookahead == 'f') ADVANCE(37);
      END_STATE();
    case 34:
      if (lookahead == 'f') ADVANCE(169);
      END_STATE();
    case 35:
      if (lookahead == 'i') ADVANCE(34);
      END_STATE();
    case 36:
      if (lookahead == 'n') ADVANCE(32);
      END_STATE();
    case 37:
      if (lookahead == 'o') ADVANCE(38);
      END_STATE();
    case 38:
      if (lookahead == 'r') ADVANCE(172);
      END_STATE();
    case 39:
      if (lookahead == 's') ADVANCE(66);
      END_STATE();
    case 40:
      if (lookahead == 's') ADVANCE(62);
      END_STATE();
    case 41:
      if (lookahead == '|') ADVANCE(52);
      if (lookahead == '\n' ||
          lookahead == '#') ADVANCE(50);
      if (lookahead != 0) ADVANCE(41);
      END_STATE();
    case 42:
      if (lookahead == '|') ADVANCE(156);
      END_STATE();
    case 43:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(121);
      END_STATE();
    case 44:
      if (eof) ADVANCE(49);
      if (lookahead == '!') ADVANCE(29);
      if (lookahead == '"') ADVANCE(16);
      if (lookahead == '#') ADVANCE(41);
      if (lookahead == '%') ADVANCE(148);
      if (lookahead == '&') ADVANCE(23);
      if (lookahead == '\'') ADVANCE(24);
      if (lookahead == '(') ADVANCE(56);
      if (lookahead == ')') ADVANCE(58);
      if (lookahead == '*') ADVANCE(144);
      if (lookahead == '+') ADVANCE(135);
      if (lookahead == '-') ADVANCE(139);
      if (lookahead == '.') ADVANCE(125);
      if (lookahead == '/') ADVANCE(146);
      if (lookahead == ':') ADVANCE(133);
      if (lookahead == ';') ADVANCE(55);
      if (lookahead == '<') ADVANCE(161);
      if (lookahead == '=') ADVANCE(131);
      if (lookahead == '>') ADVANCE(158);
      if (lookahead == '[') ADVANCE(126);
      if (lookahead == '^') ADVANCE(74);
      if (lookahead == '`') ADVANCE(31);
      if (lookahead == 'a') ADVANCE(115);
      if (lookahead == '{') ADVANCE(106);
      if (lookahead == '|') ADVANCE(71);
      if (lookahead == '}') ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(44)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(123);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 45:
      if (eof) ADVANCE(49);
      if (lookahead == '!') ADVANCE(84);
      if (lookahead == '"') ADVANCE(78);
      if (lookahead == '#') ADVANCE(77);
      if (lookahead == '%') ADVANCE(149);
      if (lookahead == '&') ADVANCE(79);
      if (lookahead == '\'') ADVANCE(80);
      if (lookahead == '(') ADVANCE(57);
      if (lookahead == '*') ADVANCE(145);
      if (lookahead == '+') ADVANCE(136);
      if (lookahead == '-') ADVANCE(140);
      if (lookahead == '.') ADVANCE(97);
      if (lookahead == '/') ADVANCE(147);
      if (lookahead == ';') ADVANCE(55);
      if (lookahead == '<') ADVANCE(162);
      if (lookahead == '=') ADVANCE(85);
      if (lookahead == '>') ADVANCE(159);
      if (lookahead == '[') ADVANCE(127);
      if (lookahead == '^') ADVANCE(74);
      if (lookahead == '`') ADVANCE(86);
      if (lookahead == 'a') ADVANCE(91);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(71);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(45)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(82);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(98);
      if (lookahead != 0) ADVANCE(100);
      END_STATE();
    case 46:
      if (eof) ADVANCE(49);
      if (lookahead == '"') ADVANCE(16);
      if (lookahead == '#') ADVANCE(41);
      if (lookahead == '\'') ADVANCE(24);
      if (lookahead == '(') ADVANCE(56);
      if (lookahead == ')') ADVANCE(58);
      if (lookahead == '+') ADVANCE(27);
      if (lookahead == '-') ADVANCE(25);
      if (lookahead == '.') ADVANCE(125);
      if (lookahead == ':') ADVANCE(132);
      if (lookahead == ';') ADVANCE(55);
      if (lookahead == '<') ADVANCE(160);
      if (lookahead == '>') ADVANCE(157);
      if (lookahead == '[') ADVANCE(126);
      if (lookahead == '^') ADVANCE(74);
      if (lookahead == '`') ADVANCE(31);
      if (lookahead == 'a') ADVANCE(117);
      if (lookahead == '{') ADVANCE(106);
      if (lookahead == '|') ADVANCE(72);
      if (lookahead == '}') ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(46)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(123);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 47:
      if (eof) ADVANCE(49);
      if (lookahead == '"') ADVANCE(16);
      if (lookahead == '#') ADVANCE(41);
      if (lookahead == '\'') ADVANCE(24);
      if (lookahead == '(') ADVANCE(56);
      if (lookahead == '-') ADVANCE(28);
      if (lookahead == '.') ADVANCE(125);
      if (lookahead == ';') ADVANCE(55);
      if (lookahead == '[') ADVANCE(126);
      if (lookahead == '^') ADVANCE(74);
      if (lookahead == '`') ADVANCE(31);
      if (lookahead == 'a') ADVANCE(117);
      if (lookahead == 'e') ADVANCE(113);
      if (lookahead == '{') ADVANCE(106);
      if (lookahead == '}') ADVANCE(108);
      if (lookahead == '+' ||
          lookahead == '|') ADVANCE(27);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(47)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(123);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 48:
      if (eof) ADVANCE(49);
      if (lookahead == '"') ADVANCE(78);
      if (lookahead == '#') ADVANCE(77);
      if (lookahead == '\'') ADVANCE(80);
      if (lookahead == '(') ADVANCE(57);
      if (lookahead == '+') ADVANCE(81);
      if (lookahead == '-') ADVANCE(81);
      if (lookahead == '.') ADVANCE(97);
      if (lookahead == ';') ADVANCE(55);
      if (lookahead == '[') ADVANCE(127);
      if (lookahead == '^') ADVANCE(74);
      if (lookahead == '`') ADVANCE(86);
      if (lookahead == 'a') ADVANCE(93);
      if (lookahead == '{') ADVANCE(107);
      if (lookahead == '|') ADVANCE(72);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(48)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(82);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(98);
      if (lookahead != 0) ADVANCE(100);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(sym__comment);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(sym__comment);
      if (lookahead == '\n') ADVANCE(50);
      if (lookahead == '#') ADVANCE(54);
      if (lookahead == '|') ADVANCE(51);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == ';') ADVANCE(41);
      if (lookahead != 0) ADVANCE(75);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(sym__comment);
      if (lookahead == '|') ADVANCE(52);
      if (lookahead == '\n' ||
          lookahead == '#') ADVANCE(50);
      if (lookahead != 0) ADVANCE(41);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(sym__comment);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(sym__comment);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';') ADVANCE(76);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_COMMA);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_as);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 'y') ADVANCE(114);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(120);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 'y') ADVANCE(89);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(98);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(98);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 'y') ADVANCE(90);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 'y') ADVANCE(36);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_as);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(120);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_as);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(98);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(98);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '.') ADVANCE(125);
      if (lookahead == '|') ADVANCE(156);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(27);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '.') ADVANCE(125);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(27);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(156);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(sym_command_text);
      if (lookahead == '\n') ADVANCE(50);
      if (lookahead == '#') ADVANCE(54);
      if (lookahead == '|') ADVANCE(51);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == ';') ADVANCE(41);
      if (lookahead != 0) ADVANCE(75);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(sym_command_text);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';') ADVANCE(76);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(aux_sym_command_argument_token1);
      if (lookahead == '\n') ADVANCE(50);
      if (lookahead == '#') ADVANCE(53);
      if (lookahead == '|') ADVANCE(52);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == '^') ADVANCE(41);
      if (lookahead != 0) ADVANCE(77);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(aux_sym_command_argument_token1);
      if (lookahead == '"') ADVANCE(100);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == '^' ||
          lookahead == '|') ADVANCE(16);
      if (lookahead != 0) ADVANCE(78);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(aux_sym_command_argument_token1);
      if (lookahead == '&') ADVANCE(155);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(aux_sym_command_argument_token1);
      if (lookahead == '\'') ADVANCE(100);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == '^' ||
          lookahead == '|') ADVANCE(24);
      if (lookahead != 0) ADVANCE(80);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(aux_sym_command_argument_token1);
      if (lookahead == '.') ADVANCE(97);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(81);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(aux_sym_command_argument_token1);
      if (lookahead == '.') ADVANCE(83);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(82);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(aux_sym_command_argument_token1);
      if (lookahead == '.') ADVANCE(99);
      if (lookahead == '|') ADVANCE(125);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == 'e') ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^') ADVANCE(100);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(aux_sym_command_argument_token1);
      if (lookahead == '=') ADVANCE(153);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(aux_sym_command_argument_token1);
      if (lookahead == '=') ADVANCE(151);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(aux_sym_command_argument_token1);
      if (lookahead == '`') ADVANCE(100);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == ';' ||
          lookahead == '^' ||
          lookahead == '|') ADVANCE(31);
      if (lookahead != 0) ADVANCE(86);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(aux_sym_command_argument_token1);
      if (lookahead == 'c') ADVANCE(104);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(98);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(98);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(aux_sym_command_argument_token1);
      if (lookahead == 'c') ADVANCE(105);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(aux_sym_command_argument_token1);
      if (lookahead == 'n') ADVANCE(87);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(98);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(98);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(aux_sym_command_argument_token1);
      if (lookahead == 'n') ADVANCE(88);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(aux_sym_command_argument_token1);
      if (lookahead == 's') ADVANCE(64);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(98);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(98);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(aux_sym_command_argument_token1);
      if (lookahead == 's') ADVANCE(68);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(98);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(98);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(aux_sym_command_argument_token1);
      if (lookahead == 's') ADVANCE(96);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(98);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(98);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(aux_sym_command_argument_token1);
      if (lookahead == 's') ADVANCE(65);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(aux_sym_command_argument_token1);
      if (lookahead == 's') ADVANCE(69);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(aux_sym_command_argument_token1);
      if (lookahead == 'y') ADVANCE(89);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(98);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(98);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(aux_sym_command_argument_token1);
      if (lookahead == '|') ADVANCE(125);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == 'e') ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^') ADVANCE(100);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(aux_sym_command_argument_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(98);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(98);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(aux_sym_command_argument_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(99);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(aux_sym_command_argument_token1);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(aux_sym_command_argument_token2);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_async);
      if (lookahead == ' ') ADVANCE(33);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(120);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_async);
      if (lookahead == ' ') ADVANCE(33);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(98);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(98);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_async);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == ' ') ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(120);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c') ADVANCE(103);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(120);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(110);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(120);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(116);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(120);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(111);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(120);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(63);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(120);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(112);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(120);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(119);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(120);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(67);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(120);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'y') ADVANCE(114);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(120);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(120);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(sym_range);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(121);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(125);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(122);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(124);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(123);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(aux_sym_float_token1);
      if (lookahead == '.') ADVANCE(43);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == 'e' ||
          lookahead == '|') ADVANCE(125);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(aux_sym_float_token1);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == 'e' ||
          lookahead == '|') ADVANCE(125);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(150);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(171);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '.') ADVANCE(125);
      if (lookahead == '=') ADVANCE(167);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(27);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '.') ADVANCE(97);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(81);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(167);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '.') ADVANCE(125);
      if (lookahead == '=') ADVANCE(168);
      if (lookahead == '>') ADVANCE(170);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(122);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '.') ADVANCE(97);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(81);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(168);
      if (lookahead == '>') ADVANCE(170);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '>') ADVANCE(170);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(163);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(164);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=') ADVANCE(165);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=') ADVANCE(166);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != ';' &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(100);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_elseif);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_asyncfor);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'I') ADVANCE(1);
      if (lookahead == 'N') ADVANCE(2);
      if (lookahead == 'a') ADVANCE(3);
      if (lookahead == 'b') ADVANCE(4);
      if (lookahead == 'c') ADVANCE(5);
      if (lookahead == 'e') ADVANCE(6);
      if (lookahead == 'f') ADVANCE(7);
      if (lookahead == 'i') ADVANCE(8);
      if (lookahead == 'l') ADVANCE(9);
      if (lookahead == 'm') ADVANCE(10);
      if (lookahead == 'n') ADVANCE(11);
      if (lookahead == 'r') ADVANCE(12);
      if (lookahead == 's') ADVANCE(13);
      if (lookahead == 't') ADVANCE(14);
      if (lookahead == 'w') ADVANCE(15);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'n') ADVANCE(16);
      END_STATE();
    case 2:
      if (lookahead == 'a') ADVANCE(17);
      END_STATE();
    case 3:
      if (lookahead == 'n') ADVANCE(18);
      END_STATE();
    case 4:
      if (lookahead == 'o') ADVANCE(19);
      if (lookahead == 'r') ADVANCE(20);
      END_STATE();
    case 5:
      if (lookahead == 'o') ADVANCE(21);
      END_STATE();
    case 6:
      if (lookahead == 'l') ADVANCE(22);
      if (lookahead == 'n') ADVANCE(23);
      END_STATE();
    case 7:
      if (lookahead == 'a') ADVANCE(24);
      if (lookahead == 'l') ADVANCE(25);
      if (lookahead == 'o') ADVANCE(26);
      END_STATE();
    case 8:
      if (lookahead == 'f') ADVANCE(27);
      if (lookahead == 'n') ADVANCE(28);
      END_STATE();
    case 9:
      if (lookahead == 'i') ADVANCE(29);
      if (lookahead == 'o') ADVANCE(30);
      END_STATE();
    case 10:
      if (lookahead == 'a') ADVANCE(31);
      END_STATE();
    case 11:
      if (lookahead == 'a') ADVANCE(32);
      if (lookahead == 'o') ADVANCE(33);
      if (lookahead == 'u') ADVANCE(34);
      END_STATE();
    case 12:
      if (lookahead == 'e') ADVANCE(35);
      END_STATE();
    case 13:
      if (lookahead == 't') ADVANCE(36);
      END_STATE();
    case 14:
      if (lookahead == 'r') ADVANCE(37);
      END_STATE();
    case 15:
      if (lookahead == 'h') ADVANCE(38);
      END_STATE();
    case 16:
      if (lookahead == 'f') ADVANCE(39);
      END_STATE();
    case 17:
      if (lookahead == 'N') ADVANCE(40);
      END_STATE();
    case 18:
      if (lookahead == 'y') ADVANCE(41);
      END_STATE();
    case 19:
      if (lookahead == 'o') ADVANCE(42);
      END_STATE();
    case 20:
      if (lookahead == 'e') ADVANCE(43);
      END_STATE();
    case 21:
      if (lookahead == 'l') ADVANCE(44);
      END_STATE();
    case 22:
      if (lookahead == 's') ADVANCE(45);
      END_STATE();
    case 23:
      if (lookahead == 'u') ADVANCE(46);
      END_STATE();
    case 24:
      if (lookahead == 'l') ADVANCE(47);
      END_STATE();
    case 25:
      if (lookahead == 'o') ADVANCE(48);
      END_STATE();
    case 26:
      if (lookahead == 'r') ADVANCE(49);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 'f') ADVANCE(50);
      if (lookahead == 't') ADVANCE(51);
      END_STATE();
    case 29:
      if (lookahead == 's') ADVANCE(52);
      END_STATE();
    case 30:
      if (lookahead == 'o') ADVANCE(53);
      END_STATE();
    case 31:
      if (lookahead == 'p') ADVANCE(54);
      if (lookahead == 't') ADVANCE(55);
      END_STATE();
    case 32:
      if (lookahead == 'n') ADVANCE(56);
      END_STATE();
    case 33:
      if (lookahead == 'n') ADVANCE(57);
      END_STATE();
    case 34:
      if (lookahead == 'm') ADVANCE(58);
      END_STATE();
    case 35:
      if (lookahead == 't') ADVANCE(59);
      END_STATE();
    case 36:
      if (lookahead == 'r') ADVANCE(60);
      END_STATE();
    case 37:
      if (lookahead == 'u') ADVANCE(61);
      END_STATE();
    case 38:
      if (lookahead == 'i') ADVANCE(62);
      END_STATE();
    case 39:
      if (lookahead == 'i') ADVANCE(63);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_NaN);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_any);
      END_STATE();
    case 42:
      if (lookahead == 'l') ADVANCE(64);
      END_STATE();
    case 43:
      if (lookahead == 'a') ADVANCE(65);
      END_STATE();
    case 44:
      if (lookahead == 'l') ADVANCE(66);
      END_STATE();
    case 45:
      if (lookahead == 'e') ADVANCE(67);
      END_STATE();
    case 46:
      if (lookahead == 'm') ADVANCE(68);
      END_STATE();
    case 47:
      if (lookahead == 's') ADVANCE(69);
      END_STATE();
    case 48:
      if (lookahead == 'a') ADVANCE(70);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 50:
      if (lookahead == 'i') ADVANCE(71);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_int);
      END_STATE();
    case 52:
      if (lookahead == 't') ADVANCE(72);
      END_STATE();
    case 53:
      if (lookahead == 'p') ADVANCE(73);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_map);
      END_STATE();
    case 55:
      if (lookahead == 'c') ADVANCE(74);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_nan);
      END_STATE();
    case 57:
      if (lookahead == 'e') ADVANCE(75);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_num);
      END_STATE();
    case 59:
      if (lookahead == 'u') ADVANCE(76);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_str);
      if (lookahead == 'u') ADVANCE(77);
      END_STATE();
    case 61:
      if (lookahead == 'e') ADVANCE(78);
      END_STATE();
    case 62:
      if (lookahead == 'l') ADVANCE(79);
      END_STATE();
    case 63:
      if (lookahead == 'n') ADVANCE(80);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_bool);
      END_STATE();
    case 65:
      if (lookahead == 'k') ADVANCE(81);
      END_STATE();
    case 66:
      if (lookahead == 'e') ADVANCE(82);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 69:
      if (lookahead == 'e') ADVANCE(83);
      END_STATE();
    case 70:
      if (lookahead == 't') ADVANCE(84);
      END_STATE();
    case 71:
      if (lookahead == 'n') ADVANCE(85);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_list);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_loop);
      END_STATE();
    case 74:
      if (lookahead == 'h') ADVANCE(86);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_none);
      END_STATE();
    case 76:
      if (lookahead == 'r') ADVANCE(87);
      END_STATE();
    case 77:
      if (lookahead == 'c') ADVANCE(88);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 79:
      if (lookahead == 'e') ADVANCE(89);
      END_STATE();
    case 80:
      if (lookahead == 'i') ADVANCE(90);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 82:
      if (lookahead == 'c') ADVANCE(91);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_float);
      END_STATE();
    case 85:
      if (lookahead == 'i') ADVANCE(92);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_match);
      END_STATE();
    case 87:
      if (lookahead == 'n') ADVANCE(93);
      END_STATE();
    case 88:
      if (lookahead == 't') ADVANCE(94);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 90:
      if (lookahead == 't') ADVANCE(95);
      END_STATE();
    case 91:
      if (lookahead == 't') ADVANCE(96);
      END_STATE();
    case 92:
      if (lookahead == 't') ADVANCE(97);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 95:
      if (lookahead == 'y') ADVANCE(98);
      END_STATE();
    case 96:
      if (lookahead == 'i') ADVANCE(99);
      END_STATE();
    case 97:
      if (lookahead == 'y') ADVANCE(100);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_Infinity);
      END_STATE();
    case 99:
      if (lookahead == 'o') ADVANCE(101);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_infinity);
      END_STATE();
    case 101:
      if (lookahead == 'n') ADVANCE(102);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_collection);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 46},
  [2] = {.lex_state = 46},
  [3] = {.lex_state = 46},
  [4] = {.lex_state = 46},
  [5] = {.lex_state = 46},
  [6] = {.lex_state = 46},
  [7] = {.lex_state = 46},
  [8] = {.lex_state = 46},
  [9] = {.lex_state = 46},
  [10] = {.lex_state = 46},
  [11] = {.lex_state = 46},
  [12] = {.lex_state = 46},
  [13] = {.lex_state = 46},
  [14] = {.lex_state = 46},
  [15] = {.lex_state = 46},
  [16] = {.lex_state = 46},
  [17] = {.lex_state = 46},
  [18] = {.lex_state = 46},
  [19] = {.lex_state = 46},
  [20] = {.lex_state = 46},
  [21] = {.lex_state = 46},
  [22] = {.lex_state = 46},
  [23] = {.lex_state = 46},
  [24] = {.lex_state = 46},
  [25] = {.lex_state = 46},
  [26] = {.lex_state = 46},
  [27] = {.lex_state = 46},
  [28] = {.lex_state = 46},
  [29] = {.lex_state = 46},
  [30] = {.lex_state = 46},
  [31] = {.lex_state = 46},
  [32] = {.lex_state = 46},
  [33] = {.lex_state = 46},
  [34] = {.lex_state = 46},
  [35] = {.lex_state = 46},
  [36] = {.lex_state = 46},
  [37] = {.lex_state = 46},
  [38] = {.lex_state = 46},
  [39] = {.lex_state = 46},
  [40] = {.lex_state = 46},
  [41] = {.lex_state = 46},
  [42] = {.lex_state = 46},
  [43] = {.lex_state = 46},
  [44] = {.lex_state = 46},
  [45] = {.lex_state = 46},
  [46] = {.lex_state = 46},
  [47] = {.lex_state = 46},
  [48] = {.lex_state = 46},
  [49] = {.lex_state = 46},
  [50] = {.lex_state = 46},
  [51] = {.lex_state = 46},
  [52] = {.lex_state = 46},
  [53] = {.lex_state = 46},
  [54] = {.lex_state = 46},
  [55] = {.lex_state = 46},
  [56] = {.lex_state = 46},
  [57] = {.lex_state = 46},
  [58] = {.lex_state = 46},
  [59] = {.lex_state = 46},
  [60] = {.lex_state = 46},
  [61] = {.lex_state = 46},
  [62] = {.lex_state = 46},
  [63] = {.lex_state = 46},
  [64] = {.lex_state = 46},
  [65] = {.lex_state = 46},
  [66] = {.lex_state = 46},
  [67] = {.lex_state = 46},
  [68] = {.lex_state = 46},
  [69] = {.lex_state = 46},
  [70] = {.lex_state = 46},
  [71] = {.lex_state = 46},
  [72] = {.lex_state = 46},
  [73] = {.lex_state = 46},
  [74] = {.lex_state = 46},
  [75] = {.lex_state = 46},
  [76] = {.lex_state = 44},
  [77] = {.lex_state = 44},
  [78] = {.lex_state = 44},
  [79] = {.lex_state = 44},
  [80] = {.lex_state = 44},
  [81] = {.lex_state = 44},
  [82] = {.lex_state = 44},
  [83] = {.lex_state = 44},
  [84] = {.lex_state = 44},
  [85] = {.lex_state = 44},
  [86] = {.lex_state = 44},
  [87] = {.lex_state = 44},
  [88] = {.lex_state = 44},
  [89] = {.lex_state = 44},
  [90] = {.lex_state = 44},
  [91] = {.lex_state = 44},
  [92] = {.lex_state = 44},
  [93] = {.lex_state = 44},
  [94] = {.lex_state = 44},
  [95] = {.lex_state = 44},
  [96] = {.lex_state = 44},
  [97] = {.lex_state = 44},
  [98] = {.lex_state = 44},
  [99] = {.lex_state = 44},
  [100] = {.lex_state = 44},
  [101] = {.lex_state = 44},
  [102] = {.lex_state = 8},
  [103] = {.lex_state = 45},
  [104] = {.lex_state = 8},
  [105] = {.lex_state = 45},
  [106] = {.lex_state = 45},
  [107] = {.lex_state = 8},
  [108] = {.lex_state = 44},
  [109] = {.lex_state = 44},
  [110] = {.lex_state = 44},
  [111] = {.lex_state = 44},
  [112] = {.lex_state = 45},
  [113] = {.lex_state = 44},
  [114] = {.lex_state = 44},
  [115] = {.lex_state = 44},
  [116] = {.lex_state = 44},
  [117] = {.lex_state = 44},
  [118] = {.lex_state = 8},
  [119] = {.lex_state = 44},
  [120] = {.lex_state = 44},
  [121] = {.lex_state = 44},
  [122] = {.lex_state = 44},
  [123] = {.lex_state = 44},
  [124] = {.lex_state = 44},
  [125] = {.lex_state = 44},
  [126] = {.lex_state = 44},
  [127] = {.lex_state = 44},
  [128] = {.lex_state = 44},
  [129] = {.lex_state = 44},
  [130] = {.lex_state = 44},
  [131] = {.lex_state = 44},
  [132] = {.lex_state = 44},
  [133] = {.lex_state = 44},
  [134] = {.lex_state = 44},
  [135] = {.lex_state = 44},
  [136] = {.lex_state = 44},
  [137] = {.lex_state = 44},
  [138] = {.lex_state = 44},
  [139] = {.lex_state = 44},
  [140] = {.lex_state = 1},
  [141] = {.lex_state = 1},
  [142] = {.lex_state = 1},
  [143] = {.lex_state = 1},
  [144] = {.lex_state = 1},
  [145] = {.lex_state = 1},
  [146] = {.lex_state = 1},
  [147] = {.lex_state = 1},
  [148] = {.lex_state = 1},
  [149] = {.lex_state = 1},
  [150] = {.lex_state = 1},
  [151] = {.lex_state = 1},
  [152] = {.lex_state = 1},
  [153] = {.lex_state = 1},
  [154] = {.lex_state = 1},
  [155] = {.lex_state = 1},
  [156] = {.lex_state = 1},
  [157] = {.lex_state = 1},
  [158] = {.lex_state = 1},
  [159] = {.lex_state = 1},
  [160] = {.lex_state = 1},
  [161] = {.lex_state = 1},
  [162] = {.lex_state = 14},
  [163] = {.lex_state = 14},
  [164] = {.lex_state = 14},
  [165] = {.lex_state = 14},
  [166] = {.lex_state = 14},
  [167] = {.lex_state = 14},
  [168] = {.lex_state = 14},
  [169] = {.lex_state = 14},
  [170] = {.lex_state = 14},
  [171] = {.lex_state = 14},
  [172] = {.lex_state = 14},
  [173] = {.lex_state = 14},
  [174] = {.lex_state = 14},
  [175] = {.lex_state = 14},
  [176] = {.lex_state = 14},
  [177] = {.lex_state = 14},
  [178] = {.lex_state = 14},
  [179] = {.lex_state = 14},
  [180] = {.lex_state = 14},
  [181] = {.lex_state = 14},
  [182] = {.lex_state = 14},
  [183] = {.lex_state = 14},
  [184] = {.lex_state = 14},
  [185] = {.lex_state = 14},
  [186] = {.lex_state = 14},
  [187] = {.lex_state = 14},
  [188] = {.lex_state = 14},
  [189] = {.lex_state = 14},
  [190] = {.lex_state = 14},
  [191] = {.lex_state = 14},
  [192] = {.lex_state = 14},
  [193] = {.lex_state = 14},
  [194] = {.lex_state = 14},
  [195] = {.lex_state = 1},
  [196] = {.lex_state = 1},
  [197] = {.lex_state = 1},
  [198] = {.lex_state = 6},
  [199] = {.lex_state = 14},
  [200] = {.lex_state = 14},
  [201] = {.lex_state = 14},
  [202] = {.lex_state = 14},
  [203] = {.lex_state = 14},
  [204] = {.lex_state = 14},
  [205] = {.lex_state = 14},
  [206] = {.lex_state = 14},
  [207] = {.lex_state = 14},
  [208] = {.lex_state = 1},
  [209] = {.lex_state = 14},
  [210] = {.lex_state = 14},
  [211] = {.lex_state = 14},
  [212] = {.lex_state = 14},
  [213] = {.lex_state = 14},
  [214] = {.lex_state = 1},
  [215] = {.lex_state = 6},
  [216] = {.lex_state = 14},
  [217] = {.lex_state = 6},
  [218] = {.lex_state = 1},
  [219] = {.lex_state = 14},
  [220] = {.lex_state = 14},
  [221] = {.lex_state = 14},
  [222] = {.lex_state = 14},
  [223] = {.lex_state = 14},
  [224] = {.lex_state = 14},
  [225] = {.lex_state = 14},
  [226] = {.lex_state = 14},
  [227] = {.lex_state = 14},
  [228] = {.lex_state = 14},
  [229] = {.lex_state = 14},
  [230] = {.lex_state = 14},
  [231] = {.lex_state = 14},
  [232] = {.lex_state = 14},
  [233] = {.lex_state = 14},
  [234] = {.lex_state = 14},
  [235] = {.lex_state = 14},
  [236] = {.lex_state = 14},
  [237] = {.lex_state = 14},
  [238] = {.lex_state = 1},
  [239] = {.lex_state = 1},
  [240] = {.lex_state = 14},
  [241] = {.lex_state = 1},
  [242] = {.lex_state = 14},
  [243] = {.lex_state = 1},
  [244] = {.lex_state = 7},
  [245] = {.lex_state = 1},
  [246] = {.lex_state = 1},
  [247] = {.lex_state = 1},
  [248] = {.lex_state = 7},
  [249] = {.lex_state = 1},
  [250] = {.lex_state = 5},
  [251] = {.lex_state = 1},
  [252] = {.lex_state = 1},
  [253] = {.lex_state = 1},
  [254] = {.lex_state = 1},
  [255] = {.lex_state = 1},
  [256] = {.lex_state = 7},
  [257] = {.lex_state = 1},
  [258] = {.lex_state = 47},
  [259] = {.lex_state = 47},
  [260] = {.lex_state = 5},
  [261] = {.lex_state = 5},
  [262] = {.lex_state = 47},
  [263] = {.lex_state = 6},
  [264] = {.lex_state = 1},
  [265] = {.lex_state = 1},
  [266] = {.lex_state = 1},
  [267] = {.lex_state = 1},
  [268] = {.lex_state = 1},
  [269] = {.lex_state = 1},
  [270] = {.lex_state = 1},
  [271] = {.lex_state = 1},
  [272] = {.lex_state = 1},
  [273] = {.lex_state = 1},
  [274] = {.lex_state = 1},
  [275] = {.lex_state = 46},
  [276] = {.lex_state = 18},
  [277] = {.lex_state = 46},
  [278] = {.lex_state = 5},
  [279] = {.lex_state = 48},
  [280] = {.lex_state = 18},
  [281] = {.lex_state = 48},
  [282] = {.lex_state = 1},
  [283] = {.lex_state = 46},
  [284] = {.lex_state = 48},
  [285] = {.lex_state = 18},
  [286] = {.lex_state = 7},
  [287] = {.lex_state = 46},
  [288] = {.lex_state = 14},
  [289] = {.lex_state = 14},
  [290] = {.lex_state = 14},
  [291] = {.lex_state = 47},
  [292] = {.lex_state = 14},
  [293] = {.lex_state = 47},
  [294] = {.lex_state = 14},
  [295] = {.lex_state = 14},
  [296] = {.lex_state = 47},
  [297] = {.lex_state = 47},
  [298] = {.lex_state = 47},
  [299] = {.lex_state = 14},
  [300] = {.lex_state = 18},
  [301] = {.lex_state = 46},
  [302] = {.lex_state = 46},
  [303] = {.lex_state = 14},
  [304] = {.lex_state = 46},
  [305] = {.lex_state = 46},
  [306] = {.lex_state = 46},
  [307] = {.lex_state = 48},
  [308] = {.lex_state = 46},
  [309] = {.lex_state = 14},
  [310] = {.lex_state = 14},
  [311] = {.lex_state = 14},
  [312] = {.lex_state = 14},
  [313] = {.lex_state = 46},
  [314] = {.lex_state = 14},
  [315] = {.lex_state = 46},
  [316] = {.lex_state = 46},
  [317] = {.lex_state = 46},
  [318] = {.lex_state = 46},
  [319] = {.lex_state = 46},
  [320] = {.lex_state = 46},
  [321] = {.lex_state = 46},
  [322] = {.lex_state = 46},
  [323] = {.lex_state = 46},
  [324] = {.lex_state = 46},
  [325] = {.lex_state = 46},
  [326] = {.lex_state = 46},
  [327] = {.lex_state = 46},
  [328] = {.lex_state = 46},
  [329] = {.lex_state = 46},
  [330] = {.lex_state = 46},
  [331] = {.lex_state = 46},
  [332] = {.lex_state = 46},
  [333] = {.lex_state = 46},
  [334] = {.lex_state = 46},
  [335] = {.lex_state = 46},
  [336] = {.lex_state = 46},
  [337] = {.lex_state = 46},
  [338] = {.lex_state = 46},
  [339] = {.lex_state = 46},
  [340] = {.lex_state = 46},
  [341] = {.lex_state = 14},
  [342] = {.lex_state = 14},
  [343] = {.lex_state = 14},
  [344] = {.lex_state = 14},
  [345] = {.lex_state = 14},
  [346] = {.lex_state = 3},
  [347] = {.lex_state = 46},
  [348] = {.lex_state = 14},
  [349] = {.lex_state = 14},
  [350] = {.lex_state = 3},
  [351] = {.lex_state = 14},
  [352] = {.lex_state = 14},
  [353] = {.lex_state = 14},
  [354] = {.lex_state = 14},
  [355] = {.lex_state = 3},
  [356] = {.lex_state = 3},
  [357] = {.lex_state = 3},
  [358] = {.lex_state = 3},
  [359] = {.lex_state = 3},
  [360] = {.lex_state = 3},
  [361] = {.lex_state = 10},
  [362] = {.lex_state = 3},
  [363] = {.lex_state = 3},
  [364] = {.lex_state = 15},
  [365] = {.lex_state = 3},
  [366] = {.lex_state = 3},
  [367] = {.lex_state = 3},
  [368] = {.lex_state = 3},
  [369] = {.lex_state = 3},
  [370] = {.lex_state = 3},
  [371] = {.lex_state = 3},
  [372] = {.lex_state = 3},
  [373] = {.lex_state = 3},
  [374] = {.lex_state = 10},
  [375] = {.lex_state = 3},
  [376] = {.lex_state = 3},
  [377] = {.lex_state = 15},
  [378] = {.lex_state = 3},
  [379] = {.lex_state = 3},
  [380] = {.lex_state = 3},
  [381] = {.lex_state = 10},
  [382] = {.lex_state = 3},
  [383] = {.lex_state = 17},
  [384] = {.lex_state = 11},
  [385] = {.lex_state = 17},
  [386] = {.lex_state = 15},
  [387] = {.lex_state = 17},
  [388] = {.lex_state = 11},
  [389] = {.lex_state = 11},
  [390] = {.lex_state = 10},
  [391] = {.lex_state = 14},
  [392] = {.lex_state = 3},
  [393] = {.lex_state = 15},
  [394] = {.lex_state = 12},
  [395] = {.lex_state = 14},
  [396] = {.lex_state = 12},
  [397] = {.lex_state = 12},
  [398] = {.lex_state = 15},
  [399] = {.lex_state = 11},
  [400] = {.lex_state = 3},
  [401] = {.lex_state = 15},
  [402] = {.lex_state = 3},
  [403] = {.lex_state = 3},
  [404] = {.lex_state = 15},
  [405] = {.lex_state = 15},
  [406] = {.lex_state = 3},
  [407] = {.lex_state = 3},
  [408] = {.lex_state = 3},
  [409] = {.lex_state = 3},
  [410] = {.lex_state = 17},
  [411] = {.lex_state = 3},
  [412] = {.lex_state = 3},
  [413] = {.lex_state = 3},
  [414] = {.lex_state = 9},
  [415] = {.lex_state = 3},
  [416] = {.lex_state = 3},
  [417] = {.lex_state = 4},
  [418] = {.lex_state = 13},
  [419] = {.lex_state = 13},
  [420] = {.lex_state = 4},
  [421] = {.lex_state = 2},
  [422] = {.lex_state = 4},
  [423] = {.lex_state = 9},
  [424] = {.lex_state = 9},
  [425] = {.lex_state = 4},
  [426] = {.lex_state = 4},
  [427] = {.lex_state = 3},
  [428] = {.lex_state = 4},
  [429] = {.lex_state = 4},
  [430] = {.lex_state = 14},
  [431] = {.lex_state = 14},
  [432] = {.lex_state = 14},
  [433] = {.lex_state = 3},
  [434] = {.lex_state = 3},
  [435] = {.lex_state = 3},
  [436] = {.lex_state = 14},
  [437] = {.lex_state = 14},
  [438] = {.lex_state = 14},
  [439] = {.lex_state = 13},
  [440] = {.lex_state = 14},
  [441] = {.lex_state = 4},
  [442] = {.lex_state = 2},
  [443] = {.lex_state = 14},
  [444] = {.lex_state = 2},
  [445] = {.lex_state = 14},
  [446] = {.lex_state = 4},
  [447] = {.lex_state = 14},
  [448] = {.lex_state = 14},
  [449] = {.lex_state = 3},
  [450] = {.lex_state = 2},
  [451] = {.lex_state = 14},
  [452] = {.lex_state = 4},
  [453] = {.lex_state = 3},
  [454] = {.lex_state = 14},
  [455] = {.lex_state = 2},
  [456] = {.lex_state = 4},
  [457] = {.lex_state = 14},
  [458] = {.lex_state = 4},
  [459] = {.lex_state = 14},
  [460] = {.lex_state = 14},
  [461] = {.lex_state = 2},
  [462] = {.lex_state = 4},
  [463] = {.lex_state = 2},
  [464] = {.lex_state = 2},
  [465] = {.lex_state = 4},
  [466] = {.lex_state = 3},
  [467] = {.lex_state = 2},
  [468] = {.lex_state = 3},
  [469] = {.lex_state = 12},
  [470] = {.lex_state = 2},
  [471] = {.lex_state = 2},
  [472] = {.lex_state = 2},
  [473] = {.lex_state = 14},
  [474] = {.lex_state = 14},
  [475] = {.lex_state = 3},
  [476] = {.lex_state = 2},
  [477] = {.lex_state = 2},
  [478] = {.lex_state = 14},
  [479] = {.lex_state = 2},
  [480] = {.lex_state = 4},
  [481] = {.lex_state = 4},
  [482] = {.lex_state = 14},
  [483] = {.lex_state = 14},
  [484] = {.lex_state = 14},
  [485] = {.lex_state = 4},
  [486] = {.lex_state = 14},
  [487] = {.lex_state = 2},
  [488] = {.lex_state = 2},
  [489] = {.lex_state = 2},
  [490] = {.lex_state = 2},
  [491] = {.lex_state = 2},
  [492] = {.lex_state = 4},
  [493] = {.lex_state = 2},
  [494] = {.lex_state = 4},
  [495] = {.lex_state = 4},
  [496] = {.lex_state = 4},
  [497] = {.lex_state = 3},
  [498] = {.lex_state = 3},
  [499] = {.lex_state = 14},
  [500] = {.lex_state = 4},
  [501] = {.lex_state = 14},
  [502] = {.lex_state = 4},
  [503] = {.lex_state = 14},
  [504] = {.lex_state = 3},
  [505] = {.lex_state = 2},
  [506] = {.lex_state = 4},
  [507] = {.lex_state = 14},
  [508] = {.lex_state = 14},
  [509] = {.lex_state = 3},
  [510] = {.lex_state = 14},
  [511] = {.lex_state = 3},
  [512] = {.lex_state = 2},
  [513] = {.lex_state = 3},
  [514] = {.lex_state = 14},
  [515] = {.lex_state = 4},
  [516] = {.lex_state = 4},
  [517] = {.lex_state = 14},
  [518] = {.lex_state = 4},
  [519] = {.lex_state = 4},
  [520] = {.lex_state = 14},
  [521] = {.lex_state = 4},
  [522] = {.lex_state = 4},
  [523] = {.lex_state = 2},
  [524] = {.lex_state = 3},
  [525] = {.lex_state = 4},
  [526] = {.lex_state = 14},
  [527] = {.lex_state = 14},
  [528] = {.lex_state = 14},
  [529] = {.lex_state = 2},
  [530] = {.lex_state = 14},
  [531] = {.lex_state = 14},
  [532] = {.lex_state = 3},
  [533] = {.lex_state = 2},
  [534] = {.lex_state = 14},
  [535] = {.lex_state = 4},
  [536] = {.lex_state = 14},
  [537] = {.lex_state = 14},
  [538] = {.lex_state = 14},
  [539] = {.lex_state = 4},
  [540] = {.lex_state = 4},
  [541] = {.lex_state = 14},
  [542] = {.lex_state = 14},
  [543] = {.lex_state = 2},
  [544] = {.lex_state = 14},
  [545] = {.lex_state = 2},
  [546] = {.lex_state = 14},
  [547] = {.lex_state = 14},
  [548] = {.lex_state = 14},
  [549] = {.lex_state = 14},
  [550] = {.lex_state = 14},
  [551] = {.lex_state = 14},
  [552] = {.lex_state = 2},
  [553] = {.lex_state = 2},
  [554] = {.lex_state = 4},
  [555] = {.lex_state = 14},
  [556] = {.lex_state = 14},
  [557] = {.lex_state = 2},
  [558] = {.lex_state = 2},
  [559] = {.lex_state = 2},
  [560] = {.lex_state = 14},
  [561] = {.lex_state = 14},
  [562] = {.lex_state = 14},
  [563] = {.lex_state = 2},
  [564] = {.lex_state = 14},
  [565] = {.lex_state = 14},
  [566] = {.lex_state = 14},
  [567] = {.lex_state = 14},
  [568] = {.lex_state = 14},
  [569] = {.lex_state = 14},
  [570] = {.lex_state = 14},
  [571] = {.lex_state = 14},
  [572] = {.lex_state = 2},
  [573] = {.lex_state = 2},
  [574] = {.lex_state = 2},
  [575] = {.lex_state = 14},
  [576] = {.lex_state = 14},
  [577] = {.lex_state = 14},
  [578] = {.lex_state = 14},
  [579] = {.lex_state = 4},
  [580] = {.lex_state = 14},
  [581] = {.lex_state = 2},
  [582] = {.lex_state = 2},
  [583] = {.lex_state = 2},
  [584] = {.lex_state = 14},
  [585] = {.lex_state = 2},
  [586] = {.lex_state = 2},
  [587] = {.lex_state = 13},
  [588] = {.lex_state = 4},
  [589] = {.lex_state = 2},
  [590] = {.lex_state = 14},
  [591] = {.lex_state = 14},
  [592] = {.lex_state = 9},
  [593] = {.lex_state = 14},
  [594] = {.lex_state = 14},
  [595] = {.lex_state = 14},
  [596] = {.lex_state = 4},
  [597] = {.lex_state = 14},
  [598] = {.lex_state = 14},
  [599] = {.lex_state = 4},
  [600] = {.lex_state = 14},
  [601] = {.lex_state = 14},
  [602] = {.lex_state = 2},
  [603] = {.lex_state = 4},
  [604] = {.lex_state = 4},
  [605] = {.lex_state = 2},
  [606] = {.lex_state = 4},
  [607] = {.lex_state = 14},
  [608] = {.lex_state = 14},
  [609] = {.lex_state = 4},
  [610] = {.lex_state = 4},
  [611] = {.lex_state = 2},
  [612] = {.lex_state = 4},
  [613] = {.lex_state = 2},
  [614] = {.lex_state = 4},
  [615] = {.lex_state = 4},
  [616] = {.lex_state = 2},
  [617] = {.lex_state = 14},
  [618] = {.lex_state = 4},
  [619] = {.lex_state = 14},
  [620] = {.lex_state = 2},
  [621] = {.lex_state = 2},
  [622] = {.lex_state = 14},
  [623] = {.lex_state = 14},
  [624] = {.lex_state = 4},
  [625] = {.lex_state = 14},
  [626] = {.lex_state = 14},
  [627] = {.lex_state = 14},
  [628] = {.lex_state = 2},
  [629] = {.lex_state = 2},
  [630] = {.lex_state = 4},
  [631] = {.lex_state = 2},
  [632] = {.lex_state = 2},
  [633] = {.lex_state = 2},
  [634] = {.lex_state = 2},
  [635] = {.lex_state = 14},
  [636] = {.lex_state = 14},
  [637] = {.lex_state = 14},
  [638] = {.lex_state = 14},
  [639] = {.lex_state = 14},
  [640] = {.lex_state = 14},
  [641] = {.lex_state = 14},
  [642] = {.lex_state = 14},
  [643] = {.lex_state = 14},
  [644] = {.lex_state = 14},
  [645] = {.lex_state = 14},
  [646] = {.lex_state = 14},
  [647] = {.lex_state = 14},
  [648] = {.lex_state = 14},
  [649] = {.lex_state = 14},
  [650] = {.lex_state = 2},
  [651] = {.lex_state = 2},
  [652] = {.lex_state = 2},
  [653] = {.lex_state = 14},
  [654] = {.lex_state = 14},
  [655] = {.lex_state = 14},
  [656] = {.lex_state = 14},
  [657] = {.lex_state = 14},
  [658] = {.lex_state = 14},
  [659] = {.lex_state = 2},
  [660] = {.lex_state = 14},
  [661] = {.lex_state = 14},
  [662] = {.lex_state = 2},
  [663] = {.lex_state = 14},
  [664] = {.lex_state = 14},
  [665] = {.lex_state = 14},
  [666] = {.lex_state = 14},
  [667] = {.lex_state = 14},
  [668] = {.lex_state = 14},
  [669] = {.lex_state = 14},
  [670] = {.lex_state = 19},
  [671] = {.lex_state = 19},
  [672] = {.lex_state = 19},
  [673] = {.lex_state = 20},
  [674] = {.lex_state = 20},
  [675] = {.lex_state = 20},
  [676] = {.lex_state = 19},
  [677] = {.lex_state = 0},
  [678] = {.lex_state = 20},
  [679] = {.lex_state = 21},
  [680] = {.lex_state = 21},
  [681] = {.lex_state = 21},
  [682] = {.lex_state = 14},
  [683] = {.lex_state = 4},
  [684] = {.lex_state = 14},
  [685] = {.lex_state = 21},
  [686] = {.lex_state = 21},
  [687] = {.lex_state = 21},
  [688] = {.lex_state = 0},
  [689] = {.lex_state = 0},
  [690] = {.lex_state = 0},
  [691] = {.lex_state = 0},
  [692] = {.lex_state = 0},
  [693] = {.lex_state = 0},
  [694] = {.lex_state = 0},
  [695] = {.lex_state = 14},
  [696] = {.lex_state = 14},
  [697] = {.lex_state = 4},
  [698] = {.lex_state = 14},
  [699] = {.lex_state = 14},
  [700] = {.lex_state = 14},
  [701] = {.lex_state = 14},
  [702] = {.lex_state = 14},
  [703] = {.lex_state = 14},
  [704] = {.lex_state = 14},
  [705] = {.lex_state = 4},
  [706] = {.lex_state = 14},
  [707] = {.lex_state = 4},
  [708] = {.lex_state = 14},
  [709] = {.lex_state = 14},
  [710] = {.lex_state = 4},
  [711] = {.lex_state = 14},
  [712] = {.lex_state = 14},
  [713] = {.lex_state = 14},
  [714] = {.lex_state = 0},
  [715] = {.lex_state = 4},
  [716] = {.lex_state = 14},
  [717] = {.lex_state = 14},
  [718] = {.lex_state = 14},
  [719] = {.lex_state = 14},
  [720] = {.lex_state = 4},
  [721] = {.lex_state = 14},
  [722] = {.lex_state = 14},
  [723] = {.lex_state = 4},
  [724] = {.lex_state = 14},
  [725] = {.lex_state = 14},
  [726] = {.lex_state = 14},
  [727] = {.lex_state = 4},
  [728] = {.lex_state = 14},
  [729] = {.lex_state = 4},
  [730] = {.lex_state = 14},
  [731] = {.lex_state = 14},
  [732] = {.lex_state = 14},
  [733] = {.lex_state = 4},
  [734] = {.lex_state = 14},
  [735] = {.lex_state = 14},
  [736] = {.lex_state = 0},
  [737] = {.lex_state = 14},
  [738] = {.lex_state = 14},
  [739] = {.lex_state = 14},
  [740] = {.lex_state = 4},
  [741] = {.lex_state = 14},
  [742] = {.lex_state = 14},
  [743] = {.lex_state = 14},
  [744] = {.lex_state = 14},
  [745] = {.lex_state = 4},
  [746] = {.lex_state = 14},
  [747] = {.lex_state = 14},
  [748] = {.lex_state = 14},
  [749] = {.lex_state = 14},
  [750] = {.lex_state = 4},
  [751] = {.lex_state = 4},
  [752] = {.lex_state = 0},
  [753] = {.lex_state = 14},
  [754] = {.lex_state = 4},
  [755] = {.lex_state = 14},
  [756] = {.lex_state = 0},
  [757] = {.lex_state = 14},
  [758] = {.lex_state = 14},
  [759] = {.lex_state = 4},
  [760] = {.lex_state = 14},
  [761] = {.lex_state = 46},
  [762] = {.lex_state = 14},
  [763] = {.lex_state = 0},
  [764] = {.lex_state = 0},
  [765] = {.lex_state = 0},
  [766] = {.lex_state = 14},
  [767] = {.lex_state = 46},
  [768] = {.lex_state = 0},
  [769] = {.lex_state = 14},
  [770] = {.lex_state = 0},
  [771] = {.lex_state = 14},
  [772] = {.lex_state = 0},
  [773] = {.lex_state = 14},
  [774] = {.lex_state = 14},
  [775] = {.lex_state = 0},
  [776] = {.lex_state = 14},
  [777] = {.lex_state = 14},
  [778] = {.lex_state = 0},
  [779] = {.lex_state = 14},
  [780] = {.lex_state = 14},
  [781] = {.lex_state = 14},
  [782] = {.lex_state = 0},
  [783] = {.lex_state = 0},
  [784] = {.lex_state = 14},
  [785] = {.lex_state = 0},
  [786] = {.lex_state = 0},
  [787] = {.lex_state = 0},
  [788] = {.lex_state = 0},
  [789] = {.lex_state = 14},
  [790] = {.lex_state = 14},
  [791] = {.lex_state = 0},
  [792] = {.lex_state = 0},
  [793] = {.lex_state = 0},
  [794] = {.lex_state = 14},
  [795] = {.lex_state = 46},
  [796] = {.lex_state = 14},
  [797] = {.lex_state = 0},
  [798] = {.lex_state = 0},
  [799] = {.lex_state = 0},
  [800] = {.lex_state = 0},
  [801] = {.lex_state = 14},
  [802] = {.lex_state = 22},
  [803] = {.lex_state = 46},
  [804] = {.lex_state = 14},
  [805] = {.lex_state = 22},
  [806] = {.lex_state = 0},
  [807] = {.lex_state = 0},
  [808] = {.lex_state = 0},
  [809] = {.lex_state = 22},
  [810] = {.lex_state = 46},
  [811] = {.lex_state = 22},
  [812] = {.lex_state = 22},
  [813] = {.lex_state = 0},
  [814] = {.lex_state = 0},
  [815] = {.lex_state = 0},
  [816] = {.lex_state = 0},
  [817] = {.lex_state = 0},
  [818] = {.lex_state = 46},
  [819] = {.lex_state = 0},
  [820] = {.lex_state = 0},
  [821] = {.lex_state = 0},
  [822] = {.lex_state = 22},
  [823] = {.lex_state = 22},
  [824] = {.lex_state = 22},
  [825] = {.lex_state = 0},
  [826] = {.lex_state = 46},
  [827] = {.lex_state = 0},
  [828] = {.lex_state = 0},
  [829] = {.lex_state = 22},
  [830] = {.lex_state = 22},
  [831] = {.lex_state = 0},
  [832] = {.lex_state = 0},
  [833] = {.lex_state = 0},
  [834] = {.lex_state = 0},
  [835] = {.lex_state = 0},
  [836] = {.lex_state = 22},
  [837] = {.lex_state = 0},
  [838] = {.lex_state = 0},
  [839] = {.lex_state = 0},
  [840] = {.lex_state = 14},
  [841] = {.lex_state = 22},
  [842] = {.lex_state = 0},
  [843] = {.lex_state = 22},
  [844] = {.lex_state = 0},
  [845] = {.lex_state = 14},
  [846] = {.lex_state = 0},
  [847] = {.lex_state = 14},
  [848] = {.lex_state = 0},
  [849] = {.lex_state = 0},
  [850] = {.lex_state = 0},
  [851] = {.lex_state = 22},
  [852] = {.lex_state = 14},
  [853] = {.lex_state = 14},
  [854] = {.lex_state = 0},
  [855] = {.lex_state = 46},
  [856] = {.lex_state = 46},
  [857] = {.lex_state = 46},
  [858] = {.lex_state = 0},
  [859] = {.lex_state = 46},
  [860] = {.lex_state = 14},
  [861] = {.lex_state = 14},
  [862] = {.lex_state = 0},
  [863] = {.lex_state = 0},
  [864] = {.lex_state = 22},
  [865] = {.lex_state = 0},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [sym__comment] = ACTIONS(3),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [aux_sym_command_argument_token2] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [sym_range] = ACTIONS(1),
    [sym_integer] = ACTIONS(1),
    [aux_sym_float_token1] = ACTIONS(1),
    [anon_sym_Infinity] = ACTIONS(1),
    [anon_sym_infinity] = ACTIONS(1),
    [anon_sym_NaN] = ACTIONS(1),
    [anon_sym_nan] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_elseif] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_match] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_loop] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_asyncfor] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_any] = ACTIONS(1),
    [anon_sym_bool] = ACTIONS(1),
    [anon_sym_collection] = ACTIONS(1),
    [anon_sym_float] = ACTIONS(1),
    [anon_sym_int] = ACTIONS(1),
    [anon_sym_list] = ACTIONS(1),
    [anon_sym_map] = ACTIONS(1),
    [anon_sym_none] = ACTIONS(1),
    [anon_sym_num] = ACTIONS(1),
    [anon_sym_str] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
  },
  [1] = {
    [sym_root] = STATE(850),
    [sym_statement] = STATE(37),
    [sym_statement_kind] = STATE(340),
    [sym_expression] = STATE(124),
    [sym__expression_kind] = STATE(134),
    [sym_as_node] = STATE(134),
    [sym_pipe] = STATE(337),
    [sym_command] = STATE(139),
    [sym_block] = STATE(337),
    [sym_value] = STATE(116),
    [sym_float] = STATE(85),
    [sym_string] = STATE(85),
    [sym_boolean] = STATE(85),
    [sym_list] = STATE(85),
    [sym_map] = STATE(85),
    [sym_index] = STATE(98),
    [sym_index_expression] = STATE(849),
    [sym_math] = STATE(134),
    [sym_logic] = STATE(134),
    [sym_assignment] = STATE(337),
    [sym_index_assignment] = STATE(337),
    [sym_if_else] = STATE(337),
    [sym_if] = STATE(259),
    [sym_match] = STATE(337),
    [sym_loop_node] = STATE(337),
    [sym_while] = STATE(337),
    [sym_for] = STATE(337),
    [sym_function] = STATE(85),
    [sym_function_expression] = STATE(846),
    [sym__function_expression_kind] = STATE(842),
    [sym_function_call] = STATE(127),
    [sym_type_definition] = STATE(337),
    [sym_enum_definition] = STATE(322),
    [sym_enum_instance] = STATE(85),
    [sym_struct_definition] = STATE(322),
    [sym_struct_instance] = STATE(85),
    [aux_sym_root_repeat1] = STATE(37),
    [sym_identifier] = ACTIONS(5),
    [sym__comment] = ACTIONS(3),
    [anon_sym_return] = ACTIONS(7),
    [anon_sym_break] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [aux_sym_command_argument_token2] = ACTIONS(13),
    [anon_sym_async] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [sym_range] = ACTIONS(19),
    [sym_integer] = ACTIONS(21),
    [aux_sym_float_token1] = ACTIONS(23),
    [anon_sym_Infinity] = ACTIONS(23),
    [anon_sym_infinity] = ACTIONS(23),
    [anon_sym_NaN] = ACTIONS(23),
    [anon_sym_nan] = ACTIONS(23),
    [anon_sym_true] = ACTIONS(25),
    [anon_sym_false] = ACTIONS(25),
    [anon_sym_LBRACK] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(31),
    [anon_sym_loop] = ACTIONS(33),
    [anon_sym_while] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_asyncfor] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
  },
  [2] = {
    [sym_statement] = STATE(5),
    [sym_statement_kind] = STATE(340),
    [sym_expression] = STATE(115),
    [sym__expression_kind] = STATE(134),
    [sym_as_node] = STATE(134),
    [sym_pipe] = STATE(337),
    [sym_command] = STATE(129),
    [sym_block] = STATE(337),
    [sym_value] = STATE(116),
    [sym_float] = STATE(85),
    [sym_string] = STATE(85),
    [sym_boolean] = STATE(85),
    [sym_list] = STATE(85),
    [sym_map] = STATE(85),
    [sym_index] = STATE(101),
    [sym_index_expression] = STATE(849),
    [sym_math] = STATE(134),
    [sym_logic] = STATE(134),
    [sym_assignment] = STATE(337),
    [sym_index_assignment] = STATE(337),
    [sym_if_else] = STATE(337),
    [sym_if] = STATE(259),
    [sym_match] = STATE(337),
    [sym_loop_node] = STATE(337),
    [sym_while] = STATE(337),
    [sym_for] = STATE(337),
    [sym_function] = STATE(85),
    [sym_function_expression] = STATE(846),
    [sym__function_expression_kind] = STATE(842),
    [sym_function_call] = STATE(133),
    [sym_type_definition] = STATE(337),
    [sym_enum_definition] = STATE(322),
    [sym_enum_instance] = STATE(85),
    [sym_struct_definition] = STATE(322),
    [sym_struct_instance] = STATE(85),
    [aux_sym_root_repeat1] = STATE(5),
    [aux_sym_map_repeat1] = STATE(742),
    [sym_identifier] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(49),
    [aux_sym_command_argument_token2] = ACTIONS(13),
    [anon_sym_async] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(51),
    [sym_range] = ACTIONS(19),
    [sym_integer] = ACTIONS(21),
    [aux_sym_float_token1] = ACTIONS(23),
    [anon_sym_Infinity] = ACTIONS(23),
    [anon_sym_infinity] = ACTIONS(23),
    [anon_sym_NaN] = ACTIONS(23),
    [anon_sym_nan] = ACTIONS(23),
    [anon_sym_true] = ACTIONS(25),
    [anon_sym_false] = ACTIONS(25),
    [anon_sym_LBRACK] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(31),
    [anon_sym_loop] = ACTIONS(33),
    [anon_sym_while] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_asyncfor] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
  },
  [3] = {
    [sym_statement] = STATE(41),
    [sym_statement_kind] = STATE(340),
    [sym_expression] = STATE(115),
    [sym__expression_kind] = STATE(134),
    [sym_as_node] = STATE(134),
    [sym_pipe] = STATE(337),
    [sym_command] = STATE(129),
    [sym_block] = STATE(337),
    [sym_value] = STATE(116),
    [sym_float] = STATE(85),
    [sym_string] = STATE(85),
    [sym_boolean] = STATE(85),
    [sym_list] = STATE(85),
    [sym_map] = STATE(85),
    [sym_index] = STATE(101),
    [sym_index_expression] = STATE(849),
    [sym_math] = STATE(134),
    [sym_logic] = STATE(134),
    [sym_assignment] = STATE(337),
    [sym_index_assignment] = STATE(337),
    [sym_if_else] = STATE(337),
    [sym_if] = STATE(259),
    [sym_match] = STATE(337),
    [sym_loop_node] = STATE(337),
    [sym_while] = STATE(337),
    [sym_for] = STATE(337),
    [sym_function] = STATE(85),
    [sym_function_expression] = STATE(846),
    [sym__function_expression_kind] = STATE(842),
    [sym_function_call] = STATE(133),
    [sym_type_definition] = STATE(337),
    [sym_enum_definition] = STATE(322),
    [sym_enum_instance] = STATE(85),
    [sym_struct_definition] = STATE(322),
    [sym_struct_instance] = STATE(85),
    [aux_sym_root_repeat1] = STATE(41),
    [aux_sym_map_repeat1] = STATE(748),
    [sym_identifier] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(49),
    [aux_sym_command_argument_token2] = ACTIONS(13),
    [anon_sym_async] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(53),
    [sym_range] = ACTIONS(19),
    [sym_integer] = ACTIONS(21),
    [aux_sym_float_token1] = ACTIONS(23),
    [anon_sym_Infinity] = ACTIONS(23),
    [anon_sym_infinity] = ACTIONS(23),
    [anon_sym_NaN] = ACTIONS(23),
    [anon_sym_nan] = ACTIONS(23),
    [anon_sym_true] = ACTIONS(25),
    [anon_sym_false] = ACTIONS(25),
    [anon_sym_LBRACK] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(31),
    [anon_sym_loop] = ACTIONS(33),
    [anon_sym_while] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_asyncfor] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
  },
  [4] = {
    [sym_statement] = STATE(41),
    [sym_statement_kind] = STATE(340),
    [sym_expression] = STATE(115),
    [sym__expression_kind] = STATE(134),
    [sym_as_node] = STATE(134),
    [sym_pipe] = STATE(337),
    [sym_command] = STATE(129),
    [sym_block] = STATE(337),
    [sym_value] = STATE(116),
    [sym_float] = STATE(85),
    [sym_string] = STATE(85),
    [sym_boolean] = STATE(85),
    [sym_list] = STATE(85),
    [sym_map] = STATE(85),
    [sym_index] = STATE(101),
    [sym_index_expression] = STATE(849),
    [sym_math] = STATE(134),
    [sym_logic] = STATE(134),
    [sym_assignment] = STATE(337),
    [sym_index_assignment] = STATE(337),
    [sym_if_else] = STATE(337),
    [sym_if] = STATE(259),
    [sym_match] = STATE(337),
    [sym_loop_node] = STATE(337),
    [sym_while] = STATE(337),
    [sym_for] = STATE(337),
    [sym_function] = STATE(85),
    [sym_function_expression] = STATE(846),
    [sym__function_expression_kind] = STATE(842),
    [sym_function_call] = STATE(133),
    [sym_type_definition] = STATE(337),
    [sym_enum_definition] = STATE(322),
    [sym_enum_instance] = STATE(85),
    [sym_struct_definition] = STATE(322),
    [sym_struct_instance] = STATE(85),
    [aux_sym_root_repeat1] = STATE(41),
    [aux_sym_map_repeat1] = STATE(701),
    [sym_identifier] = ACTIONS(45),
    [sym__comment] = ACTIONS(3),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_break] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(49),
    [aux_sym_command_argument_token2] = ACTIONS(13),
    [anon_sym_async] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_RBRACE] = ACTIONS(55),
    [sym_range] = ACTIONS(19),
    [sym_integer] = ACTIONS(21),
    [aux_sym_float_token1] = ACTIONS(23),
    [anon_sym_Infinity] = ACTIONS(23),
    [anon_sym_infinity] = ACTIONS(23),
    [anon_sym_NaN] = ACTIONS(23),
    [anon_sym_nan] = ACTIONS(23),
    [anon_sym_true] = ACTIONS(25),
    [anon_sym_false] = ACTIONS(25),
    [anon_sym_LBRACK] = ACTIONS(27),
    [anon_sym_if] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(31),
    [anon_sym_loop] = ACTIONS(33),
    [anon_sym_while] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_asyncfor] = ACTIONS(39),
    [anon_sym_enum] = ACTIONS(41),
    [anon_sym_struct] = ACTIONS(43),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 37,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(59), 1,
      anon_sym_RBRACE,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(340), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(47), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(18), 2,
      sym_statement,
      aux_sym_root_repeat1,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [139] = 37,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(61), 1,
      anon_sym_RBRACE,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(340), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(47), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(26), 2,
      sym_statement,
      aux_sym_root_repeat1,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [278] = 37,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(63), 1,
      anon_sym_RBRACE,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(340), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(47), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(38), 2,
      sym_statement,
      aux_sym_root_repeat1,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [417] = 37,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(65), 1,
      anon_sym_RBRACE,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(340), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(47), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(5), 2,
      sym_statement,
      aux_sym_root_repeat1,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [556] = 37,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(67), 1,
      anon_sym_RBRACE,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(340), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(47), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(18), 2,
      sym_statement,
      aux_sym_root_repeat1,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [695] = 37,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(69), 1,
      anon_sym_RBRACE,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(340), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(47), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(11), 2,
      sym_statement,
      aux_sym_root_repeat1,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [834] = 37,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_RBRACE,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(340), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(47), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(18), 2,
      sym_statement,
      aux_sym_root_repeat1,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [973] = 37,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_RBRACE,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(340), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(47), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(9), 2,
      sym_statement,
      aux_sym_root_repeat1,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [1112] = 37,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(73), 1,
      anon_sym_RBRACE,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(340), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(47), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(18), 2,
      sym_statement,
      aux_sym_root_repeat1,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [1251] = 37,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(75), 1,
      anon_sym_RBRACE,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(340), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(47), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(15), 2,
      sym_statement,
      aux_sym_root_repeat1,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [1390] = 37,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(77), 1,
      anon_sym_RBRACE,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(340), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(47), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(18), 2,
      sym_statement,
      aux_sym_root_repeat1,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [1529] = 37,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(77), 1,
      anon_sym_RBRACE,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(340), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(47), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(13), 2,
      sym_statement,
      aux_sym_root_repeat1,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [1668] = 37,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(79), 1,
      anon_sym_RBRACE,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(340), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(47), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(18), 2,
      sym_statement,
      aux_sym_root_repeat1,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [1807] = 37,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(81), 1,
      sym_identifier,
    ACTIONS(87), 1,
      anon_sym_LPAREN,
    ACTIONS(90), 1,
      anon_sym_CARET,
    ACTIONS(93), 1,
      aux_sym_command_argument_token2,
    ACTIONS(96), 1,
      anon_sym_async,
    ACTIONS(99), 1,
      anon_sym_LBRACE,
    ACTIONS(102), 1,
      anon_sym_RBRACE,
    ACTIONS(104), 1,
      sym_range,
    ACTIONS(107), 1,
      sym_integer,
    ACTIONS(116), 1,
      anon_sym_LBRACK,
    ACTIONS(119), 1,
      anon_sym_if,
    ACTIONS(122), 1,
      anon_sym_match,
    ACTIONS(125), 1,
      anon_sym_loop,
    ACTIONS(128), 1,
      anon_sym_while,
    ACTIONS(131), 1,
      anon_sym_for,
    ACTIONS(134), 1,
      anon_sym_asyncfor,
    ACTIONS(137), 1,
      anon_sym_enum,
    ACTIONS(140), 1,
      anon_sym_struct,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(340), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(84), 2,
      anon_sym_return,
      anon_sym_break,
    ACTIONS(113), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(18), 2,
      sym_statement,
      aux_sym_root_repeat1,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(110), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [1946] = 37,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(143), 1,
      anon_sym_RBRACE,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(340), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(47), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(18), 2,
      sym_statement,
      aux_sym_root_repeat1,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [2085] = 37,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(145), 1,
      anon_sym_RBRACE,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(340), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(47), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(21), 2,
      sym_statement,
      aux_sym_root_repeat1,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [2224] = 37,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(147), 1,
      anon_sym_RBRACE,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(340), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(47), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(18), 2,
      sym_statement,
      aux_sym_root_repeat1,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [2363] = 37,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(149), 1,
      anon_sym_RBRACE,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(340), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(47), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(27), 2,
      sym_statement,
      aux_sym_root_repeat1,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [2502] = 37,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(147), 1,
      anon_sym_RBRACE,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(340), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(47), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(19), 2,
      sym_statement,
      aux_sym_root_repeat1,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [2641] = 37,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(149), 1,
      anon_sym_RBRACE,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(340), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(47), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(18), 2,
      sym_statement,
      aux_sym_root_repeat1,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [2780] = 37,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(151), 1,
      anon_sym_RBRACE,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(340), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(47), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(24), 2,
      sym_statement,
      aux_sym_root_repeat1,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [2919] = 37,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(153), 1,
      anon_sym_RBRACE,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(340), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(47), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(18), 2,
      sym_statement,
      aux_sym_root_repeat1,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [3058] = 37,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(155), 1,
      anon_sym_RBRACE,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(340), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(47), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(18), 2,
      sym_statement,
      aux_sym_root_repeat1,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [3197] = 37,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(157), 1,
      anon_sym_RBRACE,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(340), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(47), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(18), 2,
      sym_statement,
      aux_sym_root_repeat1,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [3336] = 37,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(159), 1,
      anon_sym_RBRACE,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(340), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(47), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(41), 2,
      sym_statement,
      aux_sym_root_repeat1,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [3475] = 37,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(61), 1,
      anon_sym_RBRACE,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(340), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(47), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(18), 2,
      sym_statement,
      aux_sym_root_repeat1,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [3614] = 37,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(161), 1,
      anon_sym_RBRACE,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(340), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(47), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(40), 2,
      sym_statement,
      aux_sym_root_repeat1,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [3753] = 37,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(163), 1,
      anon_sym_RBRACE,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(340), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(47), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(42), 2,
      sym_statement,
      aux_sym_root_repeat1,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [3892] = 37,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(165), 1,
      anon_sym_RBRACE,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(340), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(47), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(34), 2,
      sym_statement,
      aux_sym_root_repeat1,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [4031] = 37,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(167), 1,
      anon_sym_RBRACE,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(340), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(47), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(18), 2,
      sym_statement,
      aux_sym_root_repeat1,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [4170] = 37,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(59), 1,
      anon_sym_RBRACE,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(340), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(47), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(28), 2,
      sym_statement,
      aux_sym_root_repeat1,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [4309] = 37,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(169), 1,
      anon_sym_RBRACE,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(340), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(47), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(30), 2,
      sym_statement,
      aux_sym_root_repeat1,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [4448] = 37,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(5), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_CARET,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(171), 1,
      ts_builtin_sym_end,
    STATE(98), 1,
      sym_index,
    STATE(116), 1,
      sym_value,
    STATE(124), 1,
      sym_expression,
    STATE(127), 1,
      sym_function_call,
    STATE(139), 1,
      sym_command,
    STATE(259), 1,
      sym_if,
    STATE(340), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(7), 2,
      anon_sym_return,
      anon_sym_break,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(39), 2,
      sym_statement,
      aux_sym_root_repeat1,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [4587] = 37,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(173), 1,
      anon_sym_RBRACE,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(340), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(47), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(18), 2,
      sym_statement,
      aux_sym_root_repeat1,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [4726] = 37,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(87), 1,
      anon_sym_LPAREN,
    ACTIONS(93), 1,
      aux_sym_command_argument_token2,
    ACTIONS(96), 1,
      anon_sym_async,
    ACTIONS(99), 1,
      anon_sym_LBRACE,
    ACTIONS(102), 1,
      ts_builtin_sym_end,
    ACTIONS(104), 1,
      sym_range,
    ACTIONS(107), 1,
      sym_integer,
    ACTIONS(116), 1,
      anon_sym_LBRACK,
    ACTIONS(119), 1,
      anon_sym_if,
    ACTIONS(122), 1,
      anon_sym_match,
    ACTIONS(125), 1,
      anon_sym_loop,
    ACTIONS(128), 1,
      anon_sym_while,
    ACTIONS(131), 1,
      anon_sym_for,
    ACTIONS(134), 1,
      anon_sym_asyncfor,
    ACTIONS(137), 1,
      anon_sym_enum,
    ACTIONS(140), 1,
      anon_sym_struct,
    ACTIONS(175), 1,
      sym_identifier,
    ACTIONS(181), 1,
      anon_sym_CARET,
    STATE(98), 1,
      sym_index,
    STATE(116), 1,
      sym_value,
    STATE(124), 1,
      sym_expression,
    STATE(127), 1,
      sym_function_call,
    STATE(139), 1,
      sym_command,
    STATE(259), 1,
      sym_if,
    STATE(340), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(113), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(178), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(39), 2,
      sym_statement,
      aux_sym_root_repeat1,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(110), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [4865] = 37,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(184), 1,
      anon_sym_RBRACE,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(340), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(47), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(18), 2,
      sym_statement,
      aux_sym_root_repeat1,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [5004] = 37,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(165), 1,
      anon_sym_RBRACE,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(340), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(47), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(18), 2,
      sym_statement,
      aux_sym_root_repeat1,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [5143] = 37,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(63), 1,
      anon_sym_RBRACE,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(340), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(47), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(18), 2,
      sym_statement,
      aux_sym_root_repeat1,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [5282] = 37,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    ACTIONS(184), 1,
      anon_sym_RBRACE,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(340), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(47), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(17), 2,
      sym_statement,
      aux_sym_root_repeat1,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [5421] = 36,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(186), 1,
      sym_identifier,
    ACTIONS(190), 1,
      anon_sym_LPAREN,
    ACTIONS(192), 1,
      anon_sym_CARET,
    ACTIONS(194), 1,
      aux_sym_command_argument_token2,
    ACTIONS(196), 1,
      anon_sym_async,
    ACTIONS(198), 1,
      anon_sym_LBRACE,
    ACTIONS(200), 1,
      sym_range,
    ACTIONS(202), 1,
      sym_integer,
    ACTIONS(208), 1,
      anon_sym_LBRACK,
    ACTIONS(210), 1,
      anon_sym_if,
    ACTIONS(212), 1,
      anon_sym_match,
    ACTIONS(214), 1,
      anon_sym_loop,
    ACTIONS(216), 1,
      anon_sym_while,
    ACTIONS(218), 1,
      anon_sym_for,
    ACTIONS(220), 1,
      anon_sym_asyncfor,
    ACTIONS(222), 1,
      anon_sym_enum,
    ACTIONS(224), 1,
      anon_sym_struct,
    STATE(369), 1,
      sym_index,
    STATE(377), 1,
      sym_if,
    STATE(407), 1,
      sym_value,
    STATE(415), 1,
      sym_expression,
    STATE(453), 1,
      sym_function_call,
    STATE(501), 1,
      sym_statement,
    STATE(514), 1,
      sym_statement_kind,
    STATE(532), 1,
      sym_command,
    STATE(828), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(862), 1,
      sym_index_expression,
    ACTIONS(188), 2,
      anon_sym_return,
      anon_sym_break,
    ACTIONS(206), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(478), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(466), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(204), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(368), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(473), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [5556] = 36,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(317), 1,
      sym_statement_kind,
    STATE(333), 1,
      sym_statement,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(226), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [5691] = 36,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(190), 1,
      anon_sym_LPAREN,
    ACTIONS(194), 1,
      aux_sym_command_argument_token2,
    ACTIONS(196), 1,
      anon_sym_async,
    ACTIONS(198), 1,
      anon_sym_LBRACE,
    ACTIONS(200), 1,
      sym_range,
    ACTIONS(202), 1,
      sym_integer,
    ACTIONS(208), 1,
      anon_sym_LBRACK,
    ACTIONS(210), 1,
      anon_sym_if,
    ACTIONS(212), 1,
      anon_sym_match,
    ACTIONS(214), 1,
      anon_sym_loop,
    ACTIONS(216), 1,
      anon_sym_while,
    ACTIONS(218), 1,
      anon_sym_for,
    ACTIONS(220), 1,
      anon_sym_asyncfor,
    ACTIONS(222), 1,
      anon_sym_enum,
    ACTIONS(224), 1,
      anon_sym_struct,
    ACTIONS(228), 1,
      sym_identifier,
    ACTIONS(232), 1,
      anon_sym_CARET,
    STATE(355), 1,
      sym_index,
    STATE(377), 1,
      sym_if,
    STATE(402), 1,
      sym_expression,
    STATE(406), 1,
      sym_function_call,
    STATE(407), 1,
      sym_value,
    STATE(433), 1,
      sym_command,
    STATE(541), 1,
      sym_statement_kind,
    STATE(744), 1,
      sym_statement,
    STATE(828), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(862), 1,
      sym_index_expression,
    ACTIONS(206), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(230), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(478), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(466), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(204), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(368), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(473), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [5826] = 36,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(186), 1,
      sym_identifier,
    ACTIONS(190), 1,
      anon_sym_LPAREN,
    ACTIONS(192), 1,
      anon_sym_CARET,
    ACTIONS(194), 1,
      aux_sym_command_argument_token2,
    ACTIONS(196), 1,
      anon_sym_async,
    ACTIONS(198), 1,
      anon_sym_LBRACE,
    ACTIONS(200), 1,
      sym_range,
    ACTIONS(202), 1,
      sym_integer,
    ACTIONS(208), 1,
      anon_sym_LBRACK,
    ACTIONS(210), 1,
      anon_sym_if,
    ACTIONS(212), 1,
      anon_sym_match,
    ACTIONS(214), 1,
      anon_sym_loop,
    ACTIONS(216), 1,
      anon_sym_while,
    ACTIONS(218), 1,
      anon_sym_for,
    ACTIONS(220), 1,
      anon_sym_asyncfor,
    ACTIONS(222), 1,
      anon_sym_enum,
    ACTIONS(224), 1,
      anon_sym_struct,
    STATE(369), 1,
      sym_index,
    STATE(377), 1,
      sym_if,
    STATE(407), 1,
      sym_value,
    STATE(415), 1,
      sym_expression,
    STATE(453), 1,
      sym_function_call,
    STATE(514), 1,
      sym_statement_kind,
    STATE(530), 1,
      sym_statement,
    STATE(532), 1,
      sym_command,
    STATE(828), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(862), 1,
      sym_index_expression,
    ACTIONS(188), 2,
      anon_sym_return,
      anon_sym_break,
    ACTIONS(206), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(478), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(466), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(204), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(368), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(473), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [5961] = 36,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(5), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_CARET,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    STATE(98), 1,
      sym_index,
    STATE(116), 1,
      sym_value,
    STATE(124), 1,
      sym_expression,
    STATE(127), 1,
      sym_function_call,
    STATE(139), 1,
      sym_command,
    STATE(259), 1,
      sym_if,
    STATE(317), 1,
      sym_statement_kind,
    STATE(319), 1,
      sym_statement,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(234), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [6096] = 36,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(186), 1,
      sym_identifier,
    ACTIONS(190), 1,
      anon_sym_LPAREN,
    ACTIONS(192), 1,
      anon_sym_CARET,
    ACTIONS(194), 1,
      aux_sym_command_argument_token2,
    ACTIONS(196), 1,
      anon_sym_async,
    ACTIONS(198), 1,
      anon_sym_LBRACE,
    ACTIONS(200), 1,
      sym_range,
    ACTIONS(202), 1,
      sym_integer,
    ACTIONS(208), 1,
      anon_sym_LBRACK,
    ACTIONS(210), 1,
      anon_sym_if,
    ACTIONS(212), 1,
      anon_sym_match,
    ACTIONS(214), 1,
      anon_sym_loop,
    ACTIONS(216), 1,
      anon_sym_while,
    ACTIONS(218), 1,
      anon_sym_for,
    ACTIONS(220), 1,
      anon_sym_asyncfor,
    ACTIONS(222), 1,
      anon_sym_enum,
    ACTIONS(224), 1,
      anon_sym_struct,
    STATE(369), 1,
      sym_index,
    STATE(377), 1,
      sym_if,
    STATE(407), 1,
      sym_value,
    STATE(415), 1,
      sym_expression,
    STATE(453), 1,
      sym_function_call,
    STATE(510), 1,
      sym_statement,
    STATE(514), 1,
      sym_statement_kind,
    STATE(532), 1,
      sym_command,
    STATE(828), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(862), 1,
      sym_index_expression,
    ACTIONS(188), 2,
      anon_sym_return,
      anon_sym_break,
    ACTIONS(206), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(478), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(466), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(204), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(368), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(473), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [6231] = 36,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(186), 1,
      sym_identifier,
    ACTIONS(190), 1,
      anon_sym_LPAREN,
    ACTIONS(192), 1,
      anon_sym_CARET,
    ACTIONS(194), 1,
      aux_sym_command_argument_token2,
    ACTIONS(196), 1,
      anon_sym_async,
    ACTIONS(198), 1,
      anon_sym_LBRACE,
    ACTIONS(200), 1,
      sym_range,
    ACTIONS(202), 1,
      sym_integer,
    ACTIONS(208), 1,
      anon_sym_LBRACK,
    ACTIONS(210), 1,
      anon_sym_if,
    ACTIONS(212), 1,
      anon_sym_match,
    ACTIONS(214), 1,
      anon_sym_loop,
    ACTIONS(216), 1,
      anon_sym_while,
    ACTIONS(218), 1,
      anon_sym_for,
    ACTIONS(220), 1,
      anon_sym_asyncfor,
    ACTIONS(222), 1,
      anon_sym_enum,
    ACTIONS(224), 1,
      anon_sym_struct,
    STATE(369), 1,
      sym_index,
    STATE(377), 1,
      sym_if,
    STATE(407), 1,
      sym_value,
    STATE(415), 1,
      sym_expression,
    STATE(453), 1,
      sym_function_call,
    STATE(532), 1,
      sym_command,
    STATE(541), 1,
      sym_statement_kind,
    STATE(789), 1,
      sym_statement,
    STATE(828), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(862), 1,
      sym_index_expression,
    ACTIONS(206), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(236), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(478), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(466), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(204), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(368), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(473), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [6366] = 36,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(5), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_CARET,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    STATE(98), 1,
      sym_index,
    STATE(116), 1,
      sym_value,
    STATE(124), 1,
      sym_expression,
    STATE(127), 1,
      sym_function_call,
    STATE(139), 1,
      sym_command,
    STATE(259), 1,
      sym_if,
    STATE(317), 1,
      sym_statement_kind,
    STATE(333), 1,
      sym_statement,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(234), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [6501] = 36,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(190), 1,
      anon_sym_LPAREN,
    ACTIONS(194), 1,
      aux_sym_command_argument_token2,
    ACTIONS(196), 1,
      anon_sym_async,
    ACTIONS(198), 1,
      anon_sym_LBRACE,
    ACTIONS(200), 1,
      sym_range,
    ACTIONS(202), 1,
      sym_integer,
    ACTIONS(208), 1,
      anon_sym_LBRACK,
    ACTIONS(210), 1,
      anon_sym_if,
    ACTIONS(212), 1,
      anon_sym_match,
    ACTIONS(214), 1,
      anon_sym_loop,
    ACTIONS(216), 1,
      anon_sym_while,
    ACTIONS(218), 1,
      anon_sym_for,
    ACTIONS(220), 1,
      anon_sym_asyncfor,
    ACTIONS(222), 1,
      anon_sym_enum,
    ACTIONS(224), 1,
      anon_sym_struct,
    ACTIONS(228), 1,
      sym_identifier,
    ACTIONS(232), 1,
      anon_sym_CARET,
    STATE(355), 1,
      sym_index,
    STATE(377), 1,
      sym_if,
    STATE(402), 1,
      sym_expression,
    STATE(406), 1,
      sym_function_call,
    STATE(407), 1,
      sym_value,
    STATE(433), 1,
      sym_command,
    STATE(514), 1,
      sym_statement_kind,
    STATE(530), 1,
      sym_statement,
    STATE(828), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(862), 1,
      sym_index_expression,
    ACTIONS(206), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(238), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(478), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(466), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(204), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(368), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(473), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [6636] = 36,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(190), 1,
      anon_sym_LPAREN,
    ACTIONS(194), 1,
      aux_sym_command_argument_token2,
    ACTIONS(196), 1,
      anon_sym_async,
    ACTIONS(198), 1,
      anon_sym_LBRACE,
    ACTIONS(200), 1,
      sym_range,
    ACTIONS(202), 1,
      sym_integer,
    ACTIONS(208), 1,
      anon_sym_LBRACK,
    ACTIONS(210), 1,
      anon_sym_if,
    ACTIONS(212), 1,
      anon_sym_match,
    ACTIONS(214), 1,
      anon_sym_loop,
    ACTIONS(216), 1,
      anon_sym_while,
    ACTIONS(218), 1,
      anon_sym_for,
    ACTIONS(220), 1,
      anon_sym_asyncfor,
    ACTIONS(222), 1,
      anon_sym_enum,
    ACTIONS(224), 1,
      anon_sym_struct,
    ACTIONS(228), 1,
      sym_identifier,
    ACTIONS(232), 1,
      anon_sym_CARET,
    STATE(355), 1,
      sym_index,
    STATE(377), 1,
      sym_if,
    STATE(402), 1,
      sym_expression,
    STATE(406), 1,
      sym_function_call,
    STATE(407), 1,
      sym_value,
    STATE(433), 1,
      sym_command,
    STATE(541), 1,
      sym_statement_kind,
    STATE(744), 1,
      sym_statement,
    STATE(828), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(862), 1,
      sym_index_expression,
    ACTIONS(206), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(230), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(478), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(466), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(204), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(368), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(473), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [6771] = 36,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(186), 1,
      sym_identifier,
    ACTIONS(190), 1,
      anon_sym_LPAREN,
    ACTIONS(192), 1,
      anon_sym_CARET,
    ACTIONS(194), 1,
      aux_sym_command_argument_token2,
    ACTIONS(196), 1,
      anon_sym_async,
    ACTIONS(198), 1,
      anon_sym_LBRACE,
    ACTIONS(200), 1,
      sym_range,
    ACTIONS(202), 1,
      sym_integer,
    ACTIONS(208), 1,
      anon_sym_LBRACK,
    ACTIONS(210), 1,
      anon_sym_if,
    ACTIONS(212), 1,
      anon_sym_match,
    ACTIONS(214), 1,
      anon_sym_loop,
    ACTIONS(216), 1,
      anon_sym_while,
    ACTIONS(218), 1,
      anon_sym_for,
    ACTIONS(220), 1,
      anon_sym_asyncfor,
    ACTIONS(222), 1,
      anon_sym_enum,
    ACTIONS(224), 1,
      anon_sym_struct,
    STATE(369), 1,
      sym_index,
    STATE(377), 1,
      sym_if,
    STATE(407), 1,
      sym_value,
    STATE(415), 1,
      sym_expression,
    STATE(453), 1,
      sym_function_call,
    STATE(532), 1,
      sym_command,
    STATE(541), 1,
      sym_statement_kind,
    STATE(779), 1,
      sym_statement,
    STATE(828), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(862), 1,
      sym_index_expression,
    ACTIONS(206), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(236), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(478), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(466), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(204), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(368), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(473), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [6906] = 36,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(317), 1,
      sym_statement_kind,
    STATE(319), 1,
      sym_statement,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(226), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [7041] = 36,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(196), 1,
      anon_sym_async,
    ACTIONS(210), 1,
      anon_sym_if,
    ACTIONS(212), 1,
      anon_sym_match,
    ACTIONS(214), 1,
      anon_sym_loop,
    ACTIONS(216), 1,
      anon_sym_while,
    ACTIONS(218), 1,
      anon_sym_for,
    ACTIONS(220), 1,
      anon_sym_asyncfor,
    ACTIONS(222), 1,
      anon_sym_enum,
    ACTIONS(224), 1,
      anon_sym_struct,
    ACTIONS(240), 1,
      sym_identifier,
    ACTIONS(244), 1,
      anon_sym_LPAREN,
    ACTIONS(246), 1,
      anon_sym_CARET,
    ACTIONS(248), 1,
      aux_sym_command_argument_token2,
    ACTIONS(250), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym_range,
    ACTIONS(254), 1,
      sym_integer,
    ACTIONS(260), 1,
      anon_sym_LBRACK,
    STATE(195), 1,
      sym_index,
    STATE(208), 1,
      sym_value,
    STATE(267), 1,
      sym_expression,
    STATE(274), 1,
      sym_command,
    STATE(282), 1,
      sym_function_call,
    STATE(377), 1,
      sym_if,
    STATE(541), 1,
      sym_statement_kind,
    STATE(547), 1,
      sym_statement,
    STATE(806), 1,
      sym_index_expression,
    STATE(808), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    ACTIONS(242), 2,
      anon_sym_return,
      anon_sym_break,
    ACTIONS(258), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(478), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(252), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(256), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(473), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [7176] = 36,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(196), 1,
      anon_sym_async,
    ACTIONS(210), 1,
      anon_sym_if,
    ACTIONS(212), 1,
      anon_sym_match,
    ACTIONS(214), 1,
      anon_sym_loop,
    ACTIONS(216), 1,
      anon_sym_while,
    ACTIONS(218), 1,
      anon_sym_for,
    ACTIONS(220), 1,
      anon_sym_asyncfor,
    ACTIONS(222), 1,
      anon_sym_enum,
    ACTIONS(224), 1,
      anon_sym_struct,
    ACTIONS(240), 1,
      sym_identifier,
    ACTIONS(244), 1,
      anon_sym_LPAREN,
    ACTIONS(246), 1,
      anon_sym_CARET,
    ACTIONS(248), 1,
      aux_sym_command_argument_token2,
    ACTIONS(250), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym_range,
    ACTIONS(254), 1,
      sym_integer,
    ACTIONS(260), 1,
      anon_sym_LBRACK,
    STATE(195), 1,
      sym_index,
    STATE(208), 1,
      sym_value,
    STATE(267), 1,
      sym_expression,
    STATE(274), 1,
      sym_command,
    STATE(282), 1,
      sym_function_call,
    STATE(377), 1,
      sym_if,
    STATE(501), 1,
      sym_statement,
    STATE(514), 1,
      sym_statement_kind,
    STATE(806), 1,
      sym_index_expression,
    STATE(808), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    ACTIONS(258), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(262), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(478), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(252), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(256), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(473), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [7311] = 36,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(190), 1,
      anon_sym_LPAREN,
    ACTIONS(194), 1,
      aux_sym_command_argument_token2,
    ACTIONS(196), 1,
      anon_sym_async,
    ACTIONS(198), 1,
      anon_sym_LBRACE,
    ACTIONS(200), 1,
      sym_range,
    ACTIONS(202), 1,
      sym_integer,
    ACTIONS(208), 1,
      anon_sym_LBRACK,
    ACTIONS(210), 1,
      anon_sym_if,
    ACTIONS(212), 1,
      anon_sym_match,
    ACTIONS(214), 1,
      anon_sym_loop,
    ACTIONS(216), 1,
      anon_sym_while,
    ACTIONS(218), 1,
      anon_sym_for,
    ACTIONS(220), 1,
      anon_sym_asyncfor,
    ACTIONS(222), 1,
      anon_sym_enum,
    ACTIONS(224), 1,
      anon_sym_struct,
    ACTIONS(228), 1,
      sym_identifier,
    ACTIONS(232), 1,
      anon_sym_CARET,
    STATE(355), 1,
      sym_index,
    STATE(377), 1,
      sym_if,
    STATE(402), 1,
      sym_expression,
    STATE(406), 1,
      sym_function_call,
    STATE(407), 1,
      sym_value,
    STATE(433), 1,
      sym_command,
    STATE(541), 1,
      sym_statement_kind,
    STATE(706), 1,
      sym_statement,
    STATE(828), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(862), 1,
      sym_index_expression,
    ACTIONS(206), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(230), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(478), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(466), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(204), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(368), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(473), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [7446] = 36,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(196), 1,
      anon_sym_async,
    ACTIONS(210), 1,
      anon_sym_if,
    ACTIONS(212), 1,
      anon_sym_match,
    ACTIONS(214), 1,
      anon_sym_loop,
    ACTIONS(216), 1,
      anon_sym_while,
    ACTIONS(218), 1,
      anon_sym_for,
    ACTIONS(220), 1,
      anon_sym_asyncfor,
    ACTIONS(222), 1,
      anon_sym_enum,
    ACTIONS(224), 1,
      anon_sym_struct,
    ACTIONS(240), 1,
      sym_identifier,
    ACTIONS(244), 1,
      anon_sym_LPAREN,
    ACTIONS(246), 1,
      anon_sym_CARET,
    ACTIONS(248), 1,
      aux_sym_command_argument_token2,
    ACTIONS(250), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym_range,
    ACTIONS(254), 1,
      sym_integer,
    ACTIONS(260), 1,
      anon_sym_LBRACK,
    STATE(195), 1,
      sym_index,
    STATE(208), 1,
      sym_value,
    STATE(267), 1,
      sym_expression,
    STATE(274), 1,
      sym_command,
    STATE(282), 1,
      sym_function_call,
    STATE(377), 1,
      sym_if,
    STATE(510), 1,
      sym_statement,
    STATE(514), 1,
      sym_statement_kind,
    STATE(806), 1,
      sym_index_expression,
    STATE(808), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    ACTIONS(258), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(262), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(478), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(252), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(256), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(473), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [7581] = 36,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(196), 1,
      anon_sym_async,
    ACTIONS(210), 1,
      anon_sym_if,
    ACTIONS(212), 1,
      anon_sym_match,
    ACTIONS(214), 1,
      anon_sym_loop,
    ACTIONS(216), 1,
      anon_sym_while,
    ACTIONS(218), 1,
      anon_sym_for,
    ACTIONS(220), 1,
      anon_sym_asyncfor,
    ACTIONS(222), 1,
      anon_sym_enum,
    ACTIONS(224), 1,
      anon_sym_struct,
    ACTIONS(240), 1,
      sym_identifier,
    ACTIONS(244), 1,
      anon_sym_LPAREN,
    ACTIONS(246), 1,
      anon_sym_CARET,
    ACTIONS(248), 1,
      aux_sym_command_argument_token2,
    ACTIONS(250), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym_range,
    ACTIONS(254), 1,
      sym_integer,
    ACTIONS(260), 1,
      anon_sym_LBRACK,
    STATE(195), 1,
      sym_index,
    STATE(208), 1,
      sym_value,
    STATE(267), 1,
      sym_expression,
    STATE(274), 1,
      sym_command,
    STATE(282), 1,
      sym_function_call,
    STATE(377), 1,
      sym_if,
    STATE(514), 1,
      sym_statement_kind,
    STATE(530), 1,
      sym_statement,
    STATE(806), 1,
      sym_index_expression,
    STATE(808), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    ACTIONS(258), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(262), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(478), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(252), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(256), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(473), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [7716] = 36,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(5), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_CARET,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    STATE(98), 1,
      sym_index,
    STATE(116), 1,
      sym_value,
    STATE(124), 1,
      sym_expression,
    STATE(127), 1,
      sym_function_call,
    STATE(139), 1,
      sym_command,
    STATE(259), 1,
      sym_if,
    STATE(317), 1,
      sym_statement_kind,
    STATE(326), 1,
      sym_statement,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(234), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [7851] = 36,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(190), 1,
      anon_sym_LPAREN,
    ACTIONS(194), 1,
      aux_sym_command_argument_token2,
    ACTIONS(196), 1,
      anon_sym_async,
    ACTIONS(198), 1,
      anon_sym_LBRACE,
    ACTIONS(200), 1,
      sym_range,
    ACTIONS(202), 1,
      sym_integer,
    ACTIONS(208), 1,
      anon_sym_LBRACK,
    ACTIONS(210), 1,
      anon_sym_if,
    ACTIONS(212), 1,
      anon_sym_match,
    ACTIONS(214), 1,
      anon_sym_loop,
    ACTIONS(216), 1,
      anon_sym_while,
    ACTIONS(218), 1,
      anon_sym_for,
    ACTIONS(220), 1,
      anon_sym_asyncfor,
    ACTIONS(222), 1,
      anon_sym_enum,
    ACTIONS(224), 1,
      anon_sym_struct,
    ACTIONS(228), 1,
      sym_identifier,
    ACTIONS(232), 1,
      anon_sym_CARET,
    STATE(355), 1,
      sym_index,
    STATE(377), 1,
      sym_if,
    STATE(402), 1,
      sym_expression,
    STATE(406), 1,
      sym_function_call,
    STATE(407), 1,
      sym_value,
    STATE(433), 1,
      sym_command,
    STATE(510), 1,
      sym_statement,
    STATE(514), 1,
      sym_statement_kind,
    STATE(828), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(862), 1,
      sym_index_expression,
    ACTIONS(206), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(238), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(478), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(466), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(204), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(368), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(473), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [7986] = 36,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(190), 1,
      anon_sym_LPAREN,
    ACTIONS(194), 1,
      aux_sym_command_argument_token2,
    ACTIONS(196), 1,
      anon_sym_async,
    ACTIONS(198), 1,
      anon_sym_LBRACE,
    ACTIONS(200), 1,
      sym_range,
    ACTIONS(202), 1,
      sym_integer,
    ACTIONS(208), 1,
      anon_sym_LBRACK,
    ACTIONS(210), 1,
      anon_sym_if,
    ACTIONS(212), 1,
      anon_sym_match,
    ACTIONS(214), 1,
      anon_sym_loop,
    ACTIONS(216), 1,
      anon_sym_while,
    ACTIONS(218), 1,
      anon_sym_for,
    ACTIONS(220), 1,
      anon_sym_asyncfor,
    ACTIONS(222), 1,
      anon_sym_enum,
    ACTIONS(224), 1,
      anon_sym_struct,
    ACTIONS(228), 1,
      sym_identifier,
    ACTIONS(232), 1,
      anon_sym_CARET,
    STATE(355), 1,
      sym_index,
    STATE(377), 1,
      sym_if,
    STATE(402), 1,
      sym_expression,
    STATE(406), 1,
      sym_function_call,
    STATE(407), 1,
      sym_value,
    STATE(433), 1,
      sym_command,
    STATE(541), 1,
      sym_statement_kind,
    STATE(706), 1,
      sym_statement,
    STATE(828), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(862), 1,
      sym_index_expression,
    ACTIONS(206), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(230), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(478), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(466), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(204), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(368), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(473), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [8121] = 36,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(317), 1,
      sym_statement_kind,
    STATE(326), 1,
      sym_statement,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(226), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [8256] = 36,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(190), 1,
      anon_sym_LPAREN,
    ACTIONS(194), 1,
      aux_sym_command_argument_token2,
    ACTIONS(196), 1,
      anon_sym_async,
    ACTIONS(198), 1,
      anon_sym_LBRACE,
    ACTIONS(200), 1,
      sym_range,
    ACTIONS(202), 1,
      sym_integer,
    ACTIONS(208), 1,
      anon_sym_LBRACK,
    ACTIONS(210), 1,
      anon_sym_if,
    ACTIONS(212), 1,
      anon_sym_match,
    ACTIONS(214), 1,
      anon_sym_loop,
    ACTIONS(216), 1,
      anon_sym_while,
    ACTIONS(218), 1,
      anon_sym_for,
    ACTIONS(220), 1,
      anon_sym_asyncfor,
    ACTIONS(222), 1,
      anon_sym_enum,
    ACTIONS(224), 1,
      anon_sym_struct,
    ACTIONS(228), 1,
      sym_identifier,
    ACTIONS(232), 1,
      anon_sym_CARET,
    STATE(355), 1,
      sym_index,
    STATE(377), 1,
      sym_if,
    STATE(402), 1,
      sym_expression,
    STATE(406), 1,
      sym_function_call,
    STATE(407), 1,
      sym_value,
    STATE(433), 1,
      sym_command,
    STATE(501), 1,
      sym_statement,
    STATE(514), 1,
      sym_statement_kind,
    STATE(828), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(862), 1,
      sym_index_expression,
    ACTIONS(206), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(238), 2,
      anon_sym_return,
      anon_sym_break,
    STATE(478), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(466), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(204), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(368), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(473), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [8391] = 34,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(196), 1,
      anon_sym_async,
    ACTIONS(210), 1,
      anon_sym_if,
    ACTIONS(212), 1,
      anon_sym_match,
    ACTIONS(214), 1,
      anon_sym_loop,
    ACTIONS(216), 1,
      anon_sym_while,
    ACTIONS(218), 1,
      anon_sym_for,
    ACTIONS(220), 1,
      anon_sym_asyncfor,
    ACTIONS(222), 1,
      anon_sym_enum,
    ACTIONS(224), 1,
      anon_sym_struct,
    ACTIONS(240), 1,
      sym_identifier,
    ACTIONS(244), 1,
      anon_sym_LPAREN,
    ACTIONS(246), 1,
      anon_sym_CARET,
    ACTIONS(248), 1,
      aux_sym_command_argument_token2,
    ACTIONS(250), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym_range,
    ACTIONS(254), 1,
      sym_integer,
    ACTIONS(260), 1,
      anon_sym_LBRACK,
    STATE(195), 1,
      sym_index,
    STATE(208), 1,
      sym_value,
    STATE(267), 1,
      sym_expression,
    STATE(274), 1,
      sym_command,
    STATE(282), 1,
      sym_function_call,
    STATE(377), 1,
      sym_if,
    STATE(542), 1,
      sym_statement_kind,
    STATE(806), 1,
      sym_index_expression,
    STATE(808), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    ACTIONS(258), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(478), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(252), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(256), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(473), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [8519] = 34,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(190), 1,
      anon_sym_LPAREN,
    ACTIONS(194), 1,
      aux_sym_command_argument_token2,
    ACTIONS(196), 1,
      anon_sym_async,
    ACTIONS(198), 1,
      anon_sym_LBRACE,
    ACTIONS(200), 1,
      sym_range,
    ACTIONS(202), 1,
      sym_integer,
    ACTIONS(208), 1,
      anon_sym_LBRACK,
    ACTIONS(210), 1,
      anon_sym_if,
    ACTIONS(212), 1,
      anon_sym_match,
    ACTIONS(214), 1,
      anon_sym_loop,
    ACTIONS(216), 1,
      anon_sym_while,
    ACTIONS(218), 1,
      anon_sym_for,
    ACTIONS(220), 1,
      anon_sym_asyncfor,
    ACTIONS(222), 1,
      anon_sym_enum,
    ACTIONS(224), 1,
      anon_sym_struct,
    ACTIONS(228), 1,
      sym_identifier,
    ACTIONS(232), 1,
      anon_sym_CARET,
    STATE(355), 1,
      sym_index,
    STATE(377), 1,
      sym_if,
    STATE(402), 1,
      sym_expression,
    STATE(406), 1,
      sym_function_call,
    STATE(407), 1,
      sym_value,
    STATE(433), 1,
      sym_command,
    STATE(503), 1,
      sym_statement_kind,
    STATE(828), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(862), 1,
      sym_index_expression,
    ACTIONS(206), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(478), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(466), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(204), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(368), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(473), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [8647] = 34,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(186), 1,
      sym_identifier,
    ACTIONS(190), 1,
      anon_sym_LPAREN,
    ACTIONS(192), 1,
      anon_sym_CARET,
    ACTIONS(194), 1,
      aux_sym_command_argument_token2,
    ACTIONS(196), 1,
      anon_sym_async,
    ACTIONS(198), 1,
      anon_sym_LBRACE,
    ACTIONS(200), 1,
      sym_range,
    ACTIONS(202), 1,
      sym_integer,
    ACTIONS(208), 1,
      anon_sym_LBRACK,
    ACTIONS(210), 1,
      anon_sym_if,
    ACTIONS(212), 1,
      anon_sym_match,
    ACTIONS(214), 1,
      anon_sym_loop,
    ACTIONS(216), 1,
      anon_sym_while,
    ACTIONS(218), 1,
      anon_sym_for,
    ACTIONS(220), 1,
      anon_sym_asyncfor,
    ACTIONS(222), 1,
      anon_sym_enum,
    ACTIONS(224), 1,
      anon_sym_struct,
    STATE(369), 1,
      sym_index,
    STATE(377), 1,
      sym_if,
    STATE(407), 1,
      sym_value,
    STATE(415), 1,
      sym_expression,
    STATE(453), 1,
      sym_function_call,
    STATE(532), 1,
      sym_command,
    STATE(542), 1,
      sym_statement_kind,
    STATE(828), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(862), 1,
      sym_index_expression,
    ACTIONS(206), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(478), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(466), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(204), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(368), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(473), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [8775] = 34,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(196), 1,
      anon_sym_async,
    ACTIONS(210), 1,
      anon_sym_if,
    ACTIONS(212), 1,
      anon_sym_match,
    ACTIONS(214), 1,
      anon_sym_loop,
    ACTIONS(216), 1,
      anon_sym_while,
    ACTIONS(218), 1,
      anon_sym_for,
    ACTIONS(220), 1,
      anon_sym_asyncfor,
    ACTIONS(222), 1,
      anon_sym_enum,
    ACTIONS(224), 1,
      anon_sym_struct,
    ACTIONS(240), 1,
      sym_identifier,
    ACTIONS(244), 1,
      anon_sym_LPAREN,
    ACTIONS(246), 1,
      anon_sym_CARET,
    ACTIONS(248), 1,
      aux_sym_command_argument_token2,
    ACTIONS(250), 1,
      anon_sym_LBRACE,
    ACTIONS(252), 1,
      sym_range,
    ACTIONS(254), 1,
      sym_integer,
    ACTIONS(260), 1,
      anon_sym_LBRACK,
    STATE(195), 1,
      sym_index,
    STATE(208), 1,
      sym_value,
    STATE(267), 1,
      sym_expression,
    STATE(274), 1,
      sym_command,
    STATE(282), 1,
      sym_function_call,
    STATE(377), 1,
      sym_if,
    STATE(503), 1,
      sym_statement_kind,
    STATE(806), 1,
      sym_index_expression,
    STATE(808), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    ACTIONS(258), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(478), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(252), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(256), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(473), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [8903] = 34,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(190), 1,
      anon_sym_LPAREN,
    ACTIONS(194), 1,
      aux_sym_command_argument_token2,
    ACTIONS(196), 1,
      anon_sym_async,
    ACTIONS(198), 1,
      anon_sym_LBRACE,
    ACTIONS(200), 1,
      sym_range,
    ACTIONS(202), 1,
      sym_integer,
    ACTIONS(208), 1,
      anon_sym_LBRACK,
    ACTIONS(210), 1,
      anon_sym_if,
    ACTIONS(212), 1,
      anon_sym_match,
    ACTIONS(214), 1,
      anon_sym_loop,
    ACTIONS(216), 1,
      anon_sym_while,
    ACTIONS(218), 1,
      anon_sym_for,
    ACTIONS(220), 1,
      anon_sym_asyncfor,
    ACTIONS(222), 1,
      anon_sym_enum,
    ACTIONS(224), 1,
      anon_sym_struct,
    ACTIONS(228), 1,
      sym_identifier,
    ACTIONS(232), 1,
      anon_sym_CARET,
    STATE(355), 1,
      sym_index,
    STATE(377), 1,
      sym_if,
    STATE(402), 1,
      sym_expression,
    STATE(406), 1,
      sym_function_call,
    STATE(407), 1,
      sym_value,
    STATE(433), 1,
      sym_command,
    STATE(542), 1,
      sym_statement_kind,
    STATE(828), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(862), 1,
      sym_index_expression,
    ACTIONS(206), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(478), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(466), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(204), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(368), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(473), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [9031] = 34,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(5), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_CARET,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    STATE(98), 1,
      sym_index,
    STATE(116), 1,
      sym_value,
    STATE(124), 1,
      sym_expression,
    STATE(127), 1,
      sym_function_call,
    STATE(139), 1,
      sym_command,
    STATE(259), 1,
      sym_if,
    STATE(320), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [9159] = 34,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(320), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [9287] = 34,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(5), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_CARET,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    STATE(98), 1,
      sym_index,
    STATE(116), 1,
      sym_value,
    STATE(124), 1,
      sym_expression,
    STATE(127), 1,
      sym_function_call,
    STATE(139), 1,
      sym_command,
    STATE(259), 1,
      sym_if,
    STATE(323), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [9415] = 34,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(15), 1,
      anon_sym_async,
    ACTIONS(17), 1,
      anon_sym_LBRACE,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_if,
    ACTIONS(31), 1,
      anon_sym_match,
    ACTIONS(33), 1,
      anon_sym_loop,
    ACTIONS(35), 1,
      anon_sym_while,
    ACTIONS(37), 1,
      anon_sym_for,
    ACTIONS(39), 1,
      anon_sym_asyncfor,
    ACTIONS(41), 1,
      anon_sym_enum,
    ACTIONS(43), 1,
      anon_sym_struct,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(57), 1,
      sym_identifier,
    STATE(101), 1,
      sym_index,
    STATE(115), 1,
      sym_expression,
    STATE(116), 1,
      sym_value,
    STATE(129), 1,
      sym_command,
    STATE(133), 1,
      sym_function_call,
    STATE(259), 1,
      sym_if,
    STATE(323), 1,
      sym_statement_kind,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(322), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(134), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(337), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [9543] = 34,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(186), 1,
      sym_identifier,
    ACTIONS(190), 1,
      anon_sym_LPAREN,
    ACTIONS(192), 1,
      anon_sym_CARET,
    ACTIONS(194), 1,
      aux_sym_command_argument_token2,
    ACTIONS(196), 1,
      anon_sym_async,
    ACTIONS(198), 1,
      anon_sym_LBRACE,
    ACTIONS(200), 1,
      sym_range,
    ACTIONS(202), 1,
      sym_integer,
    ACTIONS(208), 1,
      anon_sym_LBRACK,
    ACTIONS(210), 1,
      anon_sym_if,
    ACTIONS(212), 1,
      anon_sym_match,
    ACTIONS(214), 1,
      anon_sym_loop,
    ACTIONS(216), 1,
      anon_sym_while,
    ACTIONS(218), 1,
      anon_sym_for,
    ACTIONS(220), 1,
      anon_sym_asyncfor,
    ACTIONS(222), 1,
      anon_sym_enum,
    ACTIONS(224), 1,
      anon_sym_struct,
    STATE(369), 1,
      sym_index,
    STATE(377), 1,
      sym_if,
    STATE(407), 1,
      sym_value,
    STATE(415), 1,
      sym_expression,
    STATE(453), 1,
      sym_function_call,
    STATE(503), 1,
      sym_statement_kind,
    STATE(532), 1,
      sym_command,
    STATE(828), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(862), 1,
      sym_index_expression,
    ACTIONS(206), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(478), 2,
      sym_enum_definition,
      sym_struct_definition,
    STATE(466), 4,
      sym__expression_kind,
      sym_as_node,
      sym_math,
      sym_logic,
    ACTIONS(204), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(368), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
    STATE(473), 10,
      sym_pipe,
      sym_block,
      sym_assignment,
      sym_index_assignment,
      sym_if_else,
      sym_match,
      sym_loop_node,
      sym_while,
      sym_for,
      sym_type_definition,
  [9671] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(264), 24,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_GT,
      anon_sym_asyncfor,
    ACTIONS(266), 25,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [9728] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(268), 24,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_GT,
      anon_sym_asyncfor,
    ACTIONS(270), 25,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [9785] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(272), 24,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_GT,
      anon_sym_asyncfor,
    ACTIONS(274), 25,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [9842] = 11,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(282), 1,
      anon_sym_EQ,
    ACTIONS(284), 1,
      anon_sym_COLON,
    ACTIONS(286), 1,
      anon_sym_LT,
    ACTIONS(290), 1,
      anon_sym_COLON_COLON,
    STATE(45), 1,
      sym_assignment_operator,
    STATE(693), 1,
      sym_type_specification,
    ACTIONS(288), 2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
    ACTIONS(278), 17,
      anon_sym_SEMI,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_asyncfor,
    ACTIONS(276), 23,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [9915] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(292), 24,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_GT,
      anon_sym_asyncfor,
    ACTIONS(294), 25,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [9972] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(296), 24,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_GT,
      anon_sym_asyncfor,
    ACTIONS(298), 25,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [10029] = 11,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(284), 1,
      anon_sym_COLON,
    ACTIONS(286), 1,
      anon_sym_LT,
    ACTIONS(290), 1,
      anon_sym_COLON_COLON,
    ACTIONS(300), 1,
      anon_sym_EQ,
    STATE(51), 1,
      sym_assignment_operator,
    STATE(691), 1,
      sym_type_specification,
    ACTIONS(288), 2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
    ACTIONS(278), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_asyncfor,
    ACTIONS(276), 23,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [10102] = 11,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(284), 1,
      anon_sym_COLON,
    ACTIONS(286), 1,
      anon_sym_LT,
    ACTIONS(290), 1,
      anon_sym_COLON_COLON,
    ACTIONS(300), 1,
      anon_sym_EQ,
    STATE(45), 1,
      sym_assignment_operator,
    STATE(689), 1,
      sym_type_specification,
    ACTIONS(288), 2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
    ACTIONS(278), 17,
      anon_sym_SEMI,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_asyncfor,
    ACTIONS(276), 23,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [10175] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(302), 24,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_GT,
      anon_sym_asyncfor,
    ACTIONS(304), 25,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [10232] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(306), 24,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_GT,
      anon_sym_asyncfor,
    ACTIONS(308), 25,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [10289] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(310), 24,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_GT,
      anon_sym_asyncfor,
    ACTIONS(312), 25,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [10346] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(314), 24,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_GT,
      anon_sym_asyncfor,
    ACTIONS(316), 25,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [10403] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(318), 24,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_GT,
      anon_sym_asyncfor,
    ACTIONS(320), 25,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [10460] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(322), 24,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_GT,
      anon_sym_asyncfor,
    ACTIONS(324), 25,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [10517] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(326), 23,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_asyncfor,
    ACTIONS(284), 25,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [10573] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(332), 1,
      anon_sym_LPAREN,
    ACTIONS(328), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_asyncfor,
    ACTIONS(330), 25,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [10631] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(290), 1,
      anon_sym_COLON_COLON,
    ACTIONS(326), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_asyncfor,
    ACTIONS(284), 26,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [10689] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(334), 23,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_asyncfor,
    ACTIONS(336), 25,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [10745] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(338), 23,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_asyncfor,
    ACTIONS(340), 25,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [10801] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(326), 23,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_asyncfor,
    ACTIONS(284), 25,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [10857] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(342), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_asyncfor,
    ACTIONS(344), 25,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [10912] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(346), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_asyncfor,
    ACTIONS(348), 25,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [10967] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(300), 1,
      anon_sym_EQ,
    ACTIONS(326), 1,
      anon_sym_COLON,
    STATE(48), 1,
      sym_assignment_operator,
    ACTIONS(288), 2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
    ACTIONS(278), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_asyncfor,
    ACTIONS(276), 24,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [11032] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(350), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_asyncfor,
    ACTIONS(352), 25,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [11087] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(354), 22,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_asyncfor,
    ACTIONS(356), 25,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [11142] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(300), 1,
      anon_sym_EQ,
    ACTIONS(326), 1,
      anon_sym_COLON,
    STATE(55), 1,
      sym_assignment_operator,
    ACTIONS(288), 2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
    ACTIONS(278), 17,
      anon_sym_SEMI,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_asyncfor,
    ACTIONS(276), 24,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [11207] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(364), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(104), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(362), 4,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_asyncfor,
    ACTIONS(358), 38,
      anon_sym_return,
      anon_sym_break,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_identifier,
      sym_range,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [11265] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(370), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(106), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(366), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_asyncfor,
    ACTIONS(368), 37,
      anon_sym_return,
      anon_sym_break,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_async,
      anon_sym_LBRACE,
      sym_identifier,
      sym_range,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [11323] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(364), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(107), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(366), 4,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_asyncfor,
    ACTIONS(368), 38,
      anon_sym_return,
      anon_sym_break,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_identifier,
      sym_range,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [11381] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(370), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(103), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(362), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_asyncfor,
    ACTIONS(358), 37,
      anon_sym_return,
      anon_sym_break,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_async,
      anon_sym_LBRACE,
      sym_identifier,
      sym_range,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [11439] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(376), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(106), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(372), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_asyncfor,
    ACTIONS(374), 37,
      anon_sym_return,
      anon_sym_break,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_async,
      anon_sym_LBRACE,
      sym_identifier,
      sym_range,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [11497] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(379), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(107), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(372), 4,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_asyncfor,
    ACTIONS(374), 38,
      anon_sym_return,
      anon_sym_break,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_identifier,
      sym_range,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [11555] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(382), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_asyncfor,
    ACTIONS(384), 25,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [11608] = 6,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(284), 1,
      anon_sym_COLON,
    ACTIONS(290), 1,
      anon_sym_COLON_COLON,
    ACTIONS(278), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_asyncfor,
    ACTIONS(276), 24,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [11667] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(386), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_asyncfor,
    ACTIONS(388), 25,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [11720] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(326), 1,
      anon_sym_COLON,
    ACTIONS(306), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_asyncfor,
    ACTIONS(308), 24,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [11775] = 3,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(390), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_asyncfor,
    ACTIONS(392), 39,
      anon_sym_return,
      anon_sym_break,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_PIPE,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
      anon_sym_async,
      anon_sym_LBRACE,
      sym_identifier,
      sym_range,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [11827] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(354), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_asyncfor,
    ACTIONS(356), 24,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [11879] = 5,
    ACTIONS(3), 1,
      sym__comment,
    STATE(226), 1,
      sym_math_operator,
    STATE(228), 1,
      sym_logic_operator,
    ACTIONS(396), 18,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_asyncfor,
    ACTIONS(394), 24,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [11935] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(402), 1,
      anon_sym_as,
    STATE(226), 1,
      sym_math_operator,
    STATE(228), 1,
      sym_logic_operator,
    ACTIONS(404), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(410), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(406), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(408), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(400), 9,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_asyncfor,
    ACTIONS(398), 19,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [12001] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_COLON,
    ACTIONS(278), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_asyncfor,
    ACTIONS(276), 24,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [12057] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(416), 1,
      anon_sym_LT,
    STATE(132), 1,
      sym_type_arguments,
    ACTIONS(412), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_asyncfor,
    ACTIONS(414), 23,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [12113] = 3,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(390), 4,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
      anon_sym_asyncfor,
    ACTIONS(392), 40,
      anon_sym_return,
      anon_sym_break,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_PIPE,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_identifier,
      sym_range,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [12165] = 5,
    ACTIONS(3), 1,
      sym__comment,
    STATE(233), 1,
      sym_logic_operator,
    STATE(234), 1,
      sym_math_operator,
    ACTIONS(418), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_asyncfor,
    ACTIONS(420), 24,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [12221] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(426), 1,
      anon_sym_DASH_GT,
    ACTIONS(422), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_asyncfor,
    ACTIONS(424), 24,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [12275] = 5,
    ACTIONS(3), 1,
      sym__comment,
    STATE(233), 1,
      sym_logic_operator,
    STATE(234), 1,
      sym_math_operator,
    ACTIONS(396), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_asyncfor,
    ACTIONS(394), 24,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [12331] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(432), 1,
      anon_sym_DASH_GT,
    ACTIONS(428), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_asyncfor,
    ACTIONS(430), 24,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [12385] = 5,
    ACTIONS(3), 1,
      sym__comment,
    STATE(226), 1,
      sym_math_operator,
    STATE(228), 1,
      sym_logic_operator,
    ACTIONS(418), 18,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_asyncfor,
    ACTIONS(420), 24,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [12441] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(402), 1,
      anon_sym_as,
    STATE(233), 1,
      sym_logic_operator,
    STATE(234), 1,
      sym_math_operator,
    ACTIONS(404), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(410), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(406), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(408), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(400), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_asyncfor,
    ACTIONS(398), 19,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [12507] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(434), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_asyncfor,
    ACTIONS(436), 24,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [12558] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(438), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_asyncfor,
    ACTIONS(440), 24,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [12609] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(442), 1,
      anon_sym_PIPE,
    ACTIONS(278), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_asyncfor,
    ACTIONS(276), 24,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [12664] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(444), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_asyncfor,
    ACTIONS(446), 24,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [12715] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(448), 1,
      anon_sym_PIPE,
    ACTIONS(278), 18,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_asyncfor,
    ACTIONS(276), 24,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [12768] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(428), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_asyncfor,
    ACTIONS(430), 24,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [12819] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(450), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_asyncfor,
    ACTIONS(452), 24,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [12870] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(422), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_asyncfor,
    ACTIONS(424), 24,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [12921] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(448), 1,
      anon_sym_PIPE,
    ACTIONS(278), 17,
      anon_sym_SEMI,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_asyncfor,
    ACTIONS(276), 24,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [12976] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(454), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_asyncfor,
    ACTIONS(456), 24,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [13027] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(458), 1,
      anon_sym_LT,
    ACTIONS(412), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_asyncfor,
    ACTIONS(414), 23,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [13080] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(278), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_asyncfor,
    ACTIONS(276), 24,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [13133] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(412), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_asyncfor,
    ACTIONS(414), 24,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [13184] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(460), 19,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_asyncfor,
    ACTIONS(462), 24,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [13235] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(442), 1,
      anon_sym_PIPE,
    ACTIONS(278), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_asyncfor,
    ACTIONS(276), 24,
      anon_sym_return,
      anon_sym_break,
      anon_sym_as,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [13288] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(464), 1,
      anon_sym_COLON_COLON,
    ACTIONS(284), 16,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(326), 22,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [13337] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(270), 15,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(268), 23,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [13383] = 11,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(284), 1,
      anon_sym_COLON,
    ACTIONS(286), 1,
      anon_sym_LT,
    ACTIONS(300), 1,
      anon_sym_EQ,
    ACTIONS(464), 1,
      anon_sym_COLON_COLON,
    STATE(57), 1,
      sym_assignment_operator,
    STATE(688), 1,
      sym_type_specification,
    ACTIONS(288), 2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
    ACTIONS(276), 13,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(278), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [13445] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(348), 15,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(346), 23,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [13491] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(344), 15,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(342), 23,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [13537] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(284), 15,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(326), 23,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [13583] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(274), 15,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(272), 23,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [13629] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(356), 15,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(354), 23,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [13675] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(298), 15,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(296), 23,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [13721] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(352), 15,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(350), 23,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [13767] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(266), 15,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(264), 23,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [13813] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(294), 15,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(292), 23,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [13859] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(308), 15,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(306), 23,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [13905] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(340), 15,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(338), 23,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [13951] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(284), 15,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(326), 23,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [13997] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(320), 15,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(318), 23,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [14043] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(304), 15,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(302), 23,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [14089] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(312), 15,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(310), 23,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [14135] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(466), 1,
      anon_sym_LPAREN,
    ACTIONS(330), 15,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(328), 22,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [14183] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(316), 15,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(314), 23,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [14229] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(324), 15,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(322), 23,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [14275] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(336), 15,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(334), 23,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [14321] = 21,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(468), 1,
      sym_identifier,
    ACTIONS(470), 1,
      anon_sym_LPAREN,
    ACTIONS(472), 1,
      anon_sym_RPAREN,
    ACTIONS(474), 1,
      anon_sym_CARET,
    ACTIONS(476), 1,
      aux_sym_command_argument_token2,
    ACTIONS(478), 1,
      anon_sym_LBRACE,
    ACTIONS(480), 1,
      sym_range,
    ACTIONS(482), 1,
      sym_integer,
    ACTIONS(488), 1,
      anon_sym_LBRACK,
    STATE(611), 1,
      sym_function_call,
    STATE(613), 1,
      sym_expression,
    STATE(709), 1,
      aux_sym_function_repeat1,
    STATE(763), 1,
      sym__function_expression_kind,
    STATE(821), 1,
      sym_function_expression,
    STATE(844), 1,
      sym_index_expression,
    ACTIONS(486), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(477), 2,
      sym_value,
      sym_index,
    ACTIONS(484), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(650), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(467), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [14402] = 21,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(244), 1,
      anon_sym_LPAREN,
    ACTIONS(248), 1,
      aux_sym_command_argument_token2,
    ACTIONS(252), 1,
      sym_range,
    ACTIONS(254), 1,
      sym_integer,
    ACTIONS(260), 1,
      anon_sym_LBRACK,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_RPAREN,
    ACTIONS(494), 1,
      anon_sym_CARET,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    STATE(194), 1,
      aux_sym__expression_list,
    STATE(247), 1,
      sym_function_call,
    STATE(264), 1,
      sym_expression,
    STATE(806), 1,
      sym_index_expression,
    STATE(808), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    ACTIONS(258), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(208), 2,
      sym_value,
      sym_index,
    ACTIONS(256), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(252), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [14483] = 21,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(244), 1,
      anon_sym_LPAREN,
    ACTIONS(248), 1,
      aux_sym_command_argument_token2,
    ACTIONS(252), 1,
      sym_range,
    ACTIONS(254), 1,
      sym_integer,
    ACTIONS(260), 1,
      anon_sym_LBRACK,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(494), 1,
      anon_sym_CARET,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(498), 1,
      anon_sym_RPAREN,
    STATE(166), 1,
      aux_sym__expression_list,
    STATE(247), 1,
      sym_function_call,
    STATE(264), 1,
      sym_expression,
    STATE(806), 1,
      sym_index_expression,
    STATE(808), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    ACTIONS(258), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(208), 2,
      sym_value,
      sym_index,
    ACTIONS(256), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(252), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [14564] = 21,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(244), 1,
      anon_sym_LPAREN,
    ACTIONS(248), 1,
      aux_sym_command_argument_token2,
    ACTIONS(252), 1,
      sym_range,
    ACTIONS(254), 1,
      sym_integer,
    ACTIONS(260), 1,
      anon_sym_LBRACK,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(494), 1,
      anon_sym_CARET,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(500), 1,
      anon_sym_RPAREN,
    STATE(178), 1,
      aux_sym__expression_list,
    STATE(247), 1,
      sym_function_call,
    STATE(264), 1,
      sym_expression,
    STATE(806), 1,
      sym_index_expression,
    STATE(808), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    ACTIONS(258), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(208), 2,
      sym_value,
      sym_index,
    ACTIONS(256), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(252), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [14645] = 21,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(244), 1,
      anon_sym_LPAREN,
    ACTIONS(248), 1,
      aux_sym_command_argument_token2,
    ACTIONS(252), 1,
      sym_range,
    ACTIONS(254), 1,
      sym_integer,
    ACTIONS(260), 1,
      anon_sym_LBRACK,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(494), 1,
      anon_sym_CARET,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(502), 1,
      anon_sym_RPAREN,
    STATE(186), 1,
      aux_sym__expression_list,
    STATE(247), 1,
      sym_function_call,
    STATE(264), 1,
      sym_expression,
    STATE(806), 1,
      sym_index_expression,
    STATE(808), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    ACTIONS(258), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(208), 2,
      sym_value,
      sym_index,
    ACTIONS(256), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(252), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [14726] = 21,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(468), 1,
      sym_identifier,
    ACTIONS(470), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_CARET,
    ACTIONS(476), 1,
      aux_sym_command_argument_token2,
    ACTIONS(478), 1,
      anon_sym_LBRACE,
    ACTIONS(480), 1,
      sym_range,
    ACTIONS(482), 1,
      sym_integer,
    ACTIONS(488), 1,
      anon_sym_LBRACK,
    ACTIONS(504), 1,
      anon_sym_RPAREN,
    STATE(611), 1,
      sym_function_call,
    STATE(613), 1,
      sym_expression,
    STATE(711), 1,
      aux_sym_function_repeat1,
    STATE(763), 1,
      sym__function_expression_kind,
    STATE(821), 1,
      sym_function_expression,
    STATE(844), 1,
      sym_index_expression,
    ACTIONS(486), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(477), 2,
      sym_value,
      sym_index,
    ACTIONS(484), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(662), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(467), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [14807] = 21,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(244), 1,
      anon_sym_LPAREN,
    ACTIONS(248), 1,
      aux_sym_command_argument_token2,
    ACTIONS(252), 1,
      sym_range,
    ACTIONS(254), 1,
      sym_integer,
    ACTIONS(260), 1,
      anon_sym_LBRACK,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(494), 1,
      anon_sym_CARET,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(506), 1,
      anon_sym_RPAREN,
    STATE(186), 1,
      aux_sym__expression_list,
    STATE(247), 1,
      sym_function_call,
    STATE(264), 1,
      sym_expression,
    STATE(806), 1,
      sym_index_expression,
    STATE(808), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    ACTIONS(258), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(208), 2,
      sym_value,
      sym_index,
    ACTIONS(256), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(252), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [14888] = 21,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(244), 1,
      anon_sym_LPAREN,
    ACTIONS(248), 1,
      aux_sym_command_argument_token2,
    ACTIONS(252), 1,
      sym_range,
    ACTIONS(254), 1,
      sym_integer,
    ACTIONS(260), 1,
      anon_sym_LBRACK,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(508), 1,
      anon_sym_CARET,
    ACTIONS(510), 1,
      anon_sym_RBRACK,
    STATE(191), 1,
      aux_sym_list_repeat1,
    STATE(247), 1,
      sym_function_call,
    STATE(271), 1,
      sym_expression,
    STATE(806), 1,
      sym_index_expression,
    STATE(808), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    ACTIONS(258), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(208), 2,
      sym_value,
      sym_index,
    ACTIONS(256), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(252), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [14969] = 21,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(468), 1,
      sym_identifier,
    ACTIONS(470), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_CARET,
    ACTIONS(476), 1,
      aux_sym_command_argument_token2,
    ACTIONS(478), 1,
      anon_sym_LBRACE,
    ACTIONS(480), 1,
      sym_range,
    ACTIONS(482), 1,
      sym_integer,
    ACTIONS(488), 1,
      anon_sym_LBRACK,
    ACTIONS(512), 1,
      anon_sym_RPAREN,
    STATE(611), 1,
      sym_function_call,
    STATE(613), 1,
      sym_expression,
    STATE(739), 1,
      aux_sym_function_repeat1,
    STATE(763), 1,
      sym__function_expression_kind,
    STATE(821), 1,
      sym_function_expression,
    STATE(844), 1,
      sym_index_expression,
    ACTIONS(486), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(477), 2,
      sym_value,
      sym_index,
    ACTIONS(484), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(651), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(467), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [15050] = 21,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(468), 1,
      sym_identifier,
    ACTIONS(470), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_CARET,
    ACTIONS(476), 1,
      aux_sym_command_argument_token2,
    ACTIONS(478), 1,
      anon_sym_LBRACE,
    ACTIONS(480), 1,
      sym_range,
    ACTIONS(482), 1,
      sym_integer,
    ACTIONS(488), 1,
      anon_sym_LBRACK,
    ACTIONS(514), 1,
      anon_sym_RPAREN,
    STATE(611), 1,
      sym_function_call,
    STATE(613), 1,
      sym_expression,
    STATE(699), 1,
      aux_sym_function_repeat1,
    STATE(763), 1,
      sym__function_expression_kind,
    STATE(821), 1,
      sym_function_expression,
    STATE(844), 1,
      sym_index_expression,
    ACTIONS(486), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(477), 2,
      sym_value,
      sym_index,
    ACTIONS(484), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(652), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(467), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [15131] = 21,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(468), 1,
      sym_identifier,
    ACTIONS(470), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_CARET,
    ACTIONS(476), 1,
      aux_sym_command_argument_token2,
    ACTIONS(478), 1,
      anon_sym_LBRACE,
    ACTIONS(480), 1,
      sym_range,
    ACTIONS(482), 1,
      sym_integer,
    ACTIONS(488), 1,
      anon_sym_LBRACK,
    ACTIONS(516), 1,
      anon_sym_RPAREN,
    STATE(611), 1,
      sym_function_call,
    STATE(613), 1,
      sym_expression,
    STATE(704), 1,
      aux_sym_function_repeat1,
    STATE(763), 1,
      sym__function_expression_kind,
    STATE(821), 1,
      sym_function_expression,
    STATE(844), 1,
      sym_index_expression,
    ACTIONS(486), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(477), 2,
      sym_value,
      sym_index,
    ACTIONS(484), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(659), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(467), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [15212] = 21,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(244), 1,
      anon_sym_LPAREN,
    ACTIONS(248), 1,
      aux_sym_command_argument_token2,
    ACTIONS(252), 1,
      sym_range,
    ACTIONS(254), 1,
      sym_integer,
    ACTIONS(260), 1,
      anon_sym_LBRACK,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(508), 1,
      anon_sym_CARET,
    ACTIONS(518), 1,
      anon_sym_RBRACK,
    STATE(177), 1,
      aux_sym_list_repeat1,
    STATE(247), 1,
      sym_function_call,
    STATE(271), 1,
      sym_expression,
    STATE(806), 1,
      sym_index_expression,
    STATE(808), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    ACTIONS(258), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(208), 2,
      sym_value,
      sym_index,
    ACTIONS(256), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(252), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [15293] = 21,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(244), 1,
      anon_sym_LPAREN,
    ACTIONS(248), 1,
      aux_sym_command_argument_token2,
    ACTIONS(252), 1,
      sym_range,
    ACTIONS(254), 1,
      sym_integer,
    ACTIONS(260), 1,
      anon_sym_LBRACK,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(494), 1,
      anon_sym_CARET,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(520), 1,
      anon_sym_RPAREN,
    STATE(186), 1,
      aux_sym__expression_list,
    STATE(247), 1,
      sym_function_call,
    STATE(264), 1,
      sym_expression,
    STATE(806), 1,
      sym_index_expression,
    STATE(808), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    ACTIONS(258), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(208), 2,
      sym_value,
      sym_index,
    ACTIONS(256), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(252), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [15374] = 21,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(522), 1,
      sym_identifier,
    ACTIONS(525), 1,
      anon_sym_LPAREN,
    ACTIONS(528), 1,
      anon_sym_CARET,
    ACTIONS(531), 1,
      aux_sym_command_argument_token2,
    ACTIONS(534), 1,
      anon_sym_LBRACE,
    ACTIONS(537), 1,
      sym_range,
    ACTIONS(540), 1,
      sym_integer,
    ACTIONS(549), 1,
      anon_sym_LBRACK,
    ACTIONS(552), 1,
      anon_sym_RBRACK,
    STATE(175), 1,
      aux_sym_list_repeat1,
    STATE(247), 1,
      sym_function_call,
    STATE(271), 1,
      sym_expression,
    STATE(806), 1,
      sym_index_expression,
    STATE(808), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    ACTIONS(546), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(208), 2,
      sym_value,
      sym_index,
    ACTIONS(543), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(252), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [15455] = 21,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(244), 1,
      anon_sym_LPAREN,
    ACTIONS(248), 1,
      aux_sym_command_argument_token2,
    ACTIONS(252), 1,
      sym_range,
    ACTIONS(254), 1,
      sym_integer,
    ACTIONS(260), 1,
      anon_sym_LBRACK,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(494), 1,
      anon_sym_CARET,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(554), 1,
      anon_sym_RPAREN,
    STATE(174), 1,
      aux_sym__expression_list,
    STATE(247), 1,
      sym_function_call,
    STATE(264), 1,
      sym_expression,
    STATE(806), 1,
      sym_index_expression,
    STATE(808), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    ACTIONS(258), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(208), 2,
      sym_value,
      sym_index,
    ACTIONS(256), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(252), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [15536] = 21,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(244), 1,
      anon_sym_LPAREN,
    ACTIONS(248), 1,
      aux_sym_command_argument_token2,
    ACTIONS(252), 1,
      sym_range,
    ACTIONS(254), 1,
      sym_integer,
    ACTIONS(260), 1,
      anon_sym_LBRACK,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(508), 1,
      anon_sym_CARET,
    ACTIONS(556), 1,
      anon_sym_RBRACK,
    STATE(175), 1,
      aux_sym_list_repeat1,
    STATE(247), 1,
      sym_function_call,
    STATE(271), 1,
      sym_expression,
    STATE(806), 1,
      sym_index_expression,
    STATE(808), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    ACTIONS(258), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(208), 2,
      sym_value,
      sym_index,
    ACTIONS(256), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(252), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [15617] = 21,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(244), 1,
      anon_sym_LPAREN,
    ACTIONS(248), 1,
      aux_sym_command_argument_token2,
    ACTIONS(252), 1,
      sym_range,
    ACTIONS(254), 1,
      sym_integer,
    ACTIONS(260), 1,
      anon_sym_LBRACK,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(494), 1,
      anon_sym_CARET,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(558), 1,
      anon_sym_RPAREN,
    STATE(186), 1,
      aux_sym__expression_list,
    STATE(247), 1,
      sym_function_call,
    STATE(264), 1,
      sym_expression,
    STATE(806), 1,
      sym_index_expression,
    STATE(808), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    ACTIONS(258), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(208), 2,
      sym_value,
      sym_index,
    ACTIONS(256), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(252), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [15698] = 21,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(244), 1,
      anon_sym_LPAREN,
    ACTIONS(248), 1,
      aux_sym_command_argument_token2,
    ACTIONS(252), 1,
      sym_range,
    ACTIONS(254), 1,
      sym_integer,
    ACTIONS(260), 1,
      anon_sym_LBRACK,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(508), 1,
      anon_sym_CARET,
    ACTIONS(560), 1,
      anon_sym_RBRACK,
    STATE(175), 1,
      aux_sym_list_repeat1,
    STATE(247), 1,
      sym_function_call,
    STATE(271), 1,
      sym_expression,
    STATE(806), 1,
      sym_index_expression,
    STATE(808), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    ACTIONS(258), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(208), 2,
      sym_value,
      sym_index,
    ACTIONS(256), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(252), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [15779] = 21,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(244), 1,
      anon_sym_LPAREN,
    ACTIONS(248), 1,
      aux_sym_command_argument_token2,
    ACTIONS(252), 1,
      sym_range,
    ACTIONS(254), 1,
      sym_integer,
    ACTIONS(260), 1,
      anon_sym_LBRACK,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(508), 1,
      anon_sym_CARET,
    ACTIONS(562), 1,
      anon_sym_RBRACK,
    STATE(187), 1,
      aux_sym_list_repeat1,
    STATE(247), 1,
      sym_function_call,
    STATE(271), 1,
      sym_expression,
    STATE(806), 1,
      sym_index_expression,
    STATE(808), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    ACTIONS(258), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(208), 2,
      sym_value,
      sym_index,
    ACTIONS(256), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(252), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [15860] = 21,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(244), 1,
      anon_sym_LPAREN,
    ACTIONS(248), 1,
      aux_sym_command_argument_token2,
    ACTIONS(252), 1,
      sym_range,
    ACTIONS(254), 1,
      sym_integer,
    ACTIONS(260), 1,
      anon_sym_LBRACK,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(494), 1,
      anon_sym_CARET,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(564), 1,
      anon_sym_RPAREN,
    STATE(186), 1,
      aux_sym__expression_list,
    STATE(247), 1,
      sym_function_call,
    STATE(264), 1,
      sym_expression,
    STATE(806), 1,
      sym_index_expression,
    STATE(808), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    ACTIONS(258), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(208), 2,
      sym_value,
      sym_index,
    ACTIONS(256), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(252), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [15941] = 21,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(244), 1,
      anon_sym_LPAREN,
    ACTIONS(248), 1,
      aux_sym_command_argument_token2,
    ACTIONS(252), 1,
      sym_range,
    ACTIONS(254), 1,
      sym_integer,
    ACTIONS(260), 1,
      anon_sym_LBRACK,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(494), 1,
      anon_sym_CARET,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(566), 1,
      anon_sym_RPAREN,
    STATE(186), 1,
      aux_sym__expression_list,
    STATE(247), 1,
      sym_function_call,
    STATE(264), 1,
      sym_expression,
    STATE(806), 1,
      sym_index_expression,
    STATE(808), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    ACTIONS(258), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(208), 2,
      sym_value,
      sym_index,
    ACTIONS(256), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(252), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [16022] = 21,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(244), 1,
      anon_sym_LPAREN,
    ACTIONS(248), 1,
      aux_sym_command_argument_token2,
    ACTIONS(252), 1,
      sym_range,
    ACTIONS(254), 1,
      sym_integer,
    ACTIONS(260), 1,
      anon_sym_LBRACK,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(508), 1,
      anon_sym_CARET,
    ACTIONS(568), 1,
      anon_sym_RBRACK,
    STATE(175), 1,
      aux_sym_list_repeat1,
    STATE(247), 1,
      sym_function_call,
    STATE(271), 1,
      sym_expression,
    STATE(806), 1,
      sym_index_expression,
    STATE(808), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    ACTIONS(258), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(208), 2,
      sym_value,
      sym_index,
    ACTIONS(256), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(252), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [16103] = 21,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(244), 1,
      anon_sym_LPAREN,
    ACTIONS(248), 1,
      aux_sym_command_argument_token2,
    ACTIONS(252), 1,
      sym_range,
    ACTIONS(254), 1,
      sym_integer,
    ACTIONS(260), 1,
      anon_sym_LBRACK,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(494), 1,
      anon_sym_CARET,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(570), 1,
      anon_sym_RPAREN,
    STATE(168), 1,
      aux_sym__expression_list,
    STATE(247), 1,
      sym_function_call,
    STATE(264), 1,
      sym_expression,
    STATE(806), 1,
      sym_index_expression,
    STATE(808), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    ACTIONS(258), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(208), 2,
      sym_value,
      sym_index,
    ACTIONS(256), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(252), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [16184] = 21,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(244), 1,
      anon_sym_LPAREN,
    ACTIONS(248), 1,
      aux_sym_command_argument_token2,
    ACTIONS(252), 1,
      sym_range,
    ACTIONS(254), 1,
      sym_integer,
    ACTIONS(260), 1,
      anon_sym_LBRACK,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(494), 1,
      anon_sym_CARET,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(572), 1,
      anon_sym_RPAREN,
    STATE(181), 1,
      aux_sym__expression_list,
    STATE(247), 1,
      sym_function_call,
    STATE(264), 1,
      sym_expression,
    STATE(806), 1,
      sym_index_expression,
    STATE(808), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    ACTIONS(258), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(208), 2,
      sym_value,
      sym_index,
    ACTIONS(256), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(252), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [16265] = 21,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(574), 1,
      sym_identifier,
    ACTIONS(577), 1,
      anon_sym_LPAREN,
    ACTIONS(580), 1,
      anon_sym_RPAREN,
    ACTIONS(582), 1,
      anon_sym_CARET,
    ACTIONS(585), 1,
      aux_sym_command_argument_token2,
    ACTIONS(588), 1,
      anon_sym_LBRACE,
    ACTIONS(591), 1,
      sym_range,
    ACTIONS(594), 1,
      sym_integer,
    ACTIONS(603), 1,
      anon_sym_LBRACK,
    STATE(186), 1,
      aux_sym__expression_list,
    STATE(247), 1,
      sym_function_call,
    STATE(264), 1,
      sym_expression,
    STATE(806), 1,
      sym_index_expression,
    STATE(808), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    ACTIONS(600), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(208), 2,
      sym_value,
      sym_index,
    ACTIONS(597), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(252), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [16346] = 21,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(244), 1,
      anon_sym_LPAREN,
    ACTIONS(248), 1,
      aux_sym_command_argument_token2,
    ACTIONS(252), 1,
      sym_range,
    ACTIONS(254), 1,
      sym_integer,
    ACTIONS(260), 1,
      anon_sym_LBRACK,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(508), 1,
      anon_sym_CARET,
    ACTIONS(606), 1,
      anon_sym_RBRACK,
    STATE(175), 1,
      aux_sym_list_repeat1,
    STATE(247), 1,
      sym_function_call,
    STATE(271), 1,
      sym_expression,
    STATE(806), 1,
      sym_index_expression,
    STATE(808), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    ACTIONS(258), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(208), 2,
      sym_value,
      sym_index,
    ACTIONS(256), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(252), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [16427] = 21,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(244), 1,
      anon_sym_LPAREN,
    ACTIONS(248), 1,
      aux_sym_command_argument_token2,
    ACTIONS(252), 1,
      sym_range,
    ACTIONS(254), 1,
      sym_integer,
    ACTIONS(260), 1,
      anon_sym_LBRACK,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(508), 1,
      anon_sym_CARET,
    ACTIONS(608), 1,
      anon_sym_RBRACK,
    STATE(179), 1,
      aux_sym_list_repeat1,
    STATE(247), 1,
      sym_function_call,
    STATE(271), 1,
      sym_expression,
    STATE(806), 1,
      sym_index_expression,
    STATE(808), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    ACTIONS(258), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(208), 2,
      sym_value,
      sym_index,
    ACTIONS(256), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(252), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [16508] = 21,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(244), 1,
      anon_sym_LPAREN,
    ACTIONS(248), 1,
      aux_sym_command_argument_token2,
    ACTIONS(252), 1,
      sym_range,
    ACTIONS(254), 1,
      sym_integer,
    ACTIONS(260), 1,
      anon_sym_LBRACK,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(494), 1,
      anon_sym_CARET,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(610), 1,
      anon_sym_RPAREN,
    STATE(186), 1,
      aux_sym__expression_list,
    STATE(247), 1,
      sym_function_call,
    STATE(264), 1,
      sym_expression,
    STATE(806), 1,
      sym_index_expression,
    STATE(808), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    ACTIONS(258), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(208), 2,
      sym_value,
      sym_index,
    ACTIONS(256), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(252), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [16589] = 21,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(244), 1,
      anon_sym_LPAREN,
    ACTIONS(248), 1,
      aux_sym_command_argument_token2,
    ACTIONS(252), 1,
      sym_range,
    ACTIONS(254), 1,
      sym_integer,
    ACTIONS(260), 1,
      anon_sym_LBRACK,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(508), 1,
      anon_sym_CARET,
    ACTIONS(612), 1,
      anon_sym_RBRACK,
    STATE(183), 1,
      aux_sym_list_repeat1,
    STATE(247), 1,
      sym_function_call,
    STATE(271), 1,
      sym_expression,
    STATE(806), 1,
      sym_index_expression,
    STATE(808), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    ACTIONS(258), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(208), 2,
      sym_value,
      sym_index,
    ACTIONS(256), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(252), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [16670] = 21,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(244), 1,
      anon_sym_LPAREN,
    ACTIONS(248), 1,
      aux_sym_command_argument_token2,
    ACTIONS(252), 1,
      sym_range,
    ACTIONS(254), 1,
      sym_integer,
    ACTIONS(260), 1,
      anon_sym_LBRACK,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(508), 1,
      anon_sym_CARET,
    ACTIONS(614), 1,
      anon_sym_RBRACK,
    STATE(175), 1,
      aux_sym_list_repeat1,
    STATE(247), 1,
      sym_function_call,
    STATE(271), 1,
      sym_expression,
    STATE(806), 1,
      sym_index_expression,
    STATE(808), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    ACTIONS(258), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(208), 2,
      sym_value,
      sym_index,
    ACTIONS(256), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(252), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [16751] = 21,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(244), 1,
      anon_sym_LPAREN,
    ACTIONS(248), 1,
      aux_sym_command_argument_token2,
    ACTIONS(252), 1,
      sym_range,
    ACTIONS(254), 1,
      sym_integer,
    ACTIONS(260), 1,
      anon_sym_LBRACK,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(494), 1,
      anon_sym_CARET,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(616), 1,
      anon_sym_RPAREN,
    STATE(189), 1,
      aux_sym__expression_list,
    STATE(247), 1,
      sym_function_call,
    STATE(264), 1,
      sym_expression,
    STATE(806), 1,
      sym_index_expression,
    STATE(808), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    ACTIONS(258), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(208), 2,
      sym_value,
      sym_index,
    ACTIONS(256), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(252), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [16832] = 21,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(244), 1,
      anon_sym_LPAREN,
    ACTIONS(248), 1,
      aux_sym_command_argument_token2,
    ACTIONS(252), 1,
      sym_range,
    ACTIONS(254), 1,
      sym_integer,
    ACTIONS(260), 1,
      anon_sym_LBRACK,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(494), 1,
      anon_sym_CARET,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(618), 1,
      anon_sym_RPAREN,
    STATE(182), 1,
      aux_sym__expression_list,
    STATE(247), 1,
      sym_function_call,
    STATE(264), 1,
      sym_expression,
    STATE(806), 1,
      sym_index_expression,
    STATE(808), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    ACTIONS(258), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(208), 2,
      sym_value,
      sym_index,
    ACTIONS(256), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(252), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [16913] = 21,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(244), 1,
      anon_sym_LPAREN,
    ACTIONS(248), 1,
      aux_sym_command_argument_token2,
    ACTIONS(252), 1,
      sym_range,
    ACTIONS(254), 1,
      sym_integer,
    ACTIONS(260), 1,
      anon_sym_LBRACK,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(494), 1,
      anon_sym_CARET,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(620), 1,
      anon_sym_RPAREN,
    STATE(186), 1,
      aux_sym__expression_list,
    STATE(247), 1,
      sym_function_call,
    STATE(264), 1,
      sym_expression,
    STATE(806), 1,
      sym_index_expression,
    STATE(808), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    ACTIONS(258), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(208), 2,
      sym_value,
      sym_index,
    ACTIONS(256), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(252), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [16994] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(300), 1,
      anon_sym_EQ,
    ACTIONS(326), 1,
      anon_sym_COLON,
    STATE(59), 1,
      sym_assignment_operator,
    ACTIONS(288), 2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
    ACTIONS(276), 14,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(278), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [17048] = 6,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(284), 1,
      anon_sym_COLON,
    ACTIONS(464), 1,
      anon_sym_COLON_COLON,
    ACTIONS(276), 14,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(278), 19,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [17098] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(384), 15,
      anon_sym_as,
      anon_sym_PIPE,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(382), 20,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [17141] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(366), 2,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
    ACTIONS(622), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(217), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(368), 29,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_identifier,
      sym_range,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [17188] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(190), 1,
      anon_sym_LPAREN,
    ACTIONS(194), 1,
      aux_sym_command_argument_token2,
    ACTIONS(200), 1,
      sym_range,
    ACTIONS(202), 1,
      sym_integer,
    ACTIONS(208), 1,
      anon_sym_LBRACK,
    ACTIONS(232), 1,
      anon_sym_CARET,
    ACTIONS(624), 1,
      sym_identifier,
    ACTIONS(626), 1,
      anon_sym_LBRACE,
    STATE(411), 1,
      sym_expression,
    STATE(449), 1,
      sym_function_call,
    STATE(828), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(862), 1,
      sym_index_expression,
    ACTIONS(206), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(407), 2,
      sym_value,
      sym_index,
    ACTIONS(204), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(466), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(368), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [17263] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(628), 1,
      sym_identifier,
    ACTIONS(630), 1,
      anon_sym_LPAREN,
    ACTIONS(632), 1,
      anon_sym_CARET,
    ACTIONS(634), 1,
      aux_sym_command_argument_token2,
    ACTIONS(636), 1,
      anon_sym_LBRACE,
    ACTIONS(638), 1,
      sym_range,
    ACTIONS(640), 1,
      sym_integer,
    ACTIONS(646), 1,
      anon_sym_LBRACK,
    STATE(452), 1,
      sym_expression,
    STATE(599), 1,
      sym_function_call,
    STATE(814), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(865), 1,
      sym_index_expression,
    ACTIONS(644), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(506), 2,
      sym_value,
      sym_index,
    ACTIONS(642), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(612), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(480), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [17338] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(628), 1,
      sym_identifier,
    ACTIONS(630), 1,
      anon_sym_LPAREN,
    ACTIONS(632), 1,
      anon_sym_CARET,
    ACTIONS(634), 1,
      aux_sym_command_argument_token2,
    ACTIONS(636), 1,
      anon_sym_LBRACE,
    ACTIONS(638), 1,
      sym_range,
    ACTIONS(640), 1,
      sym_integer,
    ACTIONS(646), 1,
      anon_sym_LBRACK,
    STATE(446), 1,
      sym_expression,
    STATE(599), 1,
      sym_function_call,
    STATE(814), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(865), 1,
      sym_index_expression,
    ACTIONS(644), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(506), 2,
      sym_value,
      sym_index,
    ACTIONS(642), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(612), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(480), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [17413] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(628), 1,
      sym_identifier,
    ACTIONS(630), 1,
      anon_sym_LPAREN,
    ACTIONS(632), 1,
      anon_sym_CARET,
    ACTIONS(634), 1,
      aux_sym_command_argument_token2,
    ACTIONS(636), 1,
      anon_sym_LBRACE,
    ACTIONS(638), 1,
      sym_range,
    ACTIONS(640), 1,
      sym_integer,
    ACTIONS(646), 1,
      anon_sym_LBRACK,
    STATE(417), 1,
      sym_expression,
    STATE(599), 1,
      sym_function_call,
    STATE(814), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(865), 1,
      sym_index_expression,
    ACTIONS(644), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(506), 2,
      sym_value,
      sym_index,
    ACTIONS(642), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(612), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(480), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [17488] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(470), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_CARET,
    ACTIONS(476), 1,
      aux_sym_command_argument_token2,
    ACTIONS(478), 1,
      anon_sym_LBRACE,
    ACTIONS(480), 1,
      sym_range,
    ACTIONS(482), 1,
      sym_integer,
    ACTIONS(488), 1,
      anon_sym_LBRACK,
    ACTIONS(648), 1,
      sym_identifier,
    STATE(585), 1,
      sym_expression,
    STATE(589), 1,
      sym_function_call,
    STATE(821), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(844), 1,
      sym_index_expression,
    ACTIONS(486), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(583), 2,
      sym_value,
      sym_index,
    ACTIONS(484), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(621), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(467), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [17563] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(628), 1,
      sym_identifier,
    ACTIONS(630), 1,
      anon_sym_LPAREN,
    ACTIONS(632), 1,
      anon_sym_CARET,
    ACTIONS(634), 1,
      aux_sym_command_argument_token2,
    ACTIONS(636), 1,
      anon_sym_LBRACE,
    ACTIONS(638), 1,
      sym_range,
    ACTIONS(640), 1,
      sym_integer,
    ACTIONS(646), 1,
      anon_sym_LBRACK,
    STATE(426), 1,
      sym_expression,
    STATE(599), 1,
      sym_function_call,
    STATE(814), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(865), 1,
      sym_index_expression,
    ACTIONS(644), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(506), 2,
      sym_value,
      sym_index,
    ACTIONS(642), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(612), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(480), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [17638] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(244), 1,
      anon_sym_LPAREN,
    ACTIONS(248), 1,
      aux_sym_command_argument_token2,
    ACTIONS(252), 1,
      sym_range,
    ACTIONS(254), 1,
      sym_integer,
    ACTIONS(260), 1,
      anon_sym_LBRACK,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(508), 1,
      anon_sym_CARET,
    STATE(247), 1,
      sym_function_call,
    STATE(272), 1,
      sym_expression,
    STATE(806), 1,
      sym_index_expression,
    STATE(808), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    ACTIONS(258), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(208), 2,
      sym_value,
      sym_index,
    ACTIONS(256), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(252), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [17713] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(244), 1,
      anon_sym_LPAREN,
    ACTIONS(248), 1,
      aux_sym_command_argument_token2,
    ACTIONS(252), 1,
      sym_range,
    ACTIONS(254), 1,
      sym_integer,
    ACTIONS(260), 1,
      anon_sym_LBRACK,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(508), 1,
      anon_sym_CARET,
    STATE(247), 1,
      sym_function_call,
    STATE(270), 1,
      sym_expression,
    STATE(806), 1,
      sym_index_expression,
    STATE(808), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    ACTIONS(258), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(208), 2,
      sym_value,
      sym_index,
    ACTIONS(256), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(252), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [17788] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(628), 1,
      sym_identifier,
    ACTIONS(630), 1,
      anon_sym_LPAREN,
    ACTIONS(632), 1,
      anon_sym_CARET,
    ACTIONS(634), 1,
      aux_sym_command_argument_token2,
    ACTIONS(636), 1,
      anon_sym_LBRACE,
    ACTIONS(638), 1,
      sym_range,
    ACTIONS(640), 1,
      sym_integer,
    ACTIONS(646), 1,
      anon_sym_LBRACK,
    STATE(425), 1,
      sym_expression,
    STATE(599), 1,
      sym_function_call,
    STATE(814), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(865), 1,
      sym_index_expression,
    ACTIONS(644), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(506), 2,
      sym_value,
      sym_index,
    ACTIONS(642), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(612), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(480), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [17863] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_COLON,
    ACTIONS(276), 14,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(278), 19,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [17910] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(190), 1,
      anon_sym_LPAREN,
    ACTIONS(194), 1,
      aux_sym_command_argument_token2,
    ACTIONS(200), 1,
      sym_range,
    ACTIONS(202), 1,
      sym_integer,
    ACTIONS(208), 1,
      anon_sym_LBRACK,
    ACTIONS(232), 1,
      anon_sym_CARET,
    ACTIONS(624), 1,
      sym_identifier,
    ACTIONS(626), 1,
      anon_sym_LBRACE,
    STATE(400), 1,
      sym_expression,
    STATE(449), 1,
      sym_function_call,
    STATE(828), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(862), 1,
      sym_index_expression,
    ACTIONS(206), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(407), 2,
      sym_value,
      sym_index,
    ACTIONS(204), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(466), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(368), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [17985] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(470), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_CARET,
    ACTIONS(476), 1,
      aux_sym_command_argument_token2,
    ACTIONS(478), 1,
      anon_sym_LBRACE,
    ACTIONS(480), 1,
      sym_range,
    ACTIONS(482), 1,
      sym_integer,
    ACTIONS(488), 1,
      anon_sym_LBRACK,
    ACTIONS(648), 1,
      sym_identifier,
    STATE(572), 1,
      sym_expression,
    STATE(589), 1,
      sym_function_call,
    STATE(821), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(844), 1,
      sym_index_expression,
    ACTIONS(486), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(583), 2,
      sym_value,
      sym_index,
    ACTIONS(484), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(621), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(467), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [18060] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(470), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_CARET,
    ACTIONS(476), 1,
      aux_sym_command_argument_token2,
    ACTIONS(478), 1,
      anon_sym_LBRACE,
    ACTIONS(480), 1,
      sym_range,
    ACTIONS(482), 1,
      sym_integer,
    ACTIONS(488), 1,
      anon_sym_LBRACK,
    ACTIONS(648), 1,
      sym_identifier,
    STATE(589), 1,
      sym_function_call,
    STATE(602), 1,
      sym_expression,
    STATE(821), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(844), 1,
      sym_index_expression,
    ACTIONS(486), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(583), 2,
      sym_value,
      sym_index,
    ACTIONS(484), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(621), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(467), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [18135] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(244), 1,
      anon_sym_LPAREN,
    ACTIONS(248), 1,
      aux_sym_command_argument_token2,
    ACTIONS(252), 1,
      sym_range,
    ACTIONS(254), 1,
      sym_integer,
    ACTIONS(260), 1,
      anon_sym_LBRACK,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(494), 1,
      anon_sym_CARET,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    STATE(247), 1,
      sym_function_call,
    STATE(266), 1,
      sym_expression,
    STATE(806), 1,
      sym_index_expression,
    STATE(808), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    ACTIONS(258), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(208), 2,
      sym_value,
      sym_index,
    ACTIONS(256), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(252), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [18210] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(244), 1,
      anon_sym_LPAREN,
    ACTIONS(248), 1,
      aux_sym_command_argument_token2,
    ACTIONS(252), 1,
      sym_range,
    ACTIONS(254), 1,
      sym_integer,
    ACTIONS(260), 1,
      anon_sym_LBRACK,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(494), 1,
      anon_sym_CARET,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    STATE(247), 1,
      sym_function_call,
    STATE(269), 1,
      sym_expression,
    STATE(806), 1,
      sym_index_expression,
    STATE(808), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    ACTIONS(258), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(208), 2,
      sym_value,
      sym_index,
    ACTIONS(256), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(252), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [18285] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(326), 1,
      anon_sym_COLON,
    ACTIONS(308), 14,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(306), 20,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [18330] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(362), 2,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
    ACTIONS(622), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(198), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(358), 29,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_identifier,
      sym_range,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [18377] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(628), 1,
      sym_identifier,
    ACTIONS(630), 1,
      anon_sym_LPAREN,
    ACTIONS(632), 1,
      anon_sym_CARET,
    ACTIONS(634), 1,
      aux_sym_command_argument_token2,
    ACTIONS(636), 1,
      anon_sym_LBRACE,
    ACTIONS(638), 1,
      sym_range,
    ACTIONS(640), 1,
      sym_integer,
    ACTIONS(646), 1,
      anon_sym_LBRACK,
    STATE(428), 1,
      sym_expression,
    STATE(599), 1,
      sym_function_call,
    STATE(814), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(865), 1,
      sym_index_expression,
    ACTIONS(644), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(506), 2,
      sym_value,
      sym_index,
    ACTIONS(642), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(612), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(480), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [18452] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(372), 2,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
    ACTIONS(650), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(217), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(374), 29,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_identifier,
      sym_range,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [18499] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(388), 15,
      anon_sym_as,
      anon_sym_PIPE,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(386), 20,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [18542] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(470), 1,
      anon_sym_LPAREN,
    ACTIONS(476), 1,
      aux_sym_command_argument_token2,
    ACTIONS(478), 1,
      anon_sym_LBRACE,
    ACTIONS(480), 1,
      sym_range,
    ACTIONS(482), 1,
      sym_integer,
    ACTIONS(488), 1,
      anon_sym_LBRACK,
    ACTIONS(648), 1,
      sym_identifier,
    ACTIONS(653), 1,
      anon_sym_CARET,
    STATE(573), 1,
      sym_expression,
    STATE(589), 1,
      sym_function_call,
    STATE(821), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(844), 1,
      sym_index_expression,
    ACTIONS(486), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(477), 2,
      sym_value,
      sym_index,
    ACTIONS(484), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(621), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(467), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [18617] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(470), 1,
      anon_sym_LPAREN,
    ACTIONS(476), 1,
      aux_sym_command_argument_token2,
    ACTIONS(478), 1,
      anon_sym_LBRACE,
    ACTIONS(480), 1,
      sym_range,
    ACTIONS(482), 1,
      sym_integer,
    ACTIONS(488), 1,
      anon_sym_LBRACK,
    ACTIONS(648), 1,
      sym_identifier,
    ACTIONS(653), 1,
      anon_sym_CARET,
    STATE(586), 1,
      sym_expression,
    STATE(589), 1,
      sym_function_call,
    STATE(821), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(844), 1,
      sym_index_expression,
    ACTIONS(486), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(477), 2,
      sym_value,
      sym_index,
    ACTIONS(484), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(621), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(467), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [18692] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(470), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_CARET,
    ACTIONS(476), 1,
      aux_sym_command_argument_token2,
    ACTIONS(478), 1,
      anon_sym_LBRACE,
    ACTIONS(480), 1,
      sym_range,
    ACTIONS(482), 1,
      sym_integer,
    ACTIONS(488), 1,
      anon_sym_LBRACK,
    ACTIONS(648), 1,
      sym_identifier,
    STATE(558), 1,
      sym_expression,
    STATE(589), 1,
      sym_function_call,
    STATE(821), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(844), 1,
      sym_index_expression,
    ACTIONS(486), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(583), 2,
      sym_value,
      sym_index,
    ACTIONS(484), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(621), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(467), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [18767] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(244), 1,
      anon_sym_LPAREN,
    ACTIONS(246), 1,
      anon_sym_CARET,
    ACTIONS(248), 1,
      aux_sym_command_argument_token2,
    ACTIONS(252), 1,
      sym_range,
    ACTIONS(254), 1,
      sym_integer,
    ACTIONS(260), 1,
      anon_sym_LBRACK,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    STATE(247), 1,
      sym_function_call,
    STATE(268), 1,
      sym_expression,
    STATE(806), 1,
      sym_index_expression,
    STATE(808), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    ACTIONS(258), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(208), 2,
      sym_value,
      sym_index,
    ACTIONS(256), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(252), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [18842] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(244), 1,
      anon_sym_LPAREN,
    ACTIONS(246), 1,
      anon_sym_CARET,
    ACTIONS(248), 1,
      aux_sym_command_argument_token2,
    ACTIONS(252), 1,
      sym_range,
    ACTIONS(254), 1,
      sym_integer,
    ACTIONS(260), 1,
      anon_sym_LBRACK,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    STATE(247), 1,
      sym_function_call,
    STATE(265), 1,
      sym_expression,
    STATE(806), 1,
      sym_index_expression,
    STATE(808), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    ACTIONS(258), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(208), 2,
      sym_value,
      sym_index,
    ACTIONS(256), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(252), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [18917] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(470), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_CARET,
    ACTIONS(476), 1,
      aux_sym_command_argument_token2,
    ACTIONS(478), 1,
      anon_sym_LBRACE,
    ACTIONS(480), 1,
      sym_range,
    ACTIONS(482), 1,
      sym_integer,
    ACTIONS(488), 1,
      anon_sym_LBRACK,
    ACTIONS(648), 1,
      sym_identifier,
    STATE(552), 1,
      sym_expression,
    STATE(589), 1,
      sym_function_call,
    STATE(821), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(844), 1,
      sym_index_expression,
    ACTIONS(486), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(583), 2,
      sym_value,
      sym_index,
    ACTIONS(484), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(621), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(467), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [18992] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(628), 1,
      sym_identifier,
    ACTIONS(630), 1,
      anon_sym_LPAREN,
    ACTIONS(632), 1,
      anon_sym_CARET,
    ACTIONS(634), 1,
      aux_sym_command_argument_token2,
    ACTIONS(636), 1,
      anon_sym_LBRACE,
    ACTIONS(638), 1,
      sym_range,
    ACTIONS(640), 1,
      sym_integer,
    ACTIONS(646), 1,
      anon_sym_LBRACK,
    STATE(429), 1,
      sym_expression,
    STATE(599), 1,
      sym_function_call,
    STATE(814), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(865), 1,
      sym_index_expression,
    ACTIONS(644), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(506), 2,
      sym_value,
      sym_index,
    ACTIONS(642), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(612), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(480), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [19067] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(655), 1,
      sym_identifier,
    ACTIONS(657), 1,
      anon_sym_LBRACE,
    STATE(123), 1,
      sym_expression,
    STATE(136), 1,
      sym_function_call,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(116), 2,
      sym_value,
      sym_index,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(134), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [19142] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(628), 1,
      sym_identifier,
    ACTIONS(630), 1,
      anon_sym_LPAREN,
    ACTIONS(632), 1,
      anon_sym_CARET,
    ACTIONS(634), 1,
      aux_sym_command_argument_token2,
    ACTIONS(636), 1,
      anon_sym_LBRACE,
    ACTIONS(638), 1,
      sym_range,
    ACTIONS(640), 1,
      sym_integer,
    ACTIONS(646), 1,
      anon_sym_LBRACK,
    STATE(441), 1,
      sym_expression,
    STATE(599), 1,
      sym_function_call,
    STATE(814), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(865), 1,
      sym_index_expression,
    ACTIONS(644), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(506), 2,
      sym_value,
      sym_index,
    ACTIONS(642), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(612), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(480), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [19217] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(49), 1,
      anon_sym_CARET,
    ACTIONS(655), 1,
      sym_identifier,
    ACTIONS(657), 1,
      anon_sym_LBRACE,
    STATE(114), 1,
      sym_expression,
    STATE(136), 1,
      sym_function_call,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(116), 2,
      sym_value,
      sym_index,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(134), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [19292] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(628), 1,
      sym_identifier,
    ACTIONS(630), 1,
      anon_sym_LPAREN,
    ACTIONS(632), 1,
      anon_sym_CARET,
    ACTIONS(634), 1,
      aux_sym_command_argument_token2,
    ACTIONS(636), 1,
      anon_sym_LBRACE,
    ACTIONS(638), 1,
      sym_range,
    ACTIONS(640), 1,
      sym_integer,
    ACTIONS(646), 1,
      anon_sym_LBRACK,
    STATE(485), 1,
      sym_expression,
    STATE(599), 1,
      sym_function_call,
    STATE(814), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(865), 1,
      sym_index_expression,
    ACTIONS(644), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(506), 2,
      sym_value,
      sym_index,
    ACTIONS(642), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(612), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(480), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [19367] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(628), 1,
      sym_identifier,
    ACTIONS(630), 1,
      anon_sym_LPAREN,
    ACTIONS(632), 1,
      anon_sym_CARET,
    ACTIONS(634), 1,
      aux_sym_command_argument_token2,
    ACTIONS(636), 1,
      anon_sym_LBRACE,
    ACTIONS(638), 1,
      sym_range,
    ACTIONS(640), 1,
      sym_integer,
    ACTIONS(646), 1,
      anon_sym_LBRACK,
    STATE(481), 1,
      sym_expression,
    STATE(599), 1,
      sym_function_call,
    STATE(814), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(865), 1,
      sym_index_expression,
    ACTIONS(644), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(506), 2,
      sym_value,
      sym_index,
    ACTIONS(642), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(612), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(480), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [19442] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(470), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_CARET,
    ACTIONS(476), 1,
      aux_sym_command_argument_token2,
    ACTIONS(478), 1,
      anon_sym_LBRACE,
    ACTIONS(480), 1,
      sym_range,
    ACTIONS(482), 1,
      sym_integer,
    ACTIONS(488), 1,
      anon_sym_LBRACK,
    ACTIONS(659), 1,
      sym_identifier,
    STATE(572), 1,
      sym_expression,
    STATE(589), 1,
      sym_function_call,
    STATE(821), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(844), 1,
      sym_index_expression,
    ACTIONS(486), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(583), 2,
      sym_value,
      sym_index,
    ACTIONS(484), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(621), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(467), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [19517] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(470), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_CARET,
    ACTIONS(476), 1,
      aux_sym_command_argument_token2,
    ACTIONS(478), 1,
      anon_sym_LBRACE,
    ACTIONS(480), 1,
      sym_range,
    ACTIONS(482), 1,
      sym_integer,
    ACTIONS(488), 1,
      anon_sym_LBRACK,
    ACTIONS(648), 1,
      sym_identifier,
    STATE(581), 1,
      sym_expression,
    STATE(589), 1,
      sym_function_call,
    STATE(821), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(844), 1,
      sym_index_expression,
    ACTIONS(486), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(583), 2,
      sym_value,
      sym_index,
    ACTIONS(484), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(621), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(467), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [19592] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_CARET,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(655), 1,
      sym_identifier,
    ACTIONS(657), 1,
      anon_sym_LBRACE,
    STATE(121), 1,
      sym_expression,
    STATE(136), 1,
      sym_function_call,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(116), 2,
      sym_value,
      sym_index,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(134), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [19667] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(9), 1,
      anon_sym_LPAREN,
    ACTIONS(11), 1,
      anon_sym_CARET,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(655), 1,
      sym_identifier,
    ACTIONS(657), 1,
      anon_sym_LBRACE,
    STATE(119), 1,
      sym_expression,
    STATE(136), 1,
      sym_function_call,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(849), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(116), 2,
      sym_value,
      sym_index,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(134), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [19742] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(470), 1,
      anon_sym_LPAREN,
    ACTIONS(474), 1,
      anon_sym_CARET,
    ACTIONS(476), 1,
      aux_sym_command_argument_token2,
    ACTIONS(478), 1,
      anon_sym_LBRACE,
    ACTIONS(480), 1,
      sym_range,
    ACTIONS(482), 1,
      sym_integer,
    ACTIONS(488), 1,
      anon_sym_LBRACK,
    ACTIONS(648), 1,
      sym_identifier,
    STATE(582), 1,
      sym_expression,
    STATE(589), 1,
      sym_function_call,
    STATE(821), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(844), 1,
      sym_index_expression,
    ACTIONS(486), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(583), 2,
      sym_value,
      sym_index,
    ACTIONS(484), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(621), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(467), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [19817] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(190), 1,
      anon_sym_LPAREN,
    ACTIONS(192), 1,
      anon_sym_CARET,
    ACTIONS(194), 1,
      aux_sym_command_argument_token2,
    ACTIONS(200), 1,
      sym_range,
    ACTIONS(202), 1,
      sym_integer,
    ACTIONS(208), 1,
      anon_sym_LBRACK,
    ACTIONS(624), 1,
      sym_identifier,
    ACTIONS(626), 1,
      anon_sym_LBRACE,
    STATE(435), 1,
      sym_expression,
    STATE(449), 1,
      sym_function_call,
    STATE(828), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(862), 1,
      sym_index_expression,
    ACTIONS(206), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(407), 2,
      sym_value,
      sym_index,
    ACTIONS(204), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(466), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(368), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [19892] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(190), 1,
      anon_sym_LPAREN,
    ACTIONS(192), 1,
      anon_sym_CARET,
    ACTIONS(194), 1,
      aux_sym_command_argument_token2,
    ACTIONS(200), 1,
      sym_range,
    ACTIONS(202), 1,
      sym_integer,
    ACTIONS(208), 1,
      anon_sym_LBRACK,
    ACTIONS(624), 1,
      sym_identifier,
    ACTIONS(626), 1,
      anon_sym_LBRACE,
    STATE(413), 1,
      sym_expression,
    STATE(449), 1,
      sym_function_call,
    STATE(828), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(862), 1,
      sym_index_expression,
    ACTIONS(206), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(407), 2,
      sym_value,
      sym_index,
    ACTIONS(204), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(466), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(368), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [19967] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(661), 1,
      anon_sym_LT,
    STATE(246), 1,
      sym_type_arguments,
    ACTIONS(414), 13,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(412), 20,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [20014] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(663), 1,
      anon_sym_DASH_GT,
    ACTIONS(424), 14,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(422), 20,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [20059] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(470), 1,
      anon_sym_LPAREN,
    ACTIONS(476), 1,
      aux_sym_command_argument_token2,
    ACTIONS(478), 1,
      anon_sym_LBRACE,
    ACTIONS(480), 1,
      sym_range,
    ACTIONS(482), 1,
      sym_integer,
    ACTIONS(488), 1,
      anon_sym_LBRACK,
    ACTIONS(648), 1,
      sym_identifier,
    ACTIONS(653), 1,
      anon_sym_CARET,
    STATE(543), 1,
      sym_expression,
    STATE(589), 1,
      sym_function_call,
    STATE(821), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(844), 1,
      sym_index_expression,
    ACTIONS(486), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(477), 2,
      sym_value,
      sym_index,
    ACTIONS(484), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(621), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(467), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [20134] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(665), 1,
      anon_sym_DASH_GT,
    ACTIONS(430), 14,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(428), 20,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [20179] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(470), 1,
      anon_sym_LPAREN,
    ACTIONS(476), 1,
      aux_sym_command_argument_token2,
    ACTIONS(478), 1,
      anon_sym_LBRACE,
    ACTIONS(480), 1,
      sym_range,
    ACTIONS(482), 1,
      sym_integer,
    ACTIONS(488), 1,
      anon_sym_LBRACK,
    ACTIONS(648), 1,
      sym_identifier,
    ACTIONS(653), 1,
      anon_sym_CARET,
    STATE(574), 1,
      sym_expression,
    STATE(589), 1,
      sym_function_call,
    STATE(821), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(844), 1,
      sym_index_expression,
    ACTIONS(486), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(477), 2,
      sym_value,
      sym_index,
    ACTIONS(484), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(621), 5,
      sym__expression_kind,
      sym_as_node,
      sym_command,
      sym_math,
      sym_logic,
    STATE(467), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [20254] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(462), 14,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(460), 20,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [20296] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(366), 2,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
    ACTIONS(667), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(248), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(368), 28,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      sym_identifier,
      sym_range,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [20342] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(440), 14,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(438), 20,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [20384] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(424), 14,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(422), 20,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [20426] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(276), 14,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(278), 19,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [20470] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(372), 2,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
    ACTIONS(669), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(248), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(374), 28,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      sym_identifier,
      sym_range,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [20516] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(452), 14,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(450), 20,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [20558] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(362), 2,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
    ACTIONS(672), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(261), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(358), 28,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      sym_identifier,
      sym_range,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [20604] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(446), 14,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(444), 20,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [20646] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(456), 14,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(454), 20,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [20688] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(674), 1,
      anon_sym_LT,
    ACTIONS(414), 13,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(412), 20,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [20732] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(436), 14,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(434), 20,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [20774] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(414), 14,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(412), 20,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [20816] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(362), 2,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
    ACTIONS(667), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(244), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(358), 28,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      sym_identifier,
      sym_range,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [20862] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(430), 14,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(428), 20,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [20904] = 7,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(680), 1,
      anon_sym_elseif,
    ACTIONS(682), 1,
      anon_sym_else,
    STATE(318), 1,
      sym_else,
    STATE(262), 2,
      sym_else_if,
      aux_sym_if_else_repeat1,
    ACTIONS(676), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_asyncfor,
    ACTIONS(678), 19,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [20954] = 7,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(680), 1,
      anon_sym_elseif,
    ACTIONS(682), 1,
      anon_sym_else,
    STATE(321), 1,
      sym_else,
    STATE(258), 2,
      sym_else_if,
      aux_sym_if_else_repeat1,
    ACTIONS(684), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_asyncfor,
    ACTIONS(686), 19,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [21004] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(372), 2,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
    ACTIONS(688), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(260), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(374), 28,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      sym_identifier,
      sym_range,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [21050] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(366), 2,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
    ACTIONS(672), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(260), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(368), 28,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_LBRACE,
      sym_identifier,
      sym_range,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [21096] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(695), 1,
      anon_sym_elseif,
    STATE(262), 2,
      sym_else_if,
      aux_sym_if_else_repeat1,
    ACTIONS(691), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_asyncfor,
    ACTIONS(693), 20,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [21141] = 3,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(390), 2,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
    ACTIONS(392), 31,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_identifier,
      sym_range,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [21182] = 11,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(702), 1,
      anon_sym_COMMA,
    ACTIONS(704), 1,
      anon_sym_as,
    STATE(212), 1,
      sym_math_operator,
    STATE(213), 1,
      sym_logic_operator,
    ACTIONS(404), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(410), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(406), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(408), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(700), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      sym_range,
      anon_sym_LBRACK,
    ACTIONS(698), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [21239] = 5,
    ACTIONS(3), 1,
      sym__comment,
    STATE(222), 1,
      sym_logic_operator,
    STATE(223), 1,
      sym_math_operator,
    ACTIONS(420), 14,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(418), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [21284] = 5,
    ACTIONS(3), 1,
      sym__comment,
    STATE(212), 1,
      sym_math_operator,
    STATE(213), 1,
      sym_logic_operator,
    ACTIONS(420), 14,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(418), 17,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [21329] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(704), 1,
      anon_sym_as,
    STATE(222), 1,
      sym_logic_operator,
    STATE(223), 1,
      sym_math_operator,
    ACTIONS(404), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(406), 2,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(410), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(408), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(398), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(400), 9,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
  [21384] = 5,
    ACTIONS(3), 1,
      sym__comment,
    STATE(222), 1,
      sym_logic_operator,
    STATE(223), 1,
      sym_math_operator,
    ACTIONS(394), 14,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(396), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [21429] = 5,
    ACTIONS(3), 1,
      sym__comment,
    STATE(212), 1,
      sym_math_operator,
    STATE(213), 1,
      sym_logic_operator,
    ACTIONS(394), 14,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(396), 17,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [21474] = 5,
    ACTIONS(3), 1,
      sym__comment,
    STATE(205), 1,
      sym_logic_operator,
    STATE(206), 1,
      sym_math_operator,
    ACTIONS(420), 14,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(418), 17,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [21519] = 11,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(704), 1,
      anon_sym_as,
    ACTIONS(710), 1,
      anon_sym_COMMA,
    STATE(205), 1,
      sym_logic_operator,
    STATE(206), 1,
      sym_math_operator,
    ACTIONS(404), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(410), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(406), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(408), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(708), 7,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(706), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [21576] = 5,
    ACTIONS(3), 1,
      sym__comment,
    STATE(205), 1,
      sym_logic_operator,
    STATE(206), 1,
      sym_math_operator,
    ACTIONS(394), 14,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(396), 17,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [21621] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(356), 14,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(354), 18,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [21661] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(712), 1,
      anon_sym_PIPE,
    ACTIONS(276), 14,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(278), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [21703] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(346), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_DASH_GT,
      anon_sym_asyncfor,
    ACTIONS(348), 19,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [21743] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(714), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(280), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(362), 3,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_asyncfor,
    ACTIONS(358), 25,
      anon_sym_return,
      anon_sym_break,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_identifier,
      sym_range,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [21787] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(350), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_DASH_GT,
      anon_sym_asyncfor,
    ACTIONS(352), 19,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [21827] = 3,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(390), 2,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
    ACTIONS(392), 30,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      sym_identifier,
      sym_range,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [21867] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(716), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(279), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(372), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_asyncfor,
    ACTIONS(374), 24,
      anon_sym_return,
      anon_sym_break,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_async,
      anon_sym_LBRACE,
      sym_identifier,
      sym_range,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [21911] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(714), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(285), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(366), 3,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_asyncfor,
    ACTIONS(368), 25,
      anon_sym_return,
      anon_sym_break,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_identifier,
      sym_range,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [21955] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(719), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(279), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(366), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_asyncfor,
    ACTIONS(368), 24,
      anon_sym_return,
      anon_sym_break,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_async,
      anon_sym_LBRACE,
      sym_identifier,
      sym_range,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [21999] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(712), 1,
      anon_sym_PIPE,
    ACTIONS(276), 14,
      anon_sym_as,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(278), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [22043] = 7,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(725), 1,
      anon_sym_LBRACE,
    ACTIONS(727), 1,
      anon_sym_LT,
    STATE(306), 1,
      aux_sym_enum_definition_repeat2,
    STATE(308), 1,
      sym_type_arguments,
    ACTIONS(721), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_asyncfor,
    ACTIONS(723), 19,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [22091] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(719), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(281), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(362), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_asyncfor,
    ACTIONS(358), 24,
      anon_sym_return,
      anon_sym_break,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_async,
      anon_sym_LBRACE,
      sym_identifier,
      sym_range,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [22135] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(729), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(285), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(372), 3,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_asyncfor,
    ACTIONS(374), 25,
      anon_sym_return,
      anon_sym_break,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_identifier,
      sym_range,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [22179] = 3,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(390), 2,
      anon_sym_CARET,
      anon_sym_PIPE_PIPE,
    ACTIONS(392), 30,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      sym_identifier,
      sym_range,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [22219] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(342), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_DASH_GT,
      anon_sym_asyncfor,
    ACTIONS(344), 19,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [22259] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(732), 1,
      sym_identifier,
    ACTIONS(734), 1,
      anon_sym_LPAREN,
    ACTIONS(736), 1,
      anon_sym_CARET,
    ACTIONS(738), 1,
      anon_sym_LBRACE,
    STATE(508), 1,
      sym_pipe,
    STATE(681), 1,
      sym_function_call,
    STATE(686), 1,
      sym_command,
    STATE(835), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(854), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(736), 2,
      sym_value,
      sym_index,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [22330] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(732), 1,
      sym_identifier,
    ACTIONS(734), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACE,
    ACTIONS(740), 1,
      anon_sym_CARET,
    STATE(508), 1,
      sym_pipe,
    STATE(685), 1,
      sym_function_call,
    STATE(687), 1,
      sym_command,
    STATE(835), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(854), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(736), 2,
      sym_value,
      sym_index,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [22401] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(732), 1,
      sym_identifier,
    ACTIONS(734), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACE,
    ACTIONS(742), 1,
      anon_sym_CARET,
    STATE(328), 1,
      sym_command,
    STATE(329), 1,
      sym_function_call,
    STATE(336), 1,
      sym_pipe,
    STATE(820), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(854), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(736), 2,
      sym_value,
      sym_index,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [22472] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(744), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_elseif,
      anon_sym_asyncfor,
    ACTIONS(746), 20,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [22511] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(732), 1,
      sym_identifier,
    ACTIONS(734), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      anon_sym_CARET,
    STATE(447), 1,
      sym_function_call,
    STATE(448), 1,
      sym_command,
    STATE(508), 1,
      sym_pipe,
    STATE(838), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(854), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(736), 2,
      sym_value,
      sym_index,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [22582] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(350), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_elseif,
      anon_sym_asyncfor,
    ACTIONS(352), 20,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [22621] = 19,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(732), 1,
      sym_identifier,
    ACTIONS(734), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACE,
    ACTIONS(750), 1,
      anon_sym_CARET,
    STATE(315), 1,
      sym_command,
    STATE(331), 1,
      sym_function_call,
    STATE(336), 1,
      sym_pipe,
    STATE(820), 1,
      sym_function_expression,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(854), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(736), 2,
      sym_value,
      sym_index,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [22692] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(444), 12,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_GT,
    ACTIONS(446), 19,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_list,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [22731] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(752), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_elseif,
      anon_sym_asyncfor,
    ACTIONS(754), 20,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [22770] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(342), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_elseif,
      anon_sym_asyncfor,
    ACTIONS(344), 20,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [22809] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(346), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_elseif,
      anon_sym_asyncfor,
    ACTIONS(348), 20,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [22848] = 18,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(512), 1,
      anon_sym_RPAREN,
    ACTIONS(734), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACE,
    ACTIONS(756), 1,
      sym_identifier,
    STATE(739), 1,
      aux_sym_function_repeat1,
    STATE(772), 1,
      sym_function_call,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(854), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(736), 2,
      sym_value,
      sym_index,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [22916] = 3,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(390), 3,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_asyncfor,
    ACTIONS(392), 27,
      anon_sym_return,
      anon_sym_break,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_identifier,
      sym_range,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [22954] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(386), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_asyncfor,
    ACTIONS(388), 20,
      anon_sym_return,
      anon_sym_break,
      anon_sym_PIPE,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [22992] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(382), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_asyncfor,
    ACTIONS(384), 20,
      anon_sym_return,
      anon_sym_break,
      anon_sym_PIPE,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [23030] = 17,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(734), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACE,
    ACTIONS(756), 1,
      sym_identifier,
    ACTIONS(758), 1,
      anon_sym_RPAREN,
    STATE(703), 1,
      aux_sym_function_repeat1,
    STATE(846), 1,
      sym_function_expression,
    STATE(854), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(736), 2,
      sym_value,
      sym_index,
    STATE(763), 2,
      sym__function_expression_kind,
      sym_function_call,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [23096] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(725), 1,
      anon_sym_LBRACE,
    STATE(313), 1,
      aux_sym_enum_definition_repeat2,
    ACTIONS(760), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_asyncfor,
    ACTIONS(762), 19,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [23138] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(444), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_asyncfor,
    ACTIONS(446), 19,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [23176] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(725), 1,
      anon_sym_LBRACE,
    STATE(313), 1,
      aux_sym_enum_definition_repeat2,
    ACTIONS(764), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_asyncfor,
    ACTIONS(766), 19,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [23218] = 3,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(390), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_CARET,
      anon_sym_asyncfor,
    ACTIONS(392), 26,
      anon_sym_return,
      anon_sym_break,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
      anon_sym_async,
      anon_sym_LBRACE,
      sym_identifier,
      sym_range,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [23256] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(725), 1,
      anon_sym_LBRACE,
    STATE(304), 1,
      aux_sym_enum_definition_repeat2,
    ACTIONS(764), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_asyncfor,
    ACTIONS(766), 19,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [23298] = 18,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(516), 1,
      anon_sym_RPAREN,
    ACTIONS(734), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACE,
    ACTIONS(756), 1,
      sym_identifier,
    STATE(704), 1,
      aux_sym_function_repeat1,
    STATE(764), 1,
      sym_function_call,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(854), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(736), 2,
      sym_value,
      sym_index,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [23366] = 18,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(504), 1,
      anon_sym_RPAREN,
    ACTIONS(734), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACE,
    ACTIONS(756), 1,
      sym_identifier,
    STATE(711), 1,
      aux_sym_function_repeat1,
    STATE(768), 1,
      sym_function_call,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(854), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(736), 2,
      sym_value,
      sym_index,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [23434] = 18,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(514), 1,
      anon_sym_RPAREN,
    ACTIONS(734), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACE,
    ACTIONS(756), 1,
      sym_identifier,
    STATE(699), 1,
      aux_sym_function_repeat1,
    STATE(765), 1,
      sym_function_call,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(854), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(736), 2,
      sym_value,
      sym_index,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [23502] = 18,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(734), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACE,
    ACTIONS(756), 1,
      sym_identifier,
    ACTIONS(758), 1,
      anon_sym_RPAREN,
    STATE(703), 1,
      aux_sym_function_repeat1,
    STATE(772), 1,
      sym_function_call,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(854), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(736), 2,
      sym_value,
      sym_index,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [23570] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(772), 1,
      anon_sym_LBRACE,
    STATE(313), 1,
      aux_sym_enum_definition_repeat2,
    ACTIONS(768), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_asyncfor,
    ACTIONS(770), 19,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [23612] = 18,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(19), 1,
      sym_range,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(472), 1,
      anon_sym_RPAREN,
    ACTIONS(734), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACE,
    ACTIONS(756), 1,
      sym_identifier,
    STATE(709), 1,
      aux_sym_function_repeat1,
    STATE(788), 1,
      sym_function_call,
    STATE(842), 1,
      sym__function_expression_kind,
    STATE(846), 1,
      sym_function_expression,
    STATE(854), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(736), 2,
      sym_value,
      sym_index,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [23680] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(448), 1,
      anon_sym_PIPE,
    ACTIONS(777), 9,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_asyncfor,
    ACTIONS(775), 19,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [23719] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(779), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_asyncfor,
    ACTIONS(781), 19,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [23756] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(783), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_asyncfor,
    ACTIONS(785), 19,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [23793] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(787), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_asyncfor,
    ACTIONS(789), 19,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [23830] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(791), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_asyncfor,
    ACTIONS(793), 19,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [23867] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(799), 1,
      anon_sym_SEMI,
    ACTIONS(795), 9,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_asyncfor,
    ACTIONS(797), 19,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [23906] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(676), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_asyncfor,
    ACTIONS(678), 19,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [23943] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(801), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_asyncfor,
    ACTIONS(803), 19,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [23980] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(795), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_asyncfor,
    ACTIONS(797), 19,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [24017] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(805), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_asyncfor,
    ACTIONS(807), 19,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [24054] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(809), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_asyncfor,
    ACTIONS(811), 19,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [24091] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(813), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_asyncfor,
    ACTIONS(815), 19,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [24128] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(817), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_asyncfor,
    ACTIONS(819), 19,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [24165] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(442), 1,
      anon_sym_PIPE,
    ACTIONS(777), 9,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_asyncfor,
    ACTIONS(775), 19,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [24204] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(442), 1,
      anon_sym_PIPE,
    ACTIONS(777), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_asyncfor,
    ACTIONS(775), 19,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [24245] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(821), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_asyncfor,
    ACTIONS(823), 19,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [24282] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(448), 1,
      anon_sym_PIPE,
    ACTIONS(777), 8,
      anon_sym_SEMI,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_asyncfor,
    ACTIONS(775), 19,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [24323] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(825), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_asyncfor,
    ACTIONS(827), 19,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [24360] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(829), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_asyncfor,
    ACTIONS(831), 19,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [24397] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(833), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_asyncfor,
    ACTIONS(835), 19,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [24434] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(837), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_asyncfor,
    ACTIONS(839), 19,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [24471] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(777), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_asyncfor,
    ACTIONS(775), 19,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [24508] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(400), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_asyncfor,
    ACTIONS(398), 19,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [24545] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(841), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_asyncfor,
    ACTIONS(843), 19,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [24582] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(795), 10,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_asyncfor,
    ACTIONS(797), 19,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [24619] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(845), 1,
      anon_sym_SEMI,
    ACTIONS(783), 9,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_asyncfor,
    ACTIONS(785), 19,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [24658] = 16,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(738), 1,
      anon_sym_LBRACE,
    ACTIONS(847), 1,
      sym_identifier,
    ACTIONS(849), 1,
      anon_sym_LPAREN,
    ACTIONS(851), 1,
      anon_sym_RBRACE,
    ACTIONS(853), 1,
      sym_range,
    ACTIONS(855), 1,
      anon_sym_STAR,
    STATE(343), 1,
      aux_sym_match_repeat1,
    STATE(817), 1,
      sym_match_pattern,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(816), 2,
      sym_value,
      sym_enum_pattern,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [24720] = 16,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(738), 1,
      anon_sym_LBRACE,
    ACTIONS(847), 1,
      sym_identifier,
    ACTIONS(849), 1,
      anon_sym_LPAREN,
    ACTIONS(853), 1,
      sym_range,
    ACTIONS(855), 1,
      anon_sym_STAR,
    ACTIONS(857), 1,
      anon_sym_RBRACE,
    STATE(343), 1,
      aux_sym_match_repeat1,
    STATE(817), 1,
      sym_match_pattern,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(816), 2,
      sym_value,
      sym_enum_pattern,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [24782] = 16,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(859), 1,
      sym_identifier,
    ACTIONS(862), 1,
      anon_sym_LPAREN,
    ACTIONS(865), 1,
      aux_sym_command_argument_token2,
    ACTIONS(868), 1,
      anon_sym_LBRACE,
    ACTIONS(871), 1,
      anon_sym_RBRACE,
    ACTIONS(873), 1,
      sym_range,
    ACTIONS(876), 1,
      sym_integer,
    ACTIONS(885), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_STAR,
    STATE(343), 1,
      aux_sym_match_repeat1,
    STATE(817), 1,
      sym_match_pattern,
    ACTIONS(882), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(816), 2,
      sym_value,
      sym_enum_pattern,
    ACTIONS(879), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [24844] = 15,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(738), 1,
      anon_sym_LBRACE,
    ACTIONS(847), 1,
      sym_identifier,
    ACTIONS(849), 1,
      anon_sym_LPAREN,
    ACTIONS(853), 1,
      sym_range,
    ACTIONS(855), 1,
      anon_sym_STAR,
    STATE(341), 1,
      aux_sym_match_repeat1,
    STATE(817), 1,
      sym_match_pattern,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(816), 2,
      sym_value,
      sym_enum_pattern,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [24903] = 15,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(738), 1,
      anon_sym_LBRACE,
    ACTIONS(847), 1,
      sym_identifier,
    ACTIONS(849), 1,
      anon_sym_LPAREN,
    ACTIONS(853), 1,
      sym_range,
    ACTIONS(855), 1,
      anon_sym_STAR,
    STATE(342), 1,
      aux_sym_match_repeat1,
    STATE(817), 1,
      sym_match_pattern,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(816), 2,
      sym_value,
      sym_enum_pattern,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [24962] = 11,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(284), 1,
      anon_sym_COLON,
    ACTIONS(286), 1,
      anon_sym_LT,
    ACTIONS(300), 1,
      anon_sym_EQ,
    ACTIONS(891), 1,
      anon_sym_COLON_COLON,
    STATE(65), 1,
      sym_assignment_operator,
    STATE(694), 1,
      sym_type_specification,
    ACTIONS(288), 2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
    ACTIONS(276), 5,
      anon_sym_as,
      sym_identifier,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(278), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [25012] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(895), 7,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_asyncfor,
    ACTIONS(893), 19,
      anon_sym_return,
      anon_sym_break,
      anon_sym_async,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_match,
      anon_sym_loop,
      anon_sym_while,
      anon_sym_for,
      anon_sym_enum,
      anon_sym_struct,
  [25046] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(476), 1,
      aux_sym_command_argument_token2,
    ACTIONS(478), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_integer,
    ACTIONS(488), 1,
      anon_sym_LBRACK,
    ACTIONS(897), 1,
      sym_identifier,
    ACTIONS(899), 1,
      anon_sym_LPAREN,
    ACTIONS(901), 1,
      sym_range,
    STATE(523), 1,
      sym_index_expression,
    ACTIONS(486), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(512), 2,
      sym_value,
      sym_index,
    ACTIONS(484), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(467), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [25099] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(657), 1,
      anon_sym_LBRACE,
    ACTIONS(903), 1,
      sym_identifier,
    ACTIONS(905), 1,
      anon_sym_LPAREN,
    ACTIONS(907), 1,
      sym_range,
    STATE(94), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(90), 2,
      sym_value,
      sym_index,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [25152] = 11,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(284), 1,
      anon_sym_COLON,
    ACTIONS(286), 1,
      anon_sym_LT,
    ACTIONS(300), 1,
      anon_sym_EQ,
    ACTIONS(891), 1,
      anon_sym_COLON_COLON,
    STATE(44), 1,
      sym_assignment_operator,
    STATE(690), 1,
      sym_type_specification,
    ACTIONS(288), 2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
    ACTIONS(276), 5,
      anon_sym_as,
      sym_identifier,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
    ACTIONS(278), 11,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [25201] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(13), 1,
      aux_sym_command_argument_token2,
    ACTIONS(21), 1,
      sym_integer,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(738), 1,
      anon_sym_LBRACE,
    ACTIONS(907), 1,
      sym_range,
    ACTIONS(909), 1,
      sym_identifier,
    ACTIONS(911), 1,
      anon_sym_LPAREN,
    STATE(94), 1,
      sym_index_expression,
    ACTIONS(25), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(90), 2,
      sym_value,
      sym_index,
    ACTIONS(23), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(85), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [25254] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(634), 1,
      aux_sym_command_argument_token2,
    ACTIONS(636), 1,
      anon_sym_LBRACE,
    ACTIONS(640), 1,
      sym_integer,
    ACTIONS(646), 1,
      anon_sym_LBRACK,
    ACTIONS(913), 1,
      sym_identifier,
    ACTIONS(915), 1,
      anon_sym_LPAREN,
    ACTIONS(917), 1,
      sym_range,
    STATE(456), 1,
      sym_index_expression,
    ACTIONS(644), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(539), 2,
      sym_value,
      sym_index,
    ACTIONS(642), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(480), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [25307] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(248), 1,
      aux_sym_command_argument_token2,
    ACTIONS(254), 1,
      sym_integer,
    ACTIONS(260), 1,
      anon_sym_LBRACK,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(919), 1,
      sym_identifier,
    ACTIONS(921), 1,
      anon_sym_LPAREN,
    ACTIONS(923), 1,
      sym_range,
    STATE(153), 1,
      sym_index_expression,
    ACTIONS(258), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(154), 2,
      sym_value,
      sym_index,
    ACTIONS(256), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(152), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [25360] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(194), 1,
      aux_sym_command_argument_token2,
    ACTIONS(202), 1,
      sym_integer,
    ACTIONS(208), 1,
      anon_sym_LBRACK,
    ACTIONS(626), 1,
      anon_sym_LBRACE,
    ACTIONS(925), 1,
      sym_identifier,
    ACTIONS(927), 1,
      anon_sym_LPAREN,
    ACTIONS(929), 1,
      sym_range,
    STATE(378), 1,
      sym_index_expression,
    ACTIONS(206), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(358), 2,
      sym_value,
      sym_index,
    ACTIONS(204), 5,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
    STATE(368), 8,
      sym_float,
      sym_string,
      sym_boolean,
      sym_list,
      sym_map,
      sym_function,
      sym_enum_instance,
      sym_struct_instance,
  [25413] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(300), 1,
      anon_sym_EQ,
    ACTIONS(326), 1,
      anon_sym_COLON,
    STATE(62), 1,
      sym_assignment_operator,
    ACTIONS(288), 2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
    ACTIONS(276), 6,
      anon_sym_as,
      sym_identifier,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(278), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [25455] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(891), 1,
      anon_sym_COLON_COLON,
    ACTIONS(284), 8,
      anon_sym_as,
      sym_identifier,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(326), 15,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [25489] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(274), 7,
      anon_sym_as,
      sym_identifier,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(272), 16,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [25520] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(284), 7,
      anon_sym_as,
      sym_identifier,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(326), 16,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [25551] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(344), 7,
      anon_sym_as,
      sym_identifier,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(342), 16,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [25582] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(356), 7,
      anon_sym_as,
      sym_identifier,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(354), 16,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [25613] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(366), 2,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
    ACTIONS(931), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(374), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(368), 17,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      sym_identifier,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [25648] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(352), 7,
      anon_sym_as,
      sym_identifier,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(350), 16,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [25679] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(270), 7,
      anon_sym_as,
      sym_identifier,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(268), 16,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [25710] = 7,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(933), 1,
      anon_sym_elseif,
    ACTIONS(935), 1,
      anon_sym_else,
    STATE(527), 1,
      sym_else,
    STATE(386), 2,
      sym_else_if,
      aux_sym_if_else_repeat1,
    ACTIONS(676), 9,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(678), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [25749] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(294), 7,
      anon_sym_as,
      sym_identifier,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(292), 16,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [25780] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(316), 7,
      anon_sym_as,
      sym_identifier,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(314), 16,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [25811] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(312), 7,
      anon_sym_as,
      sym_identifier,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(310), 16,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [25842] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(308), 7,
      anon_sym_as,
      sym_identifier,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(306), 16,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [25873] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(300), 1,
      anon_sym_EQ,
    ACTIONS(326), 1,
      anon_sym_COLON,
    STATE(49), 1,
      sym_assignment_operator,
    ACTIONS(288), 2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
    ACTIONS(276), 6,
      anon_sym_as,
      sym_identifier,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(278), 11,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [25914] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(336), 7,
      anon_sym_as,
      sym_identifier,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(334), 16,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [25945] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(266), 7,
      anon_sym_as,
      sym_identifier,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(264), 16,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [25976] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(320), 7,
      anon_sym_as,
      sym_identifier,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(318), 16,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [26007] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(304), 7,
      anon_sym_as,
      sym_identifier,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(302), 16,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [26038] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(372), 2,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
    ACTIONS(937), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(374), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(374), 17,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      sym_identifier,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [26073] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(348), 7,
      anon_sym_as,
      sym_identifier,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(346), 16,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [26104] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(940), 1,
      anon_sym_LPAREN,
    ACTIONS(330), 7,
      anon_sym_as,
      sym_identifier,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(328), 15,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [26137] = 7,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(933), 1,
      anon_sym_elseif,
    ACTIONS(935), 1,
      anon_sym_else,
    STATE(484), 1,
      sym_else,
    STATE(364), 2,
      sym_else_if,
      aux_sym_if_else_repeat1,
    ACTIONS(684), 9,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(686), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [26176] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(340), 7,
      anon_sym_as,
      sym_identifier,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(338), 16,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [26207] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(298), 7,
      anon_sym_as,
      sym_identifier,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(296), 16,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [26238] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(324), 7,
      anon_sym_as,
      sym_identifier,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(322), 16,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [26269] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(362), 2,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
    ACTIONS(931), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(361), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(358), 17,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      sym_identifier,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [26304] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(284), 7,
      anon_sym_as,
      sym_identifier,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(326), 16,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [26335] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(362), 1,
      anon_sym_SEMI,
    ACTIONS(942), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(385), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(358), 17,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_identifier,
      sym_range,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_LBRACK,
      anon_sym_STAR,
  [26369] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(372), 2,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
    ACTIONS(944), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(384), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(374), 16,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      sym_identifier,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [26403] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(366), 1,
      anon_sym_SEMI,
    ACTIONS(942), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(387), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(368), 17,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_identifier,
      sym_range,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_LBRACK,
      anon_sym_STAR,
  [26437] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(947), 1,
      anon_sym_elseif,
    STATE(386), 2,
      sym_else_if,
      aux_sym_if_else_repeat1,
    ACTIONS(691), 9,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(693), 10,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_else,
  [26471] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(372), 1,
      anon_sym_SEMI,
    ACTIONS(950), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(387), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(374), 17,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_identifier,
      sym_range,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_LBRACK,
      anon_sym_STAR,
  [26505] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(366), 2,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
    ACTIONS(953), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(384), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(368), 16,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      sym_identifier,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [26539] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(362), 2,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
    ACTIONS(953), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(388), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(358), 16,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      sym_identifier,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [26573] = 3,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(390), 2,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
    ACTIONS(392), 19,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
      anon_sym_RBRACE,
      sym_identifier,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [26602] = 7,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    ACTIONS(957), 1,
      anon_sym_LT,
    STATE(438), 1,
      sym_type_arguments,
    STATE(445), 1,
      aux_sym_enum_definition_repeat2,
    ACTIONS(721), 8,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(723), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [26639] = 6,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(284), 1,
      anon_sym_COLON,
    ACTIONS(891), 1,
      anon_sym_COLON_COLON,
    ACTIONS(276), 4,
      anon_sym_as,
      sym_identifier,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(278), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [26674] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(342), 10,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_elseif,
    ACTIONS(344), 10,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_else,
  [26702] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(366), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(959), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(397), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(368), 15,
      anon_sym_as,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [26734] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(957), 1,
      anon_sym_LT,
    STATE(528), 1,
      sym_type_arguments,
    ACTIONS(412), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
    ACTIONS(414), 11,
      sym_identifier,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_list,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [26766] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(362), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(959), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(394), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(358), 15,
      anon_sym_as,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [26798] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(372), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(961), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(397), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(374), 15,
      anon_sym_as,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [26830] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(752), 10,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_elseif,
    ACTIONS(754), 10,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_else,
  [26858] = 3,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(390), 2,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
    ACTIONS(392), 18,
      anon_sym_as,
      anon_sym_PIPE,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
      anon_sym_RBRACE,
      sym_identifier,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [26886] = 5,
    ACTIONS(3), 1,
      sym__comment,
    STATE(199), 1,
      sym_logic_operator,
    STATE(209), 1,
      sym_math_operator,
    ACTIONS(420), 4,
      anon_sym_as,
      sym_identifier,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(418), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [26918] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(744), 10,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_elseif,
    ACTIONS(746), 10,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_else,
  [26946] = 9,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(398), 1,
      sym_identifier,
    ACTIONS(964), 1,
      anon_sym_as,
    STATE(199), 1,
      sym_logic_operator,
    STATE(209), 1,
      sym_math_operator,
    ACTIONS(410), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(400), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(406), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(408), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [26986] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(388), 5,
      anon_sym_as,
      anon_sym_PIPE,
      sym_identifier,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(386), 15,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [27014] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(346), 10,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_elseif,
    ACTIONS(348), 10,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_else,
  [27042] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(350), 10,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_elseif,
    ACTIONS(352), 10,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_else,
  [27070] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(966), 1,
      anon_sym_PIPE,
    ACTIONS(276), 4,
      anon_sym_as,
      sym_identifier,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(278), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [27102] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_COLON,
    ACTIONS(276), 4,
      anon_sym_as,
      sym_identifier,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(278), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [27134] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(326), 1,
      anon_sym_COLON,
    ACTIONS(308), 4,
      anon_sym_as,
      sym_identifier,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(306), 15,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [27164] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(384), 5,
      anon_sym_as,
      anon_sym_PIPE,
      sym_identifier,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(382), 15,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [27192] = 3,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(390), 1,
      anon_sym_SEMI,
    ACTIONS(392), 19,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_identifier,
      sym_range,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
      anon_sym_LBRACK,
      anon_sym_STAR,
  [27220] = 5,
    ACTIONS(3), 1,
      sym__comment,
    STATE(199), 1,
      sym_logic_operator,
    STATE(209), 1,
      sym_math_operator,
    ACTIONS(394), 4,
      anon_sym_as,
      sym_identifier,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(396), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [27252] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(356), 4,
      anon_sym_as,
      sym_identifier,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(354), 16,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [27280] = 5,
    ACTIONS(3), 1,
      sym__comment,
    STATE(236), 1,
      sym_math_operator,
    STATE(237), 1,
      sym_logic_operator,
    ACTIONS(394), 4,
      anon_sym_as,
      sym_identifier,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(396), 13,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [27311] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(366), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(968), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(423), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(368), 14,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [27342] = 9,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(398), 1,
      sym_identifier,
    ACTIONS(964), 1,
      anon_sym_as,
    STATE(236), 1,
      sym_math_operator,
    STATE(237), 1,
      sym_logic_operator,
    ACTIONS(400), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(410), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(406), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(408), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [27381] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(970), 1,
      anon_sym_DASH_GT,
    ACTIONS(430), 5,
      anon_sym_as,
      sym_identifier,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(428), 13,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [27410] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(972), 1,
      anon_sym_as,
    ACTIONS(974), 1,
      anon_sym_async,
    ACTIONS(976), 1,
      anon_sym_LBRACE,
    STATE(229), 1,
      sym_math_operator,
    STATE(230), 1,
      sym_logic_operator,
    STATE(398), 1,
      sym_block,
    ACTIONS(410), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(406), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(408), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [27451] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(366), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(978), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(439), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(368), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [27482] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(362), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(978), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(418), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(358), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [27513] = 6,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(284), 1,
      anon_sym_COLON,
    ACTIONS(980), 1,
      anon_sym_COLON_COLON,
    ACTIONS(276), 3,
      anon_sym_as,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(278), 13,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [27546] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(982), 1,
      anon_sym_COLON_COLON,
    ACTIONS(284), 3,
      anon_sym_COLON,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(326), 15,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [27575] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(980), 1,
      anon_sym_COLON_COLON,
    ACTIONS(284), 4,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(326), 14,
      anon_sym_LPAREN,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [27604] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(372), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(984), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(423), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(374), 14,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [27635] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(362), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(968), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(414), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(358), 14,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [27666] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(972), 1,
      anon_sym_as,
    ACTIONS(987), 1,
      anon_sym_async,
    ACTIONS(989), 1,
      anon_sym_LBRACE,
    STATE(229), 1,
      sym_math_operator,
    STATE(230), 1,
      sym_logic_operator,
    STATE(338), 1,
      sym_block,
    ACTIONS(410), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(406), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(408), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [27707] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(972), 1,
      anon_sym_as,
    ACTIONS(991), 1,
      anon_sym_async,
    ACTIONS(993), 1,
      anon_sym_LBRACE,
    STATE(229), 1,
      sym_math_operator,
    STATE(230), 1,
      sym_logic_operator,
    STATE(536), 1,
      sym_block,
    ACTIONS(410), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(406), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(408), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [27748] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(995), 1,
      anon_sym_DASH_GT,
    ACTIONS(424), 5,
      anon_sym_as,
      sym_identifier,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(422), 13,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [27777] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(972), 1,
      anon_sym_as,
    ACTIONS(987), 1,
      anon_sym_async,
    ACTIONS(989), 1,
      anon_sym_LBRACE,
    STATE(229), 1,
      sym_math_operator,
    STATE(230), 1,
      sym_logic_operator,
    STATE(325), 1,
      sym_block,
    ACTIONS(410), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(406), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(408), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [27818] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(972), 1,
      anon_sym_as,
    ACTIONS(997), 1,
      anon_sym_async,
    ACTIONS(999), 1,
      anon_sym_LBRACE,
    STATE(229), 1,
      sym_math_operator,
    STATE(230), 1,
      sym_logic_operator,
    STATE(291), 1,
      sym_block,
    ACTIONS(410), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(406), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(408), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [27859] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(386), 9,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(388), 10,
      anon_sym_PIPE,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [27886] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    STATE(432), 1,
      aux_sym_enum_definition_repeat2,
    ACTIONS(760), 8,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(762), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [27917] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1001), 1,
      anon_sym_LBRACE,
    STATE(432), 1,
      aux_sym_enum_definition_repeat2,
    ACTIONS(768), 8,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(770), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [27948] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(966), 1,
      anon_sym_PIPE,
    ACTIONS(276), 4,
      anon_sym_as,
      sym_identifier,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(278), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [27977] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1004), 1,
      anon_sym_LT,
    STATE(504), 1,
      sym_type_arguments,
    ACTIONS(414), 3,
      anon_sym_as,
      sym_identifier,
      anon_sym_GT,
    ACTIONS(412), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [28008] = 5,
    ACTIONS(3), 1,
      sym__comment,
    STATE(236), 1,
      sym_math_operator,
    STATE(237), 1,
      sym_logic_operator,
    ACTIONS(420), 4,
      anon_sym_as,
      sym_identifier,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(418), 13,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [28039] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1006), 1,
      anon_sym_DASH_GT,
    ACTIONS(422), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
    ACTIONS(424), 11,
      sym_identifier,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_list,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [28068] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(382), 9,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(384), 10,
      anon_sym_PIPE,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [28095] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    STATE(431), 1,
      aux_sym_enum_definition_repeat2,
    ACTIONS(764), 8,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(766), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [28126] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(372), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1008), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(439), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(374), 14,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [28157] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1011), 1,
      anon_sym_DASH_GT,
    ACTIONS(428), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
    ACTIONS(430), 11,
      sym_identifier,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_list,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [28186] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(972), 1,
      anon_sym_as,
    ACTIONS(997), 1,
      anon_sym_async,
    ACTIONS(999), 1,
      anon_sym_LBRACE,
    STATE(229), 1,
      sym_math_operator,
    STATE(230), 1,
      sym_logic_operator,
    STATE(296), 1,
      sym_block,
    ACTIONS(410), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(406), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(408), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [28227] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(276), 1,
      anon_sym_GT,
    ACTIONS(284), 1,
      anon_sym_COLON,
    ACTIONS(982), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1013), 1,
      anon_sym_LT,
    STATE(753), 1,
      sym_type_specification,
    ACTIONS(280), 2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
    ACTIONS(278), 12,
      anon_sym_as,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [28264] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1015), 1,
      anon_sym_LT,
    ACTIONS(412), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
    ACTIONS(414), 11,
      sym_identifier,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_list,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [28293] = 6,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(284), 1,
      anon_sym_COLON,
    ACTIONS(982), 1,
      anon_sym_COLON_COLON,
    ACTIONS(276), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(278), 14,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [28326] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(955), 1,
      anon_sym_LBRACE,
    STATE(432), 1,
      aux_sym_enum_definition_repeat2,
    ACTIONS(764), 8,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(766), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [28357] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(972), 1,
      anon_sym_as,
    ACTIONS(991), 1,
      anon_sym_async,
    ACTIONS(993), 1,
      anon_sym_LBRACE,
    STATE(229), 1,
      sym_math_operator,
    STATE(230), 1,
      sym_logic_operator,
    STATE(507), 1,
      sym_block,
    ACTIONS(410), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(406), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(408), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [28398] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(712), 1,
      anon_sym_PIPE,
    ACTIONS(777), 8,
      anon_sym_SEMI,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(775), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [28429] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(712), 1,
      anon_sym_PIPE,
    ACTIONS(775), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(777), 9,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
  [28458] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(276), 4,
      anon_sym_as,
      sym_identifier,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(278), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [28487] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(356), 3,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(354), 16,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_DASH_GT,
  [28514] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1017), 1,
      sym_identifier,
    ACTIONS(1020), 1,
      anon_sym_LPAREN,
    ACTIONS(1025), 1,
      anon_sym_LBRACE,
    ACTIONS(1028), 1,
      anon_sym_LBRACK,
    ACTIONS(1034), 1,
      anon_sym_list,
    STATE(451), 1,
      aux_sym_type_repeat2,
    STATE(520), 1,
      sym_type,
    ACTIONS(1023), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_GT,
    ACTIONS(1031), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [28555] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(972), 1,
      anon_sym_as,
    ACTIONS(974), 1,
      anon_sym_async,
    ACTIONS(976), 1,
      anon_sym_LBRACE,
    STATE(229), 1,
      sym_math_operator,
    STATE(230), 1,
      sym_logic_operator,
    STATE(401), 1,
      sym_block,
    ACTIONS(410), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(406), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(408), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [28596] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(1037), 1,
      anon_sym_PIPE,
    ACTIONS(276), 4,
      anon_sym_as,
      sym_identifier,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(278), 13,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [28627] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(438), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
    ACTIONS(440), 11,
      sym_identifier,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_list,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [28653] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(274), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(272), 16,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [28679] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(340), 3,
      anon_sym_as,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(338), 15,
      anon_sym_LPAREN,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [28705] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(412), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
    ACTIONS(414), 11,
      sym_identifier,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_list,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [28731] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(294), 3,
      anon_sym_as,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(292), 15,
      anon_sym_LPAREN,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [28757] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(342), 9,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(344), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [28783] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(460), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
    ACTIONS(462), 11,
      sym_identifier,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_list,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [28809] = 7,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(284), 1,
      anon_sym_COLON,
    ACTIONS(982), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1039), 1,
      anon_sym_RPAREN,
    ACTIONS(276), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(278), 12,
      anon_sym_as,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [28843] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(266), 3,
      anon_sym_as,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(264), 15,
      anon_sym_LPAREN,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [28869] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(298), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(296), 16,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [28895] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(326), 1,
      anon_sym_COLON,
    ACTIONS(308), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(306), 15,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [28923] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(274), 3,
      anon_sym_as,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(272), 15,
      anon_sym_LPAREN,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [28949] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(456), 4,
      anon_sym_as,
      sym_identifier,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(454), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [28975] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(308), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(306), 16,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [29001] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(436), 4,
      anon_sym_as,
      sym_identifier,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(434), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [29027] = 3,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(392), 17,
      anon_sym_as,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [29053] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(352), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(350), 16,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [29079] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(312), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(310), 16,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [29105] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(316), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(314), 16,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [29131] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(398), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(400), 9,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
  [29157] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(346), 9,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(348), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [29183] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(452), 4,
      anon_sym_as,
      sym_identifier,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(450), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [29209] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(344), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(342), 16,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [29235] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(326), 1,
      anon_sym_COLON,
    ACTIONS(276), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(280), 2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
    ACTIONS(278), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [29265] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(801), 9,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(803), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [29291] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(270), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(268), 16,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [29317] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(308), 3,
      anon_sym_as,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(306), 15,
      anon_sym_LPAREN,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [29343] = 5,
    ACTIONS(3), 1,
      sym__comment,
    STATE(229), 1,
      sym_math_operator,
    STATE(230), 1,
      sym_logic_operator,
    ACTIONS(394), 3,
      anon_sym_as,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(396), 13,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [29373] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(428), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
    ACTIONS(430), 11,
      sym_identifier,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_list,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [29399] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(795), 9,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(797), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [29425] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(676), 9,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(678), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [29451] = 5,
    ACTIONS(3), 1,
      sym__comment,
    STATE(229), 1,
      sym_math_operator,
    STATE(230), 1,
      sym_logic_operator,
    ACTIONS(420), 3,
      anon_sym_as,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(418), 13,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [29481] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(779), 9,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(781), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [29507] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(336), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(334), 16,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [29533] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(324), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(322), 16,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [29559] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1041), 1,
      anon_sym_LPAREN,
    ACTIONS(330), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(328), 15,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [29587] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(284), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(326), 16,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [29613] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(348), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(346), 16,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [29639] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(320), 3,
      anon_sym_as,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(318), 15,
      anon_sym_LPAREN,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [29665] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(304), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(302), 16,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [29691] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(304), 3,
      anon_sym_as,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(302), 15,
      anon_sym_LPAREN,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [29717] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1043), 1,
      anon_sym_LPAREN,
    ACTIONS(330), 3,
      anon_sym_as,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(328), 14,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [29745] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(324), 3,
      anon_sym_as,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(322), 15,
      anon_sym_LPAREN,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [29771] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(414), 4,
      anon_sym_as,
      sym_identifier,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(412), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [29797] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1045), 1,
      anon_sym_LT,
    ACTIONS(414), 3,
      anon_sym_as,
      sym_identifier,
      anon_sym_GT,
    ACTIONS(412), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [29825] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(350), 9,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(352), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [29851] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(336), 3,
      anon_sym_as,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(334), 15,
      anon_sym_LPAREN,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [29877] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(829), 9,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(831), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [29903] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(270), 3,
      anon_sym_as,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(268), 15,
      anon_sym_LPAREN,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [29929] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(795), 9,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(797), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [29955] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(424), 4,
      anon_sym_as,
      sym_identifier,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(422), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [29981] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(320), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(318), 16,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [30007] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_COLON,
    ACTIONS(276), 3,
      anon_sym_as,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(278), 13,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [30037] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(809), 9,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(811), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [30063] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(775), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(777), 9,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
  [30089] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(430), 4,
      anon_sym_as,
      sym_identifier,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(428), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [30115] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(791), 9,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(793), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [30141] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(440), 4,
      anon_sym_as,
      sym_identifier,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(438), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [30167] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(284), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(326), 16,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [30193] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(462), 4,
      anon_sym_as,
      sym_identifier,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(460), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [30219] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(783), 9,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(785), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [30245] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(316), 3,
      anon_sym_as,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(314), 15,
      anon_sym_LPAREN,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [30271] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(312), 3,
      anon_sym_as,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(310), 15,
      anon_sym_LPAREN,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [30297] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(837), 9,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(839), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [30323] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(352), 3,
      anon_sym_as,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(350), 15,
      anon_sym_LPAREN,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [30349] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(348), 3,
      anon_sym_as,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(346), 15,
      anon_sym_LPAREN,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [30375] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1051), 1,
      anon_sym_COMMA,
    ACTIONS(1049), 6,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
    ACTIONS(1047), 11,
      sym_identifier,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_list,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [30403] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(326), 1,
      anon_sym_COLON,
    ACTIONS(308), 3,
      anon_sym_as,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(306), 14,
      anon_sym_LPAREN,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [30431] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(344), 3,
      anon_sym_as,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(342), 15,
      anon_sym_LPAREN,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [30457] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(340), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(338), 16,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [30483] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(446), 4,
      anon_sym_as,
      sym_identifier,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(444), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [30509] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(298), 3,
      anon_sym_as,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(296), 15,
      anon_sym_LPAREN,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [30535] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(825), 9,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(827), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [30561] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(787), 9,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(789), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [30587] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(422), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
    ACTIONS(424), 11,
      sym_identifier,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_list,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [30613] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(294), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(292), 16,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [30639] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(813), 9,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(815), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [30665] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(817), 9,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(819), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [30691] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1037), 1,
      anon_sym_PIPE,
    ACTIONS(276), 4,
      anon_sym_as,
      sym_identifier,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(278), 13,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [30719] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(266), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(264), 16,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [30745] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(805), 9,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(807), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [30771] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(284), 3,
      anon_sym_as,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(326), 15,
      anon_sym_LPAREN,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [30797] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(841), 9,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(843), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [30823] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(833), 9,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(835), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [30849] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(821), 9,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(823), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [30875] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(284), 3,
      anon_sym_as,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(326), 15,
      anon_sym_LPAREN,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [30901] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(356), 3,
      anon_sym_as,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(354), 15,
      anon_sym_LPAREN,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [30927] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1053), 1,
      anon_sym_SEMI,
    ACTIONS(783), 8,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(785), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [30955] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1055), 1,
      anon_sym_SEMI,
    ACTIONS(795), 8,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(797), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [30983] = 5,
    ACTIONS(3), 1,
      sym__comment,
    STATE(240), 1,
      sym_math_operator,
    STATE(242), 1,
      sym_logic_operator,
    ACTIONS(420), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(418), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [31012] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1061), 1,
      anon_sym_RPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    STATE(451), 1,
      aux_sym_type_repeat2,
    STATE(520), 1,
      sym_type,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [31051] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(414), 1,
      anon_sym_GT,
    ACTIONS(1071), 1,
      anon_sym_LT,
    STATE(633), 1,
      sym_type_arguments,
    ACTIONS(412), 14,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [31080] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1073), 1,
      anon_sym_GT,
    STATE(451), 1,
      aux_sym_type_repeat2,
    STATE(520), 1,
      sym_type,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [31119] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1079), 1,
      anon_sym_COMMA,
    ACTIONS(1077), 7,
      anon_sym_LPAREN,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(1075), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [31146] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1081), 1,
      anon_sym_RBRACK,
    STATE(451), 1,
      aux_sym_type_repeat2,
    STATE(520), 1,
      sym_type,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [31185] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1083), 1,
      anon_sym_RBRACK,
    STATE(520), 1,
      sym_type,
    STATE(555), 1,
      aux_sym_type_repeat2,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [31224] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1085), 1,
      anon_sym_RPAREN,
    STATE(451), 1,
      aux_sym_type_repeat2,
    STATE(520), 1,
      sym_type,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [31263] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1087), 1,
      anon_sym_RPAREN,
    STATE(451), 1,
      aux_sym_type_repeat2,
    STATE(520), 1,
      sym_type,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [31302] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1089), 1,
      anon_sym_RPAREN,
    ACTIONS(1091), 1,
      anon_sym_as,
    STATE(232), 1,
      sym_logic_operator,
    STATE(235), 1,
      sym_math_operator,
    ACTIONS(410), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(406), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(408), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [31337] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1093), 1,
      anon_sym_DASH_GT,
    ACTIONS(424), 3,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(422), 13,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [31364] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(388), 3,
      anon_sym_as,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(386), 14,
      anon_sym_LPAREN,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [31389] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1095), 1,
      anon_sym_RBRACK,
    STATE(451), 1,
      aux_sym_type_repeat2,
    STATE(520), 1,
      sym_type,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [31428] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1097), 1,
      anon_sym_RPAREN,
    STATE(520), 1,
      sym_type,
    STATE(551), 1,
      aux_sym_type_repeat2,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [31467] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(384), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(382), 15,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [31492] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1091), 1,
      anon_sym_as,
    ACTIONS(1099), 1,
      anon_sym_RPAREN,
    STATE(232), 1,
      sym_logic_operator,
    STATE(235), 1,
      sym_math_operator,
    ACTIONS(410), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(406), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(408), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [31527] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1101), 1,
      anon_sym_DASH_GT,
    ACTIONS(430), 3,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(428), 13,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [31554] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1103), 1,
      anon_sym_GT,
    STATE(451), 1,
      aux_sym_type_repeat2,
    STATE(520), 1,
      sym_type,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [31593] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1105), 1,
      anon_sym_GT,
    STATE(451), 1,
      aux_sym_type_repeat2,
    STATE(520), 1,
      sym_type,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [31632] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1107), 1,
      anon_sym_RBRACK,
    STATE(451), 1,
      aux_sym_type_repeat2,
    STATE(520), 1,
      sym_type,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [31671] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(388), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(386), 15,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [31696] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1109), 1,
      anon_sym_RBRACK,
    STATE(520), 1,
      sym_type,
    STATE(548), 1,
      aux_sym_type_repeat2,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [31735] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1111), 1,
      anon_sym_RPAREN,
    STATE(520), 1,
      sym_type,
    STATE(550), 1,
      aux_sym_type_repeat2,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [31774] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1113), 1,
      anon_sym_RBRACK,
    STATE(520), 1,
      sym_type,
    STATE(597), 1,
      aux_sym_type_repeat2,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [31813] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1115), 1,
      anon_sym_RPAREN,
    STATE(451), 1,
      aux_sym_type_repeat2,
    STATE(520), 1,
      sym_type,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [31852] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1117), 1,
      anon_sym_GT,
    STATE(451), 1,
      aux_sym_type_repeat2,
    STATE(520), 1,
      sym_type,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [31891] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1119), 1,
      anon_sym_RPAREN,
    STATE(451), 1,
      aux_sym_type_repeat2,
    STATE(520), 1,
      sym_type,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [31930] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1121), 1,
      anon_sym_RPAREN,
    STATE(520), 1,
      sym_type,
    STATE(569), 1,
      aux_sym_type_repeat2,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [31969] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1023), 6,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
    ACTIONS(1123), 11,
      sym_identifier,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_list,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [31994] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1091), 1,
      anon_sym_as,
    ACTIONS(1125), 1,
      anon_sym_RPAREN,
    STATE(232), 1,
      sym_logic_operator,
    STATE(235), 1,
      sym_math_operator,
    ACTIONS(410), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(406), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(408), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [32029] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1091), 1,
      anon_sym_as,
    ACTIONS(1127), 1,
      anon_sym_LBRACE,
    STATE(240), 1,
      sym_math_operator,
    STATE(242), 1,
      sym_logic_operator,
    ACTIONS(410), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(406), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(408), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [32064] = 5,
    ACTIONS(3), 1,
      sym__comment,
    STATE(240), 1,
      sym_math_operator,
    STATE(242), 1,
      sym_logic_operator,
    ACTIONS(394), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(396), 13,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [32093] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1129), 1,
      anon_sym_GT,
    STATE(451), 1,
      aux_sym_type_repeat2,
    STATE(520), 1,
      sym_type,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [32132] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1131), 1,
      anon_sym_RBRACK,
    STATE(520), 1,
      sym_type,
    STATE(562), 1,
      aux_sym_type_repeat2,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [32171] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1133), 1,
      anon_sym_RPAREN,
    STATE(520), 1,
      sym_type,
    STATE(595), 1,
      aux_sym_type_repeat2,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [32210] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1135), 1,
      anon_sym_RPAREN,
    STATE(520), 1,
      sym_type,
    STATE(567), 1,
      aux_sym_type_repeat2,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [32249] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(384), 3,
      anon_sym_as,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(382), 14,
      anon_sym_LPAREN,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [32274] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1137), 1,
      anon_sym_RBRACK,
    STATE(451), 1,
      aux_sym_type_repeat2,
    STATE(520), 1,
      sym_type,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [32313] = 5,
    ACTIONS(3), 1,
      sym__comment,
    STATE(232), 1,
      sym_logic_operator,
    STATE(235), 1,
      sym_math_operator,
    ACTIONS(394), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(396), 13,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [32342] = 5,
    ACTIONS(3), 1,
      sym__comment,
    STATE(232), 1,
      sym_logic_operator,
    STATE(235), 1,
      sym_math_operator,
    ACTIONS(420), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(418), 13,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [32371] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_COLON,
    ACTIONS(276), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(278), 13,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [32400] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1139), 1,
      anon_sym_RBRACK,
    STATE(520), 1,
      sym_type,
    STATE(580), 1,
      aux_sym_type_repeat2,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [32439] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1091), 1,
      anon_sym_as,
    ACTIONS(1141), 1,
      anon_sym_RPAREN,
    STATE(232), 1,
      sym_logic_operator,
    STATE(235), 1,
      sym_math_operator,
    ACTIONS(410), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(406), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(408), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [32474] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1091), 1,
      anon_sym_as,
    ACTIONS(1143), 1,
      anon_sym_LBRACE,
    STATE(240), 1,
      sym_math_operator,
    STATE(242), 1,
      sym_logic_operator,
    ACTIONS(410), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(406), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(408), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [32509] = 3,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(392), 16,
      anon_sym_as,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [32534] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1145), 1,
      anon_sym_LT,
    STATE(610), 1,
      sym_type_arguments,
    ACTIONS(414), 2,
      anon_sym_as,
      anon_sym_GT,
    ACTIONS(412), 13,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [32563] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(276), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(278), 14,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [32590] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1147), 1,
      anon_sym_GT,
    STATE(451), 1,
      aux_sym_type_repeat2,
    STATE(520), 1,
      sym_type,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [32629] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1149), 1,
      anon_sym_RBRACK,
    STATE(451), 1,
      aux_sym_type_repeat2,
    STATE(520), 1,
      sym_type,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [32668] = 3,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(390), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(392), 16,
      anon_sym_RPAREN,
      anon_sym_as,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [32693] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1151), 1,
      anon_sym_RPAREN,
    STATE(520), 1,
      sym_type,
    STATE(598), 1,
      aux_sym_type_repeat2,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [32732] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1153), 1,
      anon_sym_RBRACK,
    STATE(520), 1,
      sym_type,
    STATE(591), 1,
      aux_sym_type_repeat2,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [32771] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1155), 1,
      anon_sym_RPAREN,
    STATE(451), 1,
      aux_sym_type_repeat2,
    STATE(520), 1,
      sym_type,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [32810] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1157), 1,
      anon_sym_DASH_GT,
    ACTIONS(430), 4,
      anon_sym_as,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(428), 12,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [32837] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1159), 1,
      anon_sym_RBRACK,
    STATE(451), 1,
      aux_sym_type_repeat2,
    STATE(520), 1,
      sym_type,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [32876] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1161), 1,
      anon_sym_RPAREN,
    STATE(451), 1,
      aux_sym_type_repeat2,
    STATE(520), 1,
      sym_type,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [32915] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(276), 3,
      anon_sym_as,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(278), 13,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [32942] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1163), 1,
      anon_sym_RPAREN,
    STATE(520), 1,
      sym_type,
    STATE(544), 1,
      aux_sym_type_repeat2,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [32981] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1165), 1,
      anon_sym_GT,
    STATE(451), 1,
      aux_sym_type_repeat2,
    STATE(520), 1,
      sym_type,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [33020] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1091), 1,
      anon_sym_as,
    ACTIONS(1167), 1,
      anon_sym_RPAREN,
    STATE(232), 1,
      sym_logic_operator,
    STATE(235), 1,
      sym_math_operator,
    ACTIONS(410), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(406), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(408), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [33055] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1169), 1,
      anon_sym_DASH_GT,
    ACTIONS(424), 4,
      anon_sym_as,
      anon_sym_DASH,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(422), 12,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [33082] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(452), 3,
      anon_sym_as,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(450), 13,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [33106] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(436), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(434), 14,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [33130] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(440), 3,
      anon_sym_as,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(438), 13,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [33154] = 9,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    STATE(520), 1,
      sym_type,
    STATE(546), 1,
      aux_sym_type_repeat2,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [33190] = 9,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    STATE(520), 1,
      sym_type,
    STATE(560), 1,
      aux_sym_type_repeat2,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [33226] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(430), 3,
      anon_sym_as,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(428), 13,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [33250] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(424), 3,
      anon_sym_as,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(422), 13,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [33274] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(276), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(280), 2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
    ACTIONS(278), 12,
      anon_sym_as,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [33300] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(456), 3,
      anon_sym_as,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(454), 13,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [33324] = 7,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1091), 1,
      anon_sym_as,
    STATE(232), 1,
      sym_logic_operator,
    STATE(235), 1,
      sym_math_operator,
    ACTIONS(410), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(406), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(408), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [33356] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1171), 1,
      anon_sym_LT,
    ACTIONS(414), 2,
      anon_sym_as,
      anon_sym_GT,
    ACTIONS(412), 13,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [33382] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(414), 3,
      anon_sym_as,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(412), 13,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [33406] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(414), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(412), 14,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [33430] = 9,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    STATE(520), 1,
      sym_type,
    STATE(575), 1,
      aux_sym_type_repeat2,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [33466] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(436), 3,
      anon_sym_as,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(434), 13,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [33490] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(580), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      sym_range,
      anon_sym_LBRACK,
    ACTIONS(1173), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [33514] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(452), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(450), 14,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [33538] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(456), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(454), 14,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [33562] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1177), 7,
      anon_sym_LPAREN,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(1175), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [33586] = 9,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    STATE(520), 1,
      sym_type,
    STATE(561), 1,
      aux_sym_type_repeat2,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [33622] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(446), 3,
      anon_sym_as,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(444), 13,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [33646] = 9,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    STATE(520), 1,
      sym_type,
    STATE(568), 1,
      aux_sym_type_repeat2,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [33682] = 9,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    STATE(520), 1,
      sym_type,
    STATE(590), 1,
      aux_sym_type_repeat2,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [33718] = 9,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    STATE(520), 1,
      sym_type,
    STATE(601), 1,
      aux_sym_type_repeat2,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [33754] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(462), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(460), 14,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [33778] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(440), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(438), 14,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [33802] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(462), 3,
      anon_sym_as,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(460), 13,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [33826] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(446), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(444), 14,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [33850] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(430), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(428), 14,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [33874] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(424), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(422), 14,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [33898] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(414), 1,
      anon_sym_GT,
    ACTIONS(1179), 1,
      anon_sym_LT,
    ACTIONS(412), 14,
      anon_sym_RPAREN,
      anon_sym_as,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [33924] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(552), 7,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      sym_range,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(1181), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [33948] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1183), 1,
      sym_identifier,
    ACTIONS(1185), 1,
      anon_sym_LPAREN,
    STATE(826), 1,
      sym_type,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [33981] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1187), 1,
      sym_identifier,
    ACTIONS(1189), 1,
      anon_sym_LPAREN,
    ACTIONS(1191), 1,
      anon_sym_LBRACE,
    ACTIONS(1193), 1,
      anon_sym_LBRACK,
    ACTIONS(1197), 1,
      anon_sym_list,
    STATE(604), 1,
      sym_type,
    ACTIONS(1195), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [34014] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1199), 1,
      sym_identifier,
    ACTIONS(1201), 1,
      anon_sym_LPAREN,
    ACTIONS(1203), 1,
      anon_sym_LBRACE,
    ACTIONS(1205), 1,
      anon_sym_LBRACK,
    ACTIONS(1209), 1,
      anon_sym_list,
    STATE(249), 1,
      sym_type,
    ACTIONS(1207), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [34047] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1199), 1,
      sym_identifier,
    ACTIONS(1201), 1,
      anon_sym_LPAREN,
    ACTIONS(1203), 1,
      anon_sym_LBRACE,
    ACTIONS(1205), 1,
      anon_sym_LBRACK,
    ACTIONS(1209), 1,
      anon_sym_list,
    STATE(243), 1,
      sym_type,
    ACTIONS(1207), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [34080] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1211), 1,
      sym_identifier,
    ACTIONS(1213), 1,
      anon_sym_LPAREN,
    ACTIONS(1215), 1,
      anon_sym_LBRACE,
    ACTIONS(1217), 1,
      anon_sym_LBRACK,
    ACTIONS(1221), 1,
      anon_sym_list,
    STATE(475), 1,
      sym_type,
    ACTIONS(1219), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [34113] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1183), 1,
      sym_identifier,
    ACTIONS(1185), 1,
      anon_sym_LPAREN,
    STATE(810), 1,
      sym_type,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [34146] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1223), 1,
      sym_identifier,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACE,
    ACTIONS(1229), 1,
      anon_sym_LBRACK,
    ACTIONS(1233), 1,
      anon_sym_list,
    STATE(620), 1,
      sym_type,
    ACTIONS(1231), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [34179] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1187), 1,
      sym_identifier,
    ACTIONS(1189), 1,
      anon_sym_LPAREN,
    ACTIONS(1191), 1,
      anon_sym_LBRACE,
    ACTIONS(1193), 1,
      anon_sym_LBRACK,
    ACTIONS(1197), 1,
      anon_sym_list,
    STATE(606), 1,
      sym_type,
    ACTIONS(1195), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [34212] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1187), 1,
      sym_identifier,
    ACTIONS(1189), 1,
      anon_sym_LPAREN,
    ACTIONS(1191), 1,
      anon_sym_LBRACE,
    ACTIONS(1193), 1,
      anon_sym_LBRACK,
    ACTIONS(1197), 1,
      anon_sym_list,
    STATE(630), 1,
      sym_type,
    ACTIONS(1195), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [34245] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1211), 1,
      sym_identifier,
    ACTIONS(1213), 1,
      anon_sym_LPAREN,
    ACTIONS(1215), 1,
      anon_sym_LBRACE,
    ACTIONS(1217), 1,
      anon_sym_LBRACK,
    ACTIONS(1221), 1,
      anon_sym_list,
    STATE(511), 1,
      sym_type,
    ACTIONS(1219), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [34278] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1183), 1,
      sym_identifier,
    ACTIONS(1185), 1,
      anon_sym_LPAREN,
    STATE(857), 1,
      sym_type,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [34311] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1183), 1,
      sym_identifier,
    ACTIONS(1185), 1,
      anon_sym_LPAREN,
    STATE(856), 1,
      sym_type,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [34344] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1183), 1,
      sym_identifier,
    ACTIONS(1185), 1,
      anon_sym_LPAREN,
    STATE(855), 1,
      sym_type,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [34377] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1183), 1,
      sym_identifier,
    ACTIONS(1185), 1,
      anon_sym_LPAREN,
    STATE(454), 1,
      sym_type,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [34410] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1235), 1,
      anon_sym_RPAREN,
    ACTIONS(456), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(454), 12,
      anon_sym_as,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [34435] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1237), 1,
      anon_sym_RPAREN,
    ACTIONS(456), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(454), 12,
      anon_sym_as,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [34460] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1239), 1,
      anon_sym_RPAREN,
    ACTIONS(456), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(454), 12,
      anon_sym_as,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [34485] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_LPAREN,
    ACTIONS(1245), 1,
      anon_sym_LBRACE,
    ACTIONS(1247), 1,
      anon_sym_LBRACK,
    ACTIONS(1251), 1,
      anon_sym_list,
    STATE(131), 1,
      sym_type,
    ACTIONS(1249), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [34518] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1211), 1,
      sym_identifier,
    ACTIONS(1213), 1,
      anon_sym_LPAREN,
    ACTIONS(1215), 1,
      anon_sym_LBRACE,
    ACTIONS(1217), 1,
      anon_sym_LBRACK,
    ACTIONS(1221), 1,
      anon_sym_list,
    STATE(513), 1,
      sym_type,
    ACTIONS(1219), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [34551] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1183), 1,
      sym_identifier,
    ACTIONS(1185), 1,
      anon_sym_LPAREN,
    STATE(818), 1,
      sym_type,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [34584] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1255), 6,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      sym_range,
      anon_sym_LBRACK,
    ACTIONS(1253), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [34607] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1223), 1,
      sym_identifier,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACE,
    ACTIONS(1229), 1,
      anon_sym_LBRACK,
    ACTIONS(1233), 1,
      anon_sym_list,
    STATE(628), 1,
      sym_type,
    ACTIONS(1231), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [34640] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1183), 1,
      sym_identifier,
    ACTIONS(1185), 1,
      anon_sym_LPAREN,
    STATE(803), 1,
      sym_type,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [34673] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1257), 1,
      anon_sym_RPAREN,
    ACTIONS(456), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(454), 12,
      anon_sym_as,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [34698] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1199), 1,
      sym_identifier,
    ACTIONS(1201), 1,
      anon_sym_LPAREN,
    ACTIONS(1203), 1,
      anon_sym_LBRACE,
    ACTIONS(1205), 1,
      anon_sym_LBRACK,
    ACTIONS(1209), 1,
      anon_sym_list,
    STATE(245), 1,
      sym_type,
    ACTIONS(1207), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [34731] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1183), 1,
      sym_identifier,
    ACTIONS(1185), 1,
      anon_sym_LPAREN,
    STATE(460), 1,
      sym_type,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [34764] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1259), 1,
      anon_sym_RPAREN,
    ACTIONS(456), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(454), 12,
      anon_sym_as,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [34789] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    STATE(454), 1,
      sym_type,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [34822] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1057), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    STATE(460), 1,
      sym_type,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [34855] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1223), 1,
      sym_identifier,
    ACTIONS(1225), 1,
      anon_sym_LPAREN,
    ACTIONS(1227), 1,
      anon_sym_LBRACE,
    ACTIONS(1229), 1,
      anon_sym_LBRACK,
    ACTIONS(1233), 1,
      anon_sym_list,
    STATE(629), 1,
      sym_type,
    ACTIONS(1231), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [34888] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1263), 6,
      anon_sym_LPAREN,
      anon_sym_CARET,
      aux_sym_command_argument_token2,
      anon_sym_LBRACE,
      sym_range,
      anon_sym_LBRACK,
    ACTIONS(1261), 9,
      sym_identifier,
      sym_integer,
      aux_sym_float_token1,
      anon_sym_Infinity,
      anon_sym_infinity,
      anon_sym_NaN,
      anon_sym_nan,
      anon_sym_true,
      anon_sym_false,
  [34911] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1063), 1,
      anon_sym_LBRACE,
    ACTIONS(1065), 1,
      anon_sym_LBRACK,
    ACTIONS(1069), 1,
      anon_sym_list,
    ACTIONS(1183), 1,
      sym_identifier,
    ACTIONS(1185), 1,
      anon_sym_LPAREN,
    STATE(859), 1,
      sym_type,
    ACTIONS(1067), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [34944] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_LPAREN,
    ACTIONS(1245), 1,
      anon_sym_LBRACE,
    ACTIONS(1247), 1,
      anon_sym_LBRACK,
    ACTIONS(1251), 1,
      anon_sym_list,
    STATE(138), 1,
      sym_type,
    ACTIONS(1249), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [34977] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1241), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      anon_sym_LPAREN,
    ACTIONS(1245), 1,
      anon_sym_LBRACE,
    ACTIONS(1247), 1,
      anon_sym_LBRACK,
    ACTIONS(1251), 1,
      anon_sym_list,
    STATE(126), 1,
      sym_type,
    ACTIONS(1249), 9,
      anon_sym_any,
      anon_sym_bool,
      anon_sym_collection,
      anon_sym_float,
      anon_sym_int,
      anon_sym_map,
      anon_sym_none,
      anon_sym_num,
      anon_sym_str,
  [35010] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(362), 2,
      anon_sym_SEMI,
      anon_sym_PIPE,
    ACTIONS(1265), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(672), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(358), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      sym_identifier,
  [35031] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(372), 2,
      anon_sym_SEMI,
      anon_sym_PIPE,
    ACTIONS(1267), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(671), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(374), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      sym_identifier,
  [35052] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(366), 2,
      anon_sym_SEMI,
      anon_sym_PIPE,
    ACTIONS(1265), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(671), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
    ACTIONS(368), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      sym_identifier,
  [35073] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(366), 2,
      anon_sym_SEMI,
      anon_sym_PIPE,
    ACTIONS(368), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(1270), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(675), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
  [35093] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(358), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(362), 2,
      anon_sym_SEMI,
      anon_sym_PIPE,
    ACTIONS(1270), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(673), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
  [35113] = 5,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(372), 2,
      anon_sym_SEMI,
      anon_sym_PIPE,
    ACTIONS(374), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(1272), 2,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
    STATE(675), 2,
      sym_command_argument,
      aux_sym_command_repeat1,
  [35133] = 3,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(390), 2,
      anon_sym_SEMI,
      anon_sym_PIPE,
    ACTIONS(392), 5,
      anon_sym_COMMA,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
      anon_sym_RBRACE,
      sym_identifier,
  [35148] = 6,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(284), 1,
      anon_sym_COLON,
    ACTIONS(1275), 1,
      anon_sym_LT,
    ACTIONS(1277), 1,
      anon_sym_COLON_COLON,
    STATE(753), 1,
      sym_type_specification,
    ACTIONS(280), 2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [35168] = 3,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(390), 2,
      anon_sym_SEMI,
      anon_sym_PIPE,
    ACTIONS(392), 4,
      aux_sym_command_argument_token1,
      aux_sym_command_argument_token2,
      anon_sym_RBRACE,
      sym_identifier,
  [35182] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(382), 6,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      sym_identifier,
  [35194] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(386), 6,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      sym_identifier,
  [35206] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(1279), 1,
      anon_sym_PIPE,
    ACTIONS(777), 4,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      sym_identifier,
  [35222] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(957), 1,
      anon_sym_LT,
    ACTIONS(1283), 1,
      anon_sym_COMMA,
    STATE(726), 1,
      sym_type_arguments,
    ACTIONS(1281), 2,
      anon_sym_RBRACE,
      sym_identifier,
  [35239] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1285), 5,
      anon_sym_async,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [35250] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1285), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      sym_identifier,
      anon_sym_EQ,
  [35261] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(1287), 1,
      anon_sym_PIPE,
    ACTIONS(777), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      sym_identifier,
  [35276] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1279), 1,
      anon_sym_PIPE,
    ACTIONS(777), 4,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      sym_identifier,
  [35289] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1287), 1,
      anon_sym_PIPE,
    ACTIONS(777), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      sym_identifier,
  [35301] = 3,
    ACTIONS(3), 1,
      sym__comment,
    STATE(60), 1,
      sym_assignment_operator,
    ACTIONS(288), 3,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [35313] = 3,
    ACTIONS(3), 1,
      sym__comment,
    STATE(64), 1,
      sym_assignment_operator,
    ACTIONS(288), 3,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [35325] = 3,
    ACTIONS(3), 1,
      sym__comment,
    STATE(47), 1,
      sym_assignment_operator,
    ACTIONS(288), 3,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [35337] = 3,
    ACTIONS(3), 1,
      sym__comment,
    STATE(61), 1,
      sym_assignment_operator,
    ACTIONS(288), 3,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [35349] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(284), 1,
      anon_sym_COLON,
    ACTIONS(1277), 1,
      anon_sym_COLON_COLON,
    ACTIONS(326), 2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [35363] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1289), 1,
      anon_sym_EQ,
    STATE(64), 1,
      sym_assignment_operator,
    ACTIONS(288), 2,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [35377] = 3,
    ACTIONS(3), 1,
      sym__comment,
    STATE(52), 1,
      sym_assignment_operator,
    ACTIONS(288), 3,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
  [35389] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1291), 1,
      sym_identifier,
    ACTIONS(1293), 1,
      anon_sym_RBRACE,
    STATE(742), 1,
      aux_sym_map_repeat1,
  [35402] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1295), 1,
      sym_identifier,
    ACTIONS(1298), 1,
      anon_sym_RPAREN,
    STATE(696), 1,
      aux_sym_function_repeat1,
  [35415] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(987), 1,
      anon_sym_async,
    ACTIONS(989), 1,
      anon_sym_LBRACE,
    STATE(316), 1,
      sym_block,
  [35428] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1291), 1,
      sym_identifier,
    ACTIONS(1300), 1,
      anon_sym_RBRACE,
    STATE(701), 1,
      aux_sym_map_repeat1,
  [35441] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1302), 1,
      sym_identifier,
    ACTIONS(1304), 1,
      anon_sym_RPAREN,
    STATE(696), 1,
      aux_sym_function_repeat1,
  [35454] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1306), 1,
      sym_identifier,
    ACTIONS(1309), 1,
      anon_sym_RBRACE,
    STATE(700), 1,
      aux_sym_type_repeat1,
  [35467] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1291), 1,
      sym_identifier,
    ACTIONS(1311), 1,
      anon_sym_RBRACE,
    STATE(755), 1,
      aux_sym_map_repeat1,
  [35480] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(738), 1,
      anon_sym_LBRACE,
    ACTIONS(1313), 1,
      sym_identifier,
    STATE(84), 1,
      sym_map,
  [35493] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1302), 1,
      sym_identifier,
    ACTIONS(1315), 1,
      anon_sym_RPAREN,
    STATE(696), 1,
      aux_sym_function_repeat1,
  [35506] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1302), 1,
      sym_identifier,
    ACTIONS(1317), 1,
      anon_sym_RPAREN,
    STATE(696), 1,
      aux_sym_function_repeat1,
  [35519] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(987), 1,
      anon_sym_async,
    ACTIONS(989), 1,
      anon_sym_LBRACE,
    STATE(80), 1,
      sym_block,
  [35532] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1321), 1,
      anon_sym_COMMA,
    ACTIONS(1319), 2,
      anon_sym_RBRACE,
      sym_identifier,
  [35543] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(987), 1,
      anon_sym_async,
    ACTIONS(989), 1,
      anon_sym_LBRACE,
    STATE(76), 1,
      sym_block,
  [35556] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1137), 1,
      anon_sym_RBRACE,
    ACTIONS(1323), 1,
      sym_identifier,
    STATE(700), 1,
      aux_sym_type_repeat1,
  [35569] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1302), 1,
      sym_identifier,
    ACTIONS(1325), 1,
      anon_sym_RPAREN,
    STATE(696), 1,
      aux_sym_function_repeat1,
  [35582] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(991), 1,
      anon_sym_async,
    ACTIONS(993), 1,
      anon_sym_LBRACE,
    STATE(486), 1,
      sym_block,
  [35595] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1302), 1,
      sym_identifier,
    ACTIONS(1327), 1,
      anon_sym_RPAREN,
    STATE(696), 1,
      aux_sym_function_repeat1,
  [35608] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(626), 1,
      anon_sym_LBRACE,
    ACTIONS(1329), 1,
      sym_identifier,
    STATE(373), 1,
      sym_map,
  [35621] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1331), 1,
      sym_identifier,
    ACTIONS(1333), 1,
      anon_sym_RBRACE,
    STATE(737), 1,
      aux_sym_struct_definition_repeat1,
  [35634] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1275), 1,
      anon_sym_LT,
    ACTIONS(1335), 1,
      anon_sym_EQ,
    STATE(734), 1,
      sym_type_specification,
  [35647] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1337), 1,
      anon_sym_async,
    ACTIONS(1339), 1,
      anon_sym_LBRACE,
    STATE(365), 1,
      sym_block,
  [35660] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1291), 1,
      sym_identifier,
    ACTIONS(1341), 1,
      anon_sym_RBRACE,
    STATE(748), 1,
      aux_sym_map_repeat1,
  [35673] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(738), 1,
      anon_sym_LBRACE,
    ACTIONS(1343), 1,
      sym_identifier,
    STATE(84), 1,
      sym_map,
  [35686] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1291), 1,
      sym_identifier,
    ACTIONS(1345), 1,
      anon_sym_RBRACE,
    STATE(755), 1,
      aux_sym_map_repeat1,
  [35699] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1347), 1,
      sym_identifier,
    ACTIONS(1349), 1,
      anon_sym_RBRACE,
    STATE(732), 1,
      aux_sym_enum_definition_repeat1,
  [35712] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1337), 1,
      anon_sym_async,
    ACTIONS(1339), 1,
      anon_sym_LBRACE,
    STATE(371), 1,
      sym_block,
  [35725] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1081), 1,
      anon_sym_RBRACE,
    ACTIONS(1323), 1,
      sym_identifier,
    STATE(700), 1,
      aux_sym_type_repeat1,
  [35738] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1095), 1,
      anon_sym_RBRACE,
    ACTIONS(1323), 1,
      sym_identifier,
    STATE(700), 1,
      aux_sym_type_repeat1,
  [35751] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1351), 1,
      anon_sym_async,
    ACTIONS(1353), 1,
      anon_sym_LBRACE,
    STATE(462), 1,
      sym_block,
  [35764] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(478), 1,
      anon_sym_LBRACE,
    ACTIONS(1355), 1,
      sym_identifier,
    STATE(493), 1,
      sym_map,
  [35777] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1291), 1,
      sym_identifier,
    ACTIONS(1357), 1,
      anon_sym_RBRACE,
    STATE(718), 1,
      aux_sym_map_repeat1,
  [35790] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1361), 1,
      anon_sym_COMMA,
    ACTIONS(1359), 2,
      anon_sym_RBRACE,
      sym_identifier,
  [35801] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1363), 1,
      anon_sym_async,
    ACTIONS(1365), 1,
      anon_sym_LBRACE,
    STATE(529), 1,
      sym_block,
  [35814] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1331), 1,
      sym_identifier,
    ACTIONS(1367), 1,
      anon_sym_RBRACE,
    STATE(743), 1,
      aux_sym_struct_definition_repeat1,
  [35827] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1363), 1,
      anon_sym_async,
    ACTIONS(1365), 1,
      anon_sym_LBRACE,
    STATE(533), 1,
      sym_block,
  [35840] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1149), 1,
      anon_sym_RBRACE,
    ACTIONS(1323), 1,
      sym_identifier,
    STATE(700), 1,
      aux_sym_type_repeat1,
  [35853] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(758), 1,
      anon_sym_RPAREN,
    ACTIONS(1302), 1,
      sym_identifier,
    STATE(703), 1,
      aux_sym_function_repeat1,
  [35866] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1359), 1,
      anon_sym_RBRACE,
    ACTIONS(1369), 1,
      sym_identifier,
    STATE(732), 1,
      aux_sym_enum_definition_repeat1,
  [35879] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1351), 1,
      anon_sym_async,
    ACTIONS(1353), 1,
      anon_sym_LBRACE,
    STATE(458), 1,
      sym_block,
  [35892] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1374), 1,
      anon_sym_EQ,
    ACTIONS(1372), 2,
      anon_sym_RBRACE,
      sym_identifier,
  [35903] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1347), 1,
      sym_identifier,
    ACTIONS(1376), 1,
      anon_sym_RBRACE,
    STATE(732), 1,
      aux_sym_enum_definition_repeat1,
  [35916] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(326), 1,
      anon_sym_COLON,
    ACTIONS(280), 2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [35927] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1372), 1,
      anon_sym_RBRACE,
    ACTIONS(1378), 1,
      sym_identifier,
    STATE(737), 1,
      aux_sym_struct_definition_repeat1,
  [35940] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1159), 1,
      anon_sym_RBRACE,
    ACTIONS(1323), 1,
      sym_identifier,
    STATE(700), 1,
      aux_sym_type_repeat1,
  [35953] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1302), 1,
      sym_identifier,
    ACTIONS(1381), 1,
      anon_sym_RPAREN,
    STATE(696), 1,
      aux_sym_function_repeat1,
  [35966] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(991), 1,
      anon_sym_async,
    ACTIONS(993), 1,
      anon_sym_LBRACE,
    STATE(526), 1,
      sym_block,
  [35979] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(636), 1,
      anon_sym_LBRACE,
    ACTIONS(1383), 1,
      sym_identifier,
    STATE(494), 1,
      sym_map,
  [35992] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1291), 1,
      sym_identifier,
    ACTIONS(1385), 1,
      anon_sym_RBRACE,
    STATE(755), 1,
      aux_sym_map_repeat1,
  [36005] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1331), 1,
      sym_identifier,
    ACTIONS(1387), 1,
      anon_sym_RBRACE,
    STATE(737), 1,
      aux_sym_struct_definition_repeat1,
  [36018] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1391), 1,
      anon_sym_COMMA,
    ACTIONS(1389), 2,
      anon_sym_RBRACE,
      sym_identifier,
  [36029] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1393), 1,
      anon_sym_async,
    ACTIONS(1395), 1,
      anon_sym_LBRACE,
    STATE(76), 1,
      sym_block,
  [36042] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(657), 1,
      anon_sym_LBRACE,
    ACTIONS(1313), 1,
      sym_identifier,
    STATE(84), 1,
      sym_map,
  [36055] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1291), 1,
      sym_identifier,
    ACTIONS(1397), 1,
      anon_sym_RBRACE,
    STATE(758), 1,
      aux_sym_map_repeat1,
  [36068] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1291), 1,
      sym_identifier,
    ACTIONS(1399), 1,
      anon_sym_RBRACE,
    STATE(755), 1,
      aux_sym_map_repeat1,
  [36081] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(496), 1,
      anon_sym_LBRACE,
    ACTIONS(1401), 1,
      sym_identifier,
    STATE(156), 1,
      sym_map,
  [36094] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(987), 1,
      anon_sym_async,
    ACTIONS(989), 1,
      anon_sym_LBRACE,
    STATE(332), 1,
      sym_block,
  [36107] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1393), 1,
      anon_sym_async,
    ACTIONS(1395), 1,
      anon_sym_LBRACE,
    STATE(80), 1,
      sym_block,
  [36120] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1403), 1,
      anon_sym_EQ,
    ACTIONS(1405), 1,
      anon_sym_LT,
    STATE(831), 1,
      sym_type_specification,
  [36133] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1407), 1,
      anon_sym_COMMA,
    ACTIONS(1298), 2,
      anon_sym_RPAREN,
      sym_identifier,
  [36144] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1409), 1,
      anon_sym_async,
    ACTIONS(1411), 1,
      anon_sym_LBRACE,
    STATE(151), 1,
      sym_block,
  [36157] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1413), 1,
      sym_identifier,
    ACTIONS(1416), 1,
      anon_sym_RBRACE,
    STATE(755), 1,
      aux_sym_map_repeat1,
  [36170] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(284), 1,
      anon_sym_COLON,
    ACTIONS(1277), 1,
      anon_sym_COLON_COLON,
  [36183] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1331), 1,
      sym_identifier,
    ACTIONS(1418), 1,
      anon_sym_RBRACE,
    STATE(713), 1,
      aux_sym_struct_definition_repeat1,
  [36196] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1291), 1,
      sym_identifier,
    ACTIONS(1420), 1,
      anon_sym_RBRACE,
    STATE(755), 1,
      aux_sym_map_repeat1,
  [36209] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1409), 1,
      anon_sym_async,
    ACTIONS(1411), 1,
      anon_sym_LBRACE,
    STATE(150), 1,
      sym_block,
  [36222] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1107), 1,
      anon_sym_RBRACE,
    ACTIONS(1323), 1,
      sym_identifier,
    STATE(700), 1,
      aux_sym_type_repeat1,
  [36235] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(412), 1,
      anon_sym_GT,
    ACTIONS(727), 1,
      anon_sym_LT,
    STATE(528), 1,
      sym_type_arguments,
  [36248] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1291), 1,
      sym_identifier,
    ACTIONS(1357), 1,
      anon_sym_RBRACE,
    STATE(742), 1,
      aux_sym_map_repeat1,
  [36261] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1422), 1,
      anon_sym_LPAREN,
    ACTIONS(1424), 1,
      anon_sym_RPAREN,
  [36271] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(1426), 1,
      anon_sym_RPAREN,
  [36281] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(1428), 1,
      anon_sym_RPAREN,
  [36291] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1309), 2,
      anon_sym_RBRACE,
      sym_identifier,
  [36299] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(428), 1,
      anon_sym_GT,
    ACTIONS(1430), 1,
      anon_sym_DASH_GT,
  [36309] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(1432), 1,
      anon_sym_RPAREN,
  [36319] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1434), 2,
      anon_sym_RBRACE,
      sym_identifier,
  [36327] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1405), 1,
      anon_sym_LT,
    STATE(729), 1,
      sym_type_specification,
  [36337] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1323), 1,
      sym_identifier,
    STATE(730), 1,
      aux_sym_type_repeat1,
  [36347] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(1436), 1,
      anon_sym_RPAREN,
  [36357] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1319), 2,
      anon_sym_RBRACE,
      sym_identifier,
  [36365] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1347), 1,
      sym_identifier,
    STATE(735), 1,
      aux_sym_enum_definition_repeat1,
  [36375] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1438), 1,
      anon_sym_LPAREN,
    ACTIONS(1440), 1,
      anon_sym_DASH_GT,
  [36385] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1323), 1,
      sym_identifier,
    STATE(738), 1,
      aux_sym_type_repeat1,
  [36395] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1347), 1,
      sym_identifier,
    STATE(719), 1,
      aux_sym_enum_definition_repeat1,
  [36405] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1405), 1,
      anon_sym_LT,
    STATE(751), 1,
      sym_type_specification,
  [36415] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1442), 2,
      anon_sym_RBRACE,
      sym_identifier,
  [36423] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1444), 2,
      anon_sym_RBRACE,
      sym_identifier,
  [36431] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1359), 2,
      anon_sym_RBRACE,
      sym_identifier,
  [36439] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1275), 1,
      anon_sym_LT,
    STATE(753), 1,
      sym_type_specification,
  [36449] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1405), 1,
      anon_sym_LT,
    STATE(745), 1,
      sym_type_specification,
  [36459] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1323), 1,
      sym_identifier,
    STATE(722), 1,
      aux_sym_type_repeat1,
  [36469] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1405), 1,
      anon_sym_LT,
    STATE(720), 1,
      sym_type_specification,
  [36479] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1405), 1,
      anon_sym_LT,
    STATE(715), 1,
      sym_type_specification,
  [36489] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1405), 1,
      anon_sym_LT,
    STATE(727), 1,
      sym_type_specification,
  [36499] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 1,
      anon_sym_LPAREN,
    ACTIONS(1446), 1,
      anon_sym_RPAREN,
  [36509] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1448), 2,
      anon_sym_RBRACE,
      sym_identifier,
  [36517] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1323), 1,
      sym_identifier,
    STATE(708), 1,
      aux_sym_type_repeat1,
  [36527] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1405), 1,
      anon_sym_LT,
    STATE(707), 1,
      sym_type_specification,
  [36537] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1405), 1,
      anon_sym_LT,
    STATE(705), 1,
      sym_type_specification,
  [36547] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1405), 1,
      anon_sym_LT,
    STATE(723), 1,
      sym_type_specification,
  [36557] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1450), 2,
      anon_sym_RPAREN,
      sym_identifier,
  [36565] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(422), 1,
      anon_sym_GT,
    ACTIONS(1452), 1,
      anon_sym_DASH_GT,
  [36575] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1323), 1,
      sym_identifier,
    STATE(721), 1,
      aux_sym_type_repeat1,
  [36585] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1275), 1,
      anon_sym_LT,
    STATE(766), 1,
      sym_type_specification,
  [36595] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1405), 1,
      anon_sym_LT,
    STATE(733), 1,
      sym_type_specification,
  [36605] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1405), 1,
      anon_sym_LT,
    STATE(754), 1,
      sym_type_specification,
  [36615] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1405), 1,
      anon_sym_LT,
    STATE(759), 1,
      sym_type_specification,
  [36625] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1323), 1,
      sym_identifier,
    STATE(760), 1,
      aux_sym_type_repeat1,
  [36635] = 2,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(1454), 1,
      sym_command_text,
  [36642] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1456), 1,
      anon_sym_GT,
  [36649] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1458), 1,
      anon_sym_in,
  [36656] = 2,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(1460), 1,
      sym_command_text,
  [36663] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1462), 1,
      anon_sym_COLON,
  [36670] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1464), 1,
      anon_sym_LBRACE,
  [36677] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1466), 1,
      anon_sym_LPAREN,
  [36684] = 2,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(1468), 1,
      sym_command_text,
  [36691] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1470), 1,
      anon_sym_GT,
  [36698] = 2,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(1472), 1,
      sym_command_text,
  [36705] = 2,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(1474), 1,
      sym_command_text,
  [36712] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1476), 1,
      anon_sym_LBRACE,
  [36719] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1478), 1,
      anon_sym_LPAREN,
  [36726] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1480), 1,
      anon_sym_COLON_COLON,
  [36733] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1482), 1,
      anon_sym_DASH_GT,
  [36740] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1484), 1,
      anon_sym_DASH_GT,
  [36747] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1486), 1,
      anon_sym_GT,
  [36754] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1488), 1,
      anon_sym_LBRACE,
  [36761] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1490), 1,
      anon_sym_LPAREN,
  [36768] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1492), 1,
      anon_sym_LPAREN,
  [36775] = 2,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(1494), 1,
      sym_command_text,
  [36782] = 2,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(1496), 1,
      sym_command_text,
  [36789] = 2,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(1498), 1,
      sym_command_text,
  [36796] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1500), 1,
      anon_sym_DASH_GT,
  [36803] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1502), 1,
      anon_sym_GT,
  [36810] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1504), 1,
      anon_sym_LBRACE,
  [36817] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1506), 1,
      anon_sym_LPAREN,
  [36824] = 2,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(1508), 1,
      sym_command_text,
  [36831] = 2,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(1510), 1,
      sym_command_text,
  [36838] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1512), 1,
      anon_sym_EQ,
  [36845] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1514), 1,
      anon_sym_LPAREN,
  [36852] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1516), 1,
      anon_sym_LBRACE,
  [36859] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1518), 1,
      anon_sym_LBRACE,
  [36866] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1520), 1,
      anon_sym_LPAREN,
  [36873] = 2,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(1522), 1,
      sym_command_text,
  [36880] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1524), 1,
      anon_sym_LBRACE,
  [36887] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1526), 1,
      anon_sym_LPAREN,
  [36894] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1528), 1,
      anon_sym_LBRACE,
  [36901] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1530), 1,
      sym_identifier,
  [36908] = 2,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(1532), 1,
      sym_command_text,
  [36915] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1422), 1,
      anon_sym_LPAREN,
  [36922] = 2,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(1534), 1,
      sym_command_text,
  [36929] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1536), 1,
      anon_sym_COLON,
  [36936] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1538), 1,
      anon_sym_in,
  [36943] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1540), 1,
      anon_sym_LPAREN,
  [36950] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1542), 1,
      sym_identifier,
  [36957] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1544), 1,
      anon_sym_LBRACE,
  [36964] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1546), 1,
      anon_sym_COLON,
  [36971] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1548), 1,
      ts_builtin_sym_end,
  [36978] = 2,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(1550), 1,
      sym_command_text,
  [36985] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1552), 1,
      sym_identifier,
  [36992] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1554), 1,
      sym_identifier,
  [36999] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1556), 1,
      anon_sym_COLON,
  [37006] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1558), 1,
      anon_sym_GT,
  [37013] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1560), 1,
      anon_sym_GT,
  [37020] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1562), 1,
      anon_sym_GT,
  [37027] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1564), 1,
      anon_sym_LBRACE,
  [37034] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1566), 1,
      anon_sym_GT,
  [37041] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1568), 1,
      sym_identifier,
  [37048] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1570), 1,
      sym_identifier,
  [37055] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1572), 1,
      anon_sym_COLON,
  [37062] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1574), 1,
      anon_sym_LBRACE,
  [37069] = 2,
    ACTIONS(360), 1,
      sym__comment,
    ACTIONS(1576), 1,
      sym_command_text,
  [37076] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1578), 1,
      anon_sym_COLON,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(5)] = 0,
  [SMALL_STATE(6)] = 139,
  [SMALL_STATE(7)] = 278,
  [SMALL_STATE(8)] = 417,
  [SMALL_STATE(9)] = 556,
  [SMALL_STATE(10)] = 695,
  [SMALL_STATE(11)] = 834,
  [SMALL_STATE(12)] = 973,
  [SMALL_STATE(13)] = 1112,
  [SMALL_STATE(14)] = 1251,
  [SMALL_STATE(15)] = 1390,
  [SMALL_STATE(16)] = 1529,
  [SMALL_STATE(17)] = 1668,
  [SMALL_STATE(18)] = 1807,
  [SMALL_STATE(19)] = 1946,
  [SMALL_STATE(20)] = 2085,
  [SMALL_STATE(21)] = 2224,
  [SMALL_STATE(22)] = 2363,
  [SMALL_STATE(23)] = 2502,
  [SMALL_STATE(24)] = 2641,
  [SMALL_STATE(25)] = 2780,
  [SMALL_STATE(26)] = 2919,
  [SMALL_STATE(27)] = 3058,
  [SMALL_STATE(28)] = 3197,
  [SMALL_STATE(29)] = 3336,
  [SMALL_STATE(30)] = 3475,
  [SMALL_STATE(31)] = 3614,
  [SMALL_STATE(32)] = 3753,
  [SMALL_STATE(33)] = 3892,
  [SMALL_STATE(34)] = 4031,
  [SMALL_STATE(35)] = 4170,
  [SMALL_STATE(36)] = 4309,
  [SMALL_STATE(37)] = 4448,
  [SMALL_STATE(38)] = 4587,
  [SMALL_STATE(39)] = 4726,
  [SMALL_STATE(40)] = 4865,
  [SMALL_STATE(41)] = 5004,
  [SMALL_STATE(42)] = 5143,
  [SMALL_STATE(43)] = 5282,
  [SMALL_STATE(44)] = 5421,
  [SMALL_STATE(45)] = 5556,
  [SMALL_STATE(46)] = 5691,
  [SMALL_STATE(47)] = 5826,
  [SMALL_STATE(48)] = 5961,
  [SMALL_STATE(49)] = 6096,
  [SMALL_STATE(50)] = 6231,
  [SMALL_STATE(51)] = 6366,
  [SMALL_STATE(52)] = 6501,
  [SMALL_STATE(53)] = 6636,
  [SMALL_STATE(54)] = 6771,
  [SMALL_STATE(55)] = 6906,
  [SMALL_STATE(56)] = 7041,
  [SMALL_STATE(57)] = 7176,
  [SMALL_STATE(58)] = 7311,
  [SMALL_STATE(59)] = 7446,
  [SMALL_STATE(60)] = 7581,
  [SMALL_STATE(61)] = 7716,
  [SMALL_STATE(62)] = 7851,
  [SMALL_STATE(63)] = 7986,
  [SMALL_STATE(64)] = 8121,
  [SMALL_STATE(65)] = 8256,
  [SMALL_STATE(66)] = 8391,
  [SMALL_STATE(67)] = 8519,
  [SMALL_STATE(68)] = 8647,
  [SMALL_STATE(69)] = 8775,
  [SMALL_STATE(70)] = 8903,
  [SMALL_STATE(71)] = 9031,
  [SMALL_STATE(72)] = 9159,
  [SMALL_STATE(73)] = 9287,
  [SMALL_STATE(74)] = 9415,
  [SMALL_STATE(75)] = 9543,
  [SMALL_STATE(76)] = 9671,
  [SMALL_STATE(77)] = 9728,
  [SMALL_STATE(78)] = 9785,
  [SMALL_STATE(79)] = 9842,
  [SMALL_STATE(80)] = 9915,
  [SMALL_STATE(81)] = 9972,
  [SMALL_STATE(82)] = 10029,
  [SMALL_STATE(83)] = 10102,
  [SMALL_STATE(84)] = 10175,
  [SMALL_STATE(85)] = 10232,
  [SMALL_STATE(86)] = 10289,
  [SMALL_STATE(87)] = 10346,
  [SMALL_STATE(88)] = 10403,
  [SMALL_STATE(89)] = 10460,
  [SMALL_STATE(90)] = 10517,
  [SMALL_STATE(91)] = 10573,
  [SMALL_STATE(92)] = 10631,
  [SMALL_STATE(93)] = 10689,
  [SMALL_STATE(94)] = 10745,
  [SMALL_STATE(95)] = 10801,
  [SMALL_STATE(96)] = 10857,
  [SMALL_STATE(97)] = 10912,
  [SMALL_STATE(98)] = 10967,
  [SMALL_STATE(99)] = 11032,
  [SMALL_STATE(100)] = 11087,
  [SMALL_STATE(101)] = 11142,
  [SMALL_STATE(102)] = 11207,
  [SMALL_STATE(103)] = 11265,
  [SMALL_STATE(104)] = 11323,
  [SMALL_STATE(105)] = 11381,
  [SMALL_STATE(106)] = 11439,
  [SMALL_STATE(107)] = 11497,
  [SMALL_STATE(108)] = 11555,
  [SMALL_STATE(109)] = 11608,
  [SMALL_STATE(110)] = 11667,
  [SMALL_STATE(111)] = 11720,
  [SMALL_STATE(112)] = 11775,
  [SMALL_STATE(113)] = 11827,
  [SMALL_STATE(114)] = 11879,
  [SMALL_STATE(115)] = 11935,
  [SMALL_STATE(116)] = 12001,
  [SMALL_STATE(117)] = 12057,
  [SMALL_STATE(118)] = 12113,
  [SMALL_STATE(119)] = 12165,
  [SMALL_STATE(120)] = 12221,
  [SMALL_STATE(121)] = 12275,
  [SMALL_STATE(122)] = 12331,
  [SMALL_STATE(123)] = 12385,
  [SMALL_STATE(124)] = 12441,
  [SMALL_STATE(125)] = 12507,
  [SMALL_STATE(126)] = 12558,
  [SMALL_STATE(127)] = 12609,
  [SMALL_STATE(128)] = 12664,
  [SMALL_STATE(129)] = 12715,
  [SMALL_STATE(130)] = 12768,
  [SMALL_STATE(131)] = 12819,
  [SMALL_STATE(132)] = 12870,
  [SMALL_STATE(133)] = 12921,
  [SMALL_STATE(134)] = 12976,
  [SMALL_STATE(135)] = 13027,
  [SMALL_STATE(136)] = 13080,
  [SMALL_STATE(137)] = 13133,
  [SMALL_STATE(138)] = 13184,
  [SMALL_STATE(139)] = 13235,
  [SMALL_STATE(140)] = 13288,
  [SMALL_STATE(141)] = 13337,
  [SMALL_STATE(142)] = 13383,
  [SMALL_STATE(143)] = 13445,
  [SMALL_STATE(144)] = 13491,
  [SMALL_STATE(145)] = 13537,
  [SMALL_STATE(146)] = 13583,
  [SMALL_STATE(147)] = 13629,
  [SMALL_STATE(148)] = 13675,
  [SMALL_STATE(149)] = 13721,
  [SMALL_STATE(150)] = 13767,
  [SMALL_STATE(151)] = 13813,
  [SMALL_STATE(152)] = 13859,
  [SMALL_STATE(153)] = 13905,
  [SMALL_STATE(154)] = 13951,
  [SMALL_STATE(155)] = 13997,
  [SMALL_STATE(156)] = 14043,
  [SMALL_STATE(157)] = 14089,
  [SMALL_STATE(158)] = 14135,
  [SMALL_STATE(159)] = 14183,
  [SMALL_STATE(160)] = 14229,
  [SMALL_STATE(161)] = 14275,
  [SMALL_STATE(162)] = 14321,
  [SMALL_STATE(163)] = 14402,
  [SMALL_STATE(164)] = 14483,
  [SMALL_STATE(165)] = 14564,
  [SMALL_STATE(166)] = 14645,
  [SMALL_STATE(167)] = 14726,
  [SMALL_STATE(168)] = 14807,
  [SMALL_STATE(169)] = 14888,
  [SMALL_STATE(170)] = 14969,
  [SMALL_STATE(171)] = 15050,
  [SMALL_STATE(172)] = 15131,
  [SMALL_STATE(173)] = 15212,
  [SMALL_STATE(174)] = 15293,
  [SMALL_STATE(175)] = 15374,
  [SMALL_STATE(176)] = 15455,
  [SMALL_STATE(177)] = 15536,
  [SMALL_STATE(178)] = 15617,
  [SMALL_STATE(179)] = 15698,
  [SMALL_STATE(180)] = 15779,
  [SMALL_STATE(181)] = 15860,
  [SMALL_STATE(182)] = 15941,
  [SMALL_STATE(183)] = 16022,
  [SMALL_STATE(184)] = 16103,
  [SMALL_STATE(185)] = 16184,
  [SMALL_STATE(186)] = 16265,
  [SMALL_STATE(187)] = 16346,
  [SMALL_STATE(188)] = 16427,
  [SMALL_STATE(189)] = 16508,
  [SMALL_STATE(190)] = 16589,
  [SMALL_STATE(191)] = 16670,
  [SMALL_STATE(192)] = 16751,
  [SMALL_STATE(193)] = 16832,
  [SMALL_STATE(194)] = 16913,
  [SMALL_STATE(195)] = 16994,
  [SMALL_STATE(196)] = 17048,
  [SMALL_STATE(197)] = 17098,
  [SMALL_STATE(198)] = 17141,
  [SMALL_STATE(199)] = 17188,
  [SMALL_STATE(200)] = 17263,
  [SMALL_STATE(201)] = 17338,
  [SMALL_STATE(202)] = 17413,
  [SMALL_STATE(203)] = 17488,
  [SMALL_STATE(204)] = 17563,
  [SMALL_STATE(205)] = 17638,
  [SMALL_STATE(206)] = 17713,
  [SMALL_STATE(207)] = 17788,
  [SMALL_STATE(208)] = 17863,
  [SMALL_STATE(209)] = 17910,
  [SMALL_STATE(210)] = 17985,
  [SMALL_STATE(211)] = 18060,
  [SMALL_STATE(212)] = 18135,
  [SMALL_STATE(213)] = 18210,
  [SMALL_STATE(214)] = 18285,
  [SMALL_STATE(215)] = 18330,
  [SMALL_STATE(216)] = 18377,
  [SMALL_STATE(217)] = 18452,
  [SMALL_STATE(218)] = 18499,
  [SMALL_STATE(219)] = 18542,
  [SMALL_STATE(220)] = 18617,
  [SMALL_STATE(221)] = 18692,
  [SMALL_STATE(222)] = 18767,
  [SMALL_STATE(223)] = 18842,
  [SMALL_STATE(224)] = 18917,
  [SMALL_STATE(225)] = 18992,
  [SMALL_STATE(226)] = 19067,
  [SMALL_STATE(227)] = 19142,
  [SMALL_STATE(228)] = 19217,
  [SMALL_STATE(229)] = 19292,
  [SMALL_STATE(230)] = 19367,
  [SMALL_STATE(231)] = 19442,
  [SMALL_STATE(232)] = 19517,
  [SMALL_STATE(233)] = 19592,
  [SMALL_STATE(234)] = 19667,
  [SMALL_STATE(235)] = 19742,
  [SMALL_STATE(236)] = 19817,
  [SMALL_STATE(237)] = 19892,
  [SMALL_STATE(238)] = 19967,
  [SMALL_STATE(239)] = 20014,
  [SMALL_STATE(240)] = 20059,
  [SMALL_STATE(241)] = 20134,
  [SMALL_STATE(242)] = 20179,
  [SMALL_STATE(243)] = 20254,
  [SMALL_STATE(244)] = 20296,
  [SMALL_STATE(245)] = 20342,
  [SMALL_STATE(246)] = 20384,
  [SMALL_STATE(247)] = 20426,
  [SMALL_STATE(248)] = 20470,
  [SMALL_STATE(249)] = 20516,
  [SMALL_STATE(250)] = 20558,
  [SMALL_STATE(251)] = 20604,
  [SMALL_STATE(252)] = 20646,
  [SMALL_STATE(253)] = 20688,
  [SMALL_STATE(254)] = 20732,
  [SMALL_STATE(255)] = 20774,
  [SMALL_STATE(256)] = 20816,
  [SMALL_STATE(257)] = 20862,
  [SMALL_STATE(258)] = 20904,
  [SMALL_STATE(259)] = 20954,
  [SMALL_STATE(260)] = 21004,
  [SMALL_STATE(261)] = 21050,
  [SMALL_STATE(262)] = 21096,
  [SMALL_STATE(263)] = 21141,
  [SMALL_STATE(264)] = 21182,
  [SMALL_STATE(265)] = 21239,
  [SMALL_STATE(266)] = 21284,
  [SMALL_STATE(267)] = 21329,
  [SMALL_STATE(268)] = 21384,
  [SMALL_STATE(269)] = 21429,
  [SMALL_STATE(270)] = 21474,
  [SMALL_STATE(271)] = 21519,
  [SMALL_STATE(272)] = 21576,
  [SMALL_STATE(273)] = 21621,
  [SMALL_STATE(274)] = 21661,
  [SMALL_STATE(275)] = 21703,
  [SMALL_STATE(276)] = 21743,
  [SMALL_STATE(277)] = 21787,
  [SMALL_STATE(278)] = 21827,
  [SMALL_STATE(279)] = 21867,
  [SMALL_STATE(280)] = 21911,
  [SMALL_STATE(281)] = 21955,
  [SMALL_STATE(282)] = 21999,
  [SMALL_STATE(283)] = 22043,
  [SMALL_STATE(284)] = 22091,
  [SMALL_STATE(285)] = 22135,
  [SMALL_STATE(286)] = 22179,
  [SMALL_STATE(287)] = 22219,
  [SMALL_STATE(288)] = 22259,
  [SMALL_STATE(289)] = 22330,
  [SMALL_STATE(290)] = 22401,
  [SMALL_STATE(291)] = 22472,
  [SMALL_STATE(292)] = 22511,
  [SMALL_STATE(293)] = 22582,
  [SMALL_STATE(294)] = 22621,
  [SMALL_STATE(295)] = 22692,
  [SMALL_STATE(296)] = 22731,
  [SMALL_STATE(297)] = 22770,
  [SMALL_STATE(298)] = 22809,
  [SMALL_STATE(299)] = 22848,
  [SMALL_STATE(300)] = 22916,
  [SMALL_STATE(301)] = 22954,
  [SMALL_STATE(302)] = 22992,
  [SMALL_STATE(303)] = 23030,
  [SMALL_STATE(304)] = 23096,
  [SMALL_STATE(305)] = 23138,
  [SMALL_STATE(306)] = 23176,
  [SMALL_STATE(307)] = 23218,
  [SMALL_STATE(308)] = 23256,
  [SMALL_STATE(309)] = 23298,
  [SMALL_STATE(310)] = 23366,
  [SMALL_STATE(311)] = 23434,
  [SMALL_STATE(312)] = 23502,
  [SMALL_STATE(313)] = 23570,
  [SMALL_STATE(314)] = 23612,
  [SMALL_STATE(315)] = 23680,
  [SMALL_STATE(316)] = 23719,
  [SMALL_STATE(317)] = 23756,
  [SMALL_STATE(318)] = 23793,
  [SMALL_STATE(319)] = 23830,
  [SMALL_STATE(320)] = 23867,
  [SMALL_STATE(321)] = 23906,
  [SMALL_STATE(322)] = 23943,
  [SMALL_STATE(323)] = 23980,
  [SMALL_STATE(324)] = 24017,
  [SMALL_STATE(325)] = 24054,
  [SMALL_STATE(326)] = 24091,
  [SMALL_STATE(327)] = 24128,
  [SMALL_STATE(328)] = 24165,
  [SMALL_STATE(329)] = 24204,
  [SMALL_STATE(330)] = 24245,
  [SMALL_STATE(331)] = 24282,
  [SMALL_STATE(332)] = 24323,
  [SMALL_STATE(333)] = 24360,
  [SMALL_STATE(334)] = 24397,
  [SMALL_STATE(335)] = 24434,
  [SMALL_STATE(336)] = 24471,
  [SMALL_STATE(337)] = 24508,
  [SMALL_STATE(338)] = 24545,
  [SMALL_STATE(339)] = 24582,
  [SMALL_STATE(340)] = 24619,
  [SMALL_STATE(341)] = 24658,
  [SMALL_STATE(342)] = 24720,
  [SMALL_STATE(343)] = 24782,
  [SMALL_STATE(344)] = 24844,
  [SMALL_STATE(345)] = 24903,
  [SMALL_STATE(346)] = 24962,
  [SMALL_STATE(347)] = 25012,
  [SMALL_STATE(348)] = 25046,
  [SMALL_STATE(349)] = 25099,
  [SMALL_STATE(350)] = 25152,
  [SMALL_STATE(351)] = 25201,
  [SMALL_STATE(352)] = 25254,
  [SMALL_STATE(353)] = 25307,
  [SMALL_STATE(354)] = 25360,
  [SMALL_STATE(355)] = 25413,
  [SMALL_STATE(356)] = 25455,
  [SMALL_STATE(357)] = 25489,
  [SMALL_STATE(358)] = 25520,
  [SMALL_STATE(359)] = 25551,
  [SMALL_STATE(360)] = 25582,
  [SMALL_STATE(361)] = 25613,
  [SMALL_STATE(362)] = 25648,
  [SMALL_STATE(363)] = 25679,
  [SMALL_STATE(364)] = 25710,
  [SMALL_STATE(365)] = 25749,
  [SMALL_STATE(366)] = 25780,
  [SMALL_STATE(367)] = 25811,
  [SMALL_STATE(368)] = 25842,
  [SMALL_STATE(369)] = 25873,
  [SMALL_STATE(370)] = 25914,
  [SMALL_STATE(371)] = 25945,
  [SMALL_STATE(372)] = 25976,
  [SMALL_STATE(373)] = 26007,
  [SMALL_STATE(374)] = 26038,
  [SMALL_STATE(375)] = 26073,
  [SMALL_STATE(376)] = 26104,
  [SMALL_STATE(377)] = 26137,
  [SMALL_STATE(378)] = 26176,
  [SMALL_STATE(379)] = 26207,
  [SMALL_STATE(380)] = 26238,
  [SMALL_STATE(381)] = 26269,
  [SMALL_STATE(382)] = 26304,
  [SMALL_STATE(383)] = 26335,
  [SMALL_STATE(384)] = 26369,
  [SMALL_STATE(385)] = 26403,
  [SMALL_STATE(386)] = 26437,
  [SMALL_STATE(387)] = 26471,
  [SMALL_STATE(388)] = 26505,
  [SMALL_STATE(389)] = 26539,
  [SMALL_STATE(390)] = 26573,
  [SMALL_STATE(391)] = 26602,
  [SMALL_STATE(392)] = 26639,
  [SMALL_STATE(393)] = 26674,
  [SMALL_STATE(394)] = 26702,
  [SMALL_STATE(395)] = 26734,
  [SMALL_STATE(396)] = 26766,
  [SMALL_STATE(397)] = 26798,
  [SMALL_STATE(398)] = 26830,
  [SMALL_STATE(399)] = 26858,
  [SMALL_STATE(400)] = 26886,
  [SMALL_STATE(401)] = 26918,
  [SMALL_STATE(402)] = 26946,
  [SMALL_STATE(403)] = 26986,
  [SMALL_STATE(404)] = 27014,
  [SMALL_STATE(405)] = 27042,
  [SMALL_STATE(406)] = 27070,
  [SMALL_STATE(407)] = 27102,
  [SMALL_STATE(408)] = 27134,
  [SMALL_STATE(409)] = 27164,
  [SMALL_STATE(410)] = 27192,
  [SMALL_STATE(411)] = 27220,
  [SMALL_STATE(412)] = 27252,
  [SMALL_STATE(413)] = 27280,
  [SMALL_STATE(414)] = 27311,
  [SMALL_STATE(415)] = 27342,
  [SMALL_STATE(416)] = 27381,
  [SMALL_STATE(417)] = 27410,
  [SMALL_STATE(418)] = 27451,
  [SMALL_STATE(419)] = 27482,
  [SMALL_STATE(420)] = 27513,
  [SMALL_STATE(421)] = 27546,
  [SMALL_STATE(422)] = 27575,
  [SMALL_STATE(423)] = 27604,
  [SMALL_STATE(424)] = 27635,
  [SMALL_STATE(425)] = 27666,
  [SMALL_STATE(426)] = 27707,
  [SMALL_STATE(427)] = 27748,
  [SMALL_STATE(428)] = 27777,
  [SMALL_STATE(429)] = 27818,
  [SMALL_STATE(430)] = 27859,
  [SMALL_STATE(431)] = 27886,
  [SMALL_STATE(432)] = 27917,
  [SMALL_STATE(433)] = 27948,
  [SMALL_STATE(434)] = 27977,
  [SMALL_STATE(435)] = 28008,
  [SMALL_STATE(436)] = 28039,
  [SMALL_STATE(437)] = 28068,
  [SMALL_STATE(438)] = 28095,
  [SMALL_STATE(439)] = 28126,
  [SMALL_STATE(440)] = 28157,
  [SMALL_STATE(441)] = 28186,
  [SMALL_STATE(442)] = 28227,
  [SMALL_STATE(443)] = 28264,
  [SMALL_STATE(444)] = 28293,
  [SMALL_STATE(445)] = 28326,
  [SMALL_STATE(446)] = 28357,
  [SMALL_STATE(447)] = 28398,
  [SMALL_STATE(448)] = 28429,
  [SMALL_STATE(449)] = 28458,
  [SMALL_STATE(450)] = 28487,
  [SMALL_STATE(451)] = 28514,
  [SMALL_STATE(452)] = 28555,
  [SMALL_STATE(453)] = 28596,
  [SMALL_STATE(454)] = 28627,
  [SMALL_STATE(455)] = 28653,
  [SMALL_STATE(456)] = 28679,
  [SMALL_STATE(457)] = 28705,
  [SMALL_STATE(458)] = 28731,
  [SMALL_STATE(459)] = 28757,
  [SMALL_STATE(460)] = 28783,
  [SMALL_STATE(461)] = 28809,
  [SMALL_STATE(462)] = 28843,
  [SMALL_STATE(463)] = 28869,
  [SMALL_STATE(464)] = 28895,
  [SMALL_STATE(465)] = 28923,
  [SMALL_STATE(466)] = 28949,
  [SMALL_STATE(467)] = 28975,
  [SMALL_STATE(468)] = 29001,
  [SMALL_STATE(469)] = 29027,
  [SMALL_STATE(470)] = 29053,
  [SMALL_STATE(471)] = 29079,
  [SMALL_STATE(472)] = 29105,
  [SMALL_STATE(473)] = 29131,
  [SMALL_STATE(474)] = 29157,
  [SMALL_STATE(475)] = 29183,
  [SMALL_STATE(476)] = 29209,
  [SMALL_STATE(477)] = 29235,
  [SMALL_STATE(478)] = 29265,
  [SMALL_STATE(479)] = 29291,
  [SMALL_STATE(480)] = 29317,
  [SMALL_STATE(481)] = 29343,
  [SMALL_STATE(482)] = 29373,
  [SMALL_STATE(483)] = 29399,
  [SMALL_STATE(484)] = 29425,
  [SMALL_STATE(485)] = 29451,
  [SMALL_STATE(486)] = 29481,
  [SMALL_STATE(487)] = 29507,
  [SMALL_STATE(488)] = 29533,
  [SMALL_STATE(489)] = 29559,
  [SMALL_STATE(490)] = 29587,
  [SMALL_STATE(491)] = 29613,
  [SMALL_STATE(492)] = 29639,
  [SMALL_STATE(493)] = 29665,
  [SMALL_STATE(494)] = 29691,
  [SMALL_STATE(495)] = 29717,
  [SMALL_STATE(496)] = 29745,
  [SMALL_STATE(497)] = 29771,
  [SMALL_STATE(498)] = 29797,
  [SMALL_STATE(499)] = 29825,
  [SMALL_STATE(500)] = 29851,
  [SMALL_STATE(501)] = 29877,
  [SMALL_STATE(502)] = 29903,
  [SMALL_STATE(503)] = 29929,
  [SMALL_STATE(504)] = 29955,
  [SMALL_STATE(505)] = 29981,
  [SMALL_STATE(506)] = 30007,
  [SMALL_STATE(507)] = 30037,
  [SMALL_STATE(508)] = 30063,
  [SMALL_STATE(509)] = 30089,
  [SMALL_STATE(510)] = 30115,
  [SMALL_STATE(511)] = 30141,
  [SMALL_STATE(512)] = 30167,
  [SMALL_STATE(513)] = 30193,
  [SMALL_STATE(514)] = 30219,
  [SMALL_STATE(515)] = 30245,
  [SMALL_STATE(516)] = 30271,
  [SMALL_STATE(517)] = 30297,
  [SMALL_STATE(518)] = 30323,
  [SMALL_STATE(519)] = 30349,
  [SMALL_STATE(520)] = 30375,
  [SMALL_STATE(521)] = 30403,
  [SMALL_STATE(522)] = 30431,
  [SMALL_STATE(523)] = 30457,
  [SMALL_STATE(524)] = 30483,
  [SMALL_STATE(525)] = 30509,
  [SMALL_STATE(526)] = 30535,
  [SMALL_STATE(527)] = 30561,
  [SMALL_STATE(528)] = 30587,
  [SMALL_STATE(529)] = 30613,
  [SMALL_STATE(530)] = 30639,
  [SMALL_STATE(531)] = 30665,
  [SMALL_STATE(532)] = 30691,
  [SMALL_STATE(533)] = 30719,
  [SMALL_STATE(534)] = 30745,
  [SMALL_STATE(535)] = 30771,
  [SMALL_STATE(536)] = 30797,
  [SMALL_STATE(537)] = 30823,
  [SMALL_STATE(538)] = 30849,
  [SMALL_STATE(539)] = 30875,
  [SMALL_STATE(540)] = 30901,
  [SMALL_STATE(541)] = 30927,
  [SMALL_STATE(542)] = 30955,
  [SMALL_STATE(543)] = 30983,
  [SMALL_STATE(544)] = 31012,
  [SMALL_STATE(545)] = 31051,
  [SMALL_STATE(546)] = 31080,
  [SMALL_STATE(547)] = 31119,
  [SMALL_STATE(548)] = 31146,
  [SMALL_STATE(549)] = 31185,
  [SMALL_STATE(550)] = 31224,
  [SMALL_STATE(551)] = 31263,
  [SMALL_STATE(552)] = 31302,
  [SMALL_STATE(553)] = 31337,
  [SMALL_STATE(554)] = 31364,
  [SMALL_STATE(555)] = 31389,
  [SMALL_STATE(556)] = 31428,
  [SMALL_STATE(557)] = 31467,
  [SMALL_STATE(558)] = 31492,
  [SMALL_STATE(559)] = 31527,
  [SMALL_STATE(560)] = 31554,
  [SMALL_STATE(561)] = 31593,
  [SMALL_STATE(562)] = 31632,
  [SMALL_STATE(563)] = 31671,
  [SMALL_STATE(564)] = 31696,
  [SMALL_STATE(565)] = 31735,
  [SMALL_STATE(566)] = 31774,
  [SMALL_STATE(567)] = 31813,
  [SMALL_STATE(568)] = 31852,
  [SMALL_STATE(569)] = 31891,
  [SMALL_STATE(570)] = 31930,
  [SMALL_STATE(571)] = 31969,
  [SMALL_STATE(572)] = 31994,
  [SMALL_STATE(573)] = 32029,
  [SMALL_STATE(574)] = 32064,
  [SMALL_STATE(575)] = 32093,
  [SMALL_STATE(576)] = 32132,
  [SMALL_STATE(577)] = 32171,
  [SMALL_STATE(578)] = 32210,
  [SMALL_STATE(579)] = 32249,
  [SMALL_STATE(580)] = 32274,
  [SMALL_STATE(581)] = 32313,
  [SMALL_STATE(582)] = 32342,
  [SMALL_STATE(583)] = 32371,
  [SMALL_STATE(584)] = 32400,
  [SMALL_STATE(585)] = 32439,
  [SMALL_STATE(586)] = 32474,
  [SMALL_STATE(587)] = 32509,
  [SMALL_STATE(588)] = 32534,
  [SMALL_STATE(589)] = 32563,
  [SMALL_STATE(590)] = 32590,
  [SMALL_STATE(591)] = 32629,
  [SMALL_STATE(592)] = 32668,
  [SMALL_STATE(593)] = 32693,
  [SMALL_STATE(594)] = 32732,
  [SMALL_STATE(595)] = 32771,
  [SMALL_STATE(596)] = 32810,
  [SMALL_STATE(597)] = 32837,
  [SMALL_STATE(598)] = 32876,
  [SMALL_STATE(599)] = 32915,
  [SMALL_STATE(600)] = 32942,
  [SMALL_STATE(601)] = 32981,
  [SMALL_STATE(602)] = 33020,
  [SMALL_STATE(603)] = 33055,
  [SMALL_STATE(604)] = 33082,
  [SMALL_STATE(605)] = 33106,
  [SMALL_STATE(606)] = 33130,
  [SMALL_STATE(607)] = 33154,
  [SMALL_STATE(608)] = 33190,
  [SMALL_STATE(609)] = 33226,
  [SMALL_STATE(610)] = 33250,
  [SMALL_STATE(611)] = 33274,
  [SMALL_STATE(612)] = 33300,
  [SMALL_STATE(613)] = 33324,
  [SMALL_STATE(614)] = 33356,
  [SMALL_STATE(615)] = 33382,
  [SMALL_STATE(616)] = 33406,
  [SMALL_STATE(617)] = 33430,
  [SMALL_STATE(618)] = 33466,
  [SMALL_STATE(619)] = 33490,
  [SMALL_STATE(620)] = 33514,
  [SMALL_STATE(621)] = 33538,
  [SMALL_STATE(622)] = 33562,
  [SMALL_STATE(623)] = 33586,
  [SMALL_STATE(624)] = 33622,
  [SMALL_STATE(625)] = 33646,
  [SMALL_STATE(626)] = 33682,
  [SMALL_STATE(627)] = 33718,
  [SMALL_STATE(628)] = 33754,
  [SMALL_STATE(629)] = 33778,
  [SMALL_STATE(630)] = 33802,
  [SMALL_STATE(631)] = 33826,
  [SMALL_STATE(632)] = 33850,
  [SMALL_STATE(633)] = 33874,
  [SMALL_STATE(634)] = 33898,
  [SMALL_STATE(635)] = 33924,
  [SMALL_STATE(636)] = 33948,
  [SMALL_STATE(637)] = 33981,
  [SMALL_STATE(638)] = 34014,
  [SMALL_STATE(639)] = 34047,
  [SMALL_STATE(640)] = 34080,
  [SMALL_STATE(641)] = 34113,
  [SMALL_STATE(642)] = 34146,
  [SMALL_STATE(643)] = 34179,
  [SMALL_STATE(644)] = 34212,
  [SMALL_STATE(645)] = 34245,
  [SMALL_STATE(646)] = 34278,
  [SMALL_STATE(647)] = 34311,
  [SMALL_STATE(648)] = 34344,
  [SMALL_STATE(649)] = 34377,
  [SMALL_STATE(650)] = 34410,
  [SMALL_STATE(651)] = 34435,
  [SMALL_STATE(652)] = 34460,
  [SMALL_STATE(653)] = 34485,
  [SMALL_STATE(654)] = 34518,
  [SMALL_STATE(655)] = 34551,
  [SMALL_STATE(656)] = 34584,
  [SMALL_STATE(657)] = 34607,
  [SMALL_STATE(658)] = 34640,
  [SMALL_STATE(659)] = 34673,
  [SMALL_STATE(660)] = 34698,
  [SMALL_STATE(661)] = 34731,
  [SMALL_STATE(662)] = 34764,
  [SMALL_STATE(663)] = 34789,
  [SMALL_STATE(664)] = 34822,
  [SMALL_STATE(665)] = 34855,
  [SMALL_STATE(666)] = 34888,
  [SMALL_STATE(667)] = 34911,
  [SMALL_STATE(668)] = 34944,
  [SMALL_STATE(669)] = 34977,
  [SMALL_STATE(670)] = 35010,
  [SMALL_STATE(671)] = 35031,
  [SMALL_STATE(672)] = 35052,
  [SMALL_STATE(673)] = 35073,
  [SMALL_STATE(674)] = 35093,
  [SMALL_STATE(675)] = 35113,
  [SMALL_STATE(676)] = 35133,
  [SMALL_STATE(677)] = 35148,
  [SMALL_STATE(678)] = 35168,
  [SMALL_STATE(679)] = 35182,
  [SMALL_STATE(680)] = 35194,
  [SMALL_STATE(681)] = 35206,
  [SMALL_STATE(682)] = 35222,
  [SMALL_STATE(683)] = 35239,
  [SMALL_STATE(684)] = 35250,
  [SMALL_STATE(685)] = 35261,
  [SMALL_STATE(686)] = 35276,
  [SMALL_STATE(687)] = 35289,
  [SMALL_STATE(688)] = 35301,
  [SMALL_STATE(689)] = 35313,
  [SMALL_STATE(690)] = 35325,
  [SMALL_STATE(691)] = 35337,
  [SMALL_STATE(692)] = 35349,
  [SMALL_STATE(693)] = 35363,
  [SMALL_STATE(694)] = 35377,
  [SMALL_STATE(695)] = 35389,
  [SMALL_STATE(696)] = 35402,
  [SMALL_STATE(697)] = 35415,
  [SMALL_STATE(698)] = 35428,
  [SMALL_STATE(699)] = 35441,
  [SMALL_STATE(700)] = 35454,
  [SMALL_STATE(701)] = 35467,
  [SMALL_STATE(702)] = 35480,
  [SMALL_STATE(703)] = 35493,
  [SMALL_STATE(704)] = 35506,
  [SMALL_STATE(705)] = 35519,
  [SMALL_STATE(706)] = 35532,
  [SMALL_STATE(707)] = 35543,
  [SMALL_STATE(708)] = 35556,
  [SMALL_STATE(709)] = 35569,
  [SMALL_STATE(710)] = 35582,
  [SMALL_STATE(711)] = 35595,
  [SMALL_STATE(712)] = 35608,
  [SMALL_STATE(713)] = 35621,
  [SMALL_STATE(714)] = 35634,
  [SMALL_STATE(715)] = 35647,
  [SMALL_STATE(716)] = 35660,
  [SMALL_STATE(717)] = 35673,
  [SMALL_STATE(718)] = 35686,
  [SMALL_STATE(719)] = 35699,
  [SMALL_STATE(720)] = 35712,
  [SMALL_STATE(721)] = 35725,
  [SMALL_STATE(722)] = 35738,
  [SMALL_STATE(723)] = 35751,
  [SMALL_STATE(724)] = 35764,
  [SMALL_STATE(725)] = 35777,
  [SMALL_STATE(726)] = 35790,
  [SMALL_STATE(727)] = 35801,
  [SMALL_STATE(728)] = 35814,
  [SMALL_STATE(729)] = 35827,
  [SMALL_STATE(730)] = 35840,
  [SMALL_STATE(731)] = 35853,
  [SMALL_STATE(732)] = 35866,
  [SMALL_STATE(733)] = 35879,
  [SMALL_STATE(734)] = 35892,
  [SMALL_STATE(735)] = 35903,
  [SMALL_STATE(736)] = 35916,
  [SMALL_STATE(737)] = 35927,
  [SMALL_STATE(738)] = 35940,
  [SMALL_STATE(739)] = 35953,
  [SMALL_STATE(740)] = 35966,
  [SMALL_STATE(741)] = 35979,
  [SMALL_STATE(742)] = 35992,
  [SMALL_STATE(743)] = 36005,
  [SMALL_STATE(744)] = 36018,
  [SMALL_STATE(745)] = 36029,
  [SMALL_STATE(746)] = 36042,
  [SMALL_STATE(747)] = 36055,
  [SMALL_STATE(748)] = 36068,
  [SMALL_STATE(749)] = 36081,
  [SMALL_STATE(750)] = 36094,
  [SMALL_STATE(751)] = 36107,
  [SMALL_STATE(752)] = 36120,
  [SMALL_STATE(753)] = 36133,
  [SMALL_STATE(754)] = 36144,
  [SMALL_STATE(755)] = 36157,
  [SMALL_STATE(756)] = 36170,
  [SMALL_STATE(757)] = 36183,
  [SMALL_STATE(758)] = 36196,
  [SMALL_STATE(759)] = 36209,
  [SMALL_STATE(760)] = 36222,
  [SMALL_STATE(761)] = 36235,
  [SMALL_STATE(762)] = 36248,
  [SMALL_STATE(763)] = 36261,
  [SMALL_STATE(764)] = 36271,
  [SMALL_STATE(765)] = 36281,
  [SMALL_STATE(766)] = 36291,
  [SMALL_STATE(767)] = 36299,
  [SMALL_STATE(768)] = 36309,
  [SMALL_STATE(769)] = 36319,
  [SMALL_STATE(770)] = 36327,
  [SMALL_STATE(771)] = 36337,
  [SMALL_STATE(772)] = 36347,
  [SMALL_STATE(773)] = 36357,
  [SMALL_STATE(774)] = 36365,
  [SMALL_STATE(775)] = 36375,
  [SMALL_STATE(776)] = 36385,
  [SMALL_STATE(777)] = 36395,
  [SMALL_STATE(778)] = 36405,
  [SMALL_STATE(779)] = 36415,
  [SMALL_STATE(780)] = 36423,
  [SMALL_STATE(781)] = 36431,
  [SMALL_STATE(782)] = 36439,
  [SMALL_STATE(783)] = 36449,
  [SMALL_STATE(784)] = 36459,
  [SMALL_STATE(785)] = 36469,
  [SMALL_STATE(786)] = 36479,
  [SMALL_STATE(787)] = 36489,
  [SMALL_STATE(788)] = 36499,
  [SMALL_STATE(789)] = 36509,
  [SMALL_STATE(790)] = 36517,
  [SMALL_STATE(791)] = 36527,
  [SMALL_STATE(792)] = 36537,
  [SMALL_STATE(793)] = 36547,
  [SMALL_STATE(794)] = 36557,
  [SMALL_STATE(795)] = 36565,
  [SMALL_STATE(796)] = 36575,
  [SMALL_STATE(797)] = 36585,
  [SMALL_STATE(798)] = 36595,
  [SMALL_STATE(799)] = 36605,
  [SMALL_STATE(800)] = 36615,
  [SMALL_STATE(801)] = 36625,
  [SMALL_STATE(802)] = 36635,
  [SMALL_STATE(803)] = 36642,
  [SMALL_STATE(804)] = 36649,
  [SMALL_STATE(805)] = 36656,
  [SMALL_STATE(806)] = 36663,
  [SMALL_STATE(807)] = 36670,
  [SMALL_STATE(808)] = 36677,
  [SMALL_STATE(809)] = 36684,
  [SMALL_STATE(810)] = 36691,
  [SMALL_STATE(811)] = 36698,
  [SMALL_STATE(812)] = 36705,
  [SMALL_STATE(813)] = 36712,
  [SMALL_STATE(814)] = 36719,
  [SMALL_STATE(815)] = 36726,
  [SMALL_STATE(816)] = 36733,
  [SMALL_STATE(817)] = 36740,
  [SMALL_STATE(818)] = 36747,
  [SMALL_STATE(819)] = 36754,
  [SMALL_STATE(820)] = 36761,
  [SMALL_STATE(821)] = 36768,
  [SMALL_STATE(822)] = 36775,
  [SMALL_STATE(823)] = 36782,
  [SMALL_STATE(824)] = 36789,
  [SMALL_STATE(825)] = 36796,
  [SMALL_STATE(826)] = 36803,
  [SMALL_STATE(827)] = 36810,
  [SMALL_STATE(828)] = 36817,
  [SMALL_STATE(829)] = 36824,
  [SMALL_STATE(830)] = 36831,
  [SMALL_STATE(831)] = 36838,
  [SMALL_STATE(832)] = 36845,
  [SMALL_STATE(833)] = 36852,
  [SMALL_STATE(834)] = 36859,
  [SMALL_STATE(835)] = 36866,
  [SMALL_STATE(836)] = 36873,
  [SMALL_STATE(837)] = 36880,
  [SMALL_STATE(838)] = 36887,
  [SMALL_STATE(839)] = 36894,
  [SMALL_STATE(840)] = 36901,
  [SMALL_STATE(841)] = 36908,
  [SMALL_STATE(842)] = 36915,
  [SMALL_STATE(843)] = 36922,
  [SMALL_STATE(844)] = 36929,
  [SMALL_STATE(845)] = 36936,
  [SMALL_STATE(846)] = 36943,
  [SMALL_STATE(847)] = 36950,
  [SMALL_STATE(848)] = 36957,
  [SMALL_STATE(849)] = 36964,
  [SMALL_STATE(850)] = 36971,
  [SMALL_STATE(851)] = 36978,
  [SMALL_STATE(852)] = 36985,
  [SMALL_STATE(853)] = 36992,
  [SMALL_STATE(854)] = 36999,
  [SMALL_STATE(855)] = 37006,
  [SMALL_STATE(856)] = 37013,
  [SMALL_STATE(857)] = 37020,
  [SMALL_STATE(858)] = 37027,
  [SMALL_STATE(859)] = 37034,
  [SMALL_STATE(860)] = 37041,
  [SMALL_STATE(861)] = 37048,
  [SMALL_STATE(862)] = 37055,
  [SMALL_STATE(863)] = 37062,
  [SMALL_STATE(864)] = 37069,
  [SMALL_STATE(865)] = 37076,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(71),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(863),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(225),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(220),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(697),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(216),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(860),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(853),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(852),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(79),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(72),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [61] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [63] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [71] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [81] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_root_repeat1, 2), SHIFT_REPEAT(83),
  [84] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_root_repeat1, 2), SHIFT_REPEAT(72),
  [87] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_root_repeat1, 2), SHIFT_REPEAT(170),
  [90] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_root_repeat1, 2), SHIFT_REPEAT(809),
  [93] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_root_repeat1, 2), SHIFT_REPEAT(81),
  [96] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_root_repeat1, 2), SHIFT_REPEAT(863),
  [99] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_root_repeat1, 2), SHIFT_REPEAT(2),
  [102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_root_repeat1, 2),
  [104] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_root_repeat1, 2), SHIFT_REPEAT(111),
  [107] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_root_repeat1, 2), SHIFT_REPEAT(85),
  [110] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_root_repeat1, 2), SHIFT_REPEAT(86),
  [113] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_root_repeat1, 2), SHIFT_REPEAT(87),
  [116] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_root_repeat1, 2), SHIFT_REPEAT(169),
  [119] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_root_repeat1, 2), SHIFT_REPEAT(225),
  [122] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_root_repeat1, 2), SHIFT_REPEAT(220),
  [125] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_root_repeat1, 2), SHIFT_REPEAT(697),
  [128] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_root_repeat1, 2), SHIFT_REPEAT(216),
  [131] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_root_repeat1, 2), SHIFT_REPEAT(860),
  [134] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_root_repeat1, 2), SHIFT_REPEAT(860),
  [137] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_root_repeat1, 2), SHIFT_REPEAT(853),
  [140] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_root_repeat1, 2), SHIFT_REPEAT(852),
  [143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_root, 1),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [175] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_root_repeat1, 2), SHIFT_REPEAT(82),
  [178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_root_repeat1, 2), SHIFT_REPEAT(71),
  [181] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_root_repeat1, 2), SHIFT_REPEAT(841),
  [184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(350),
  [188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(75),
  [190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(813),
  [198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(368),
  [204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(367),
  [206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(366),
  [208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(200),
  [212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(219),
  [214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(710),
  [216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(861),
  [220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(847),
  [224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(840),
  [226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(74),
  [228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(346),
  [230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(70),
  [232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(73),
  [236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(68),
  [238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(67),
  [240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(142),
  [242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(152),
  [256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(157),
  [258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(159),
  [260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(69),
  [264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 5),
  [266] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 5),
  [268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 2),
  [270] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 2),
  [272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_instance, 6),
  [274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_instance, 6),
  [276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_kind, 1),
  [278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_kind, 1),
  [280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_expression_kind, 1),
  [282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(53),
  [284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_expression, 1),
  [286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(646),
  [288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 4),
  [294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 4),
  [296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 1),
  [298] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 1),
  [300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(347),
  [302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_instance, 3),
  [304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_instance, 3),
  [306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value, 1),
  [308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value, 1),
  [310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_float, 1),
  [312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_float, 1),
  [314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean, 1),
  [316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean, 1),
  [318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 3),
  [320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 3),
  [322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_map, 3),
  [324] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_map, 3),
  [326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_expression, 1),
  [328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_instance, 3),
  [330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_instance, 3),
  [332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_expression, 3),
  [336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_expression, 3),
  [338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index, 3),
  [340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index, 3),
  [342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 4),
  [344] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 4),
  [346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2),
  [348] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2),
  [350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3),
  [352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3),
  [354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_map, 2),
  [356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_map, 2),
  [358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command, 2),
  [360] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command, 2),
  [364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(118),
  [366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command, 3),
  [368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command, 3),
  [370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(112),
  [372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_command_repeat1, 2),
  [374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2),
  [376] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(112),
  [379] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(118),
  [382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_call, 4),
  [384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_call, 4),
  [386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_call, 3),
  [388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_call, 3),
  [390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_argument, 1),
  [392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_argument, 1),
  [394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_logic, 3),
  [396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logic, 3),
  [398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_kind, 1),
  [400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_kind, 1),
  [402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(653),
  [404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(656),
  [406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(666),
  [412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1),
  [414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 1),
  [416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(627),
  [418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_math, 3),
  [420] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_math, 3),
  [422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 2),
  [424] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 2),
  [426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 3),
  [430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 3),
  [432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 3),
  [436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 3),
  [438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 4),
  [440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 4),
  [442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(290),
  [444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3),
  [446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3),
  [448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(294),
  [450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_as_node, 3),
  [452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_as_node, 3),
  [454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1),
  [456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1),
  [458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(641),
  [460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 5),
  [462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 5),
  [464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(442),
  [470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(467),
  [484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(471),
  [486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(472),
  [488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(196),
  [492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [522] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_list_repeat1, 2), SHIFT_REPEAT(196),
  [525] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_repeat1, 2), SHIFT_REPEAT(162),
  [528] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_repeat1, 2), SHIFT_REPEAT(864),
  [531] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_repeat1, 2), SHIFT_REPEAT(148),
  [534] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_repeat1, 2), SHIFT_REPEAT(716),
  [537] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_repeat1, 2), SHIFT_REPEAT(214),
  [540] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_list_repeat1, 2), SHIFT_REPEAT(152),
  [543] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_list_repeat1, 2), SHIFT_REPEAT(157),
  [546] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_list_repeat1, 2), SHIFT_REPEAT(159),
  [549] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_repeat1, 2), SHIFT_REPEAT(188),
  [552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_list_repeat1, 2),
  [554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [574] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__expression_list, 2), SHIFT_REPEAT(196),
  [577] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__expression_list, 2), SHIFT_REPEAT(162),
  [580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__expression_list, 2),
  [582] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__expression_list, 2), SHIFT_REPEAT(812),
  [585] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__expression_list, 2), SHIFT_REPEAT(148),
  [588] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__expression_list, 2), SHIFT_REPEAT(716),
  [591] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__expression_list, 2), SHIFT_REPEAT(214),
  [594] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__expression_list, 2), SHIFT_REPEAT(152),
  [597] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__expression_list, 2), SHIFT_REPEAT(157),
  [600] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__expression_list, 2), SHIFT_REPEAT(159),
  [603] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__expression_list, 2), SHIFT_REPEAT(188),
  [606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(263),
  [624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(392),
  [626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(420),
  [630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(480),
  [642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(516),
  [644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(515),
  [646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(444),
  [650] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(263),
  [653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(109),
  [657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(461),
  [661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(617),
  [663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(286),
  [669] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(286),
  [672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(278),
  [674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(658),
  [676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_else, 2),
  [678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_else, 2),
  [680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(750),
  [684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_else, 1),
  [686] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_else, 1),
  [688] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(278),
  [691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_else_repeat1, 2),
  [693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_else_repeat1, 2),
  [695] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_if_else_repeat1, 2), SHIFT_REPEAT(227),
  [698] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__expression_list, 1),
  [700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__expression_list, 1),
  [702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(638),
  [706] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_list_repeat1, 1),
  [708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_list_repeat1, 1),
  [710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(292),
  [714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(300),
  [716] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(307),
  [719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(307),
  [721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_definition, 2),
  [723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_definition, 2),
  [725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [729] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(300),
  [732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(756),
  [734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if, 3),
  [746] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if, 3),
  [748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_if, 3),
  [754] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_if, 3),
  [756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(677),
  [758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_definition, 4),
  [762] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_definition, 4),
  [764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_definition, 3),
  [766] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_definition, 3),
  [768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_definition_repeat2, 2),
  [770] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_enum_definition_repeat2, 2),
  [772] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_definition_repeat2, 2), SHIFT_REPEAT(777),
  [775] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pipe, 3),
  [777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pipe, 3),
  [779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_loop_node, 2),
  [781] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_loop_node, 2),
  [783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1),
  [785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 1),
  [787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_else, 3),
  [789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_else, 3),
  [791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_assignment, 3),
  [793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_assignment, 3),
  [795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 2),
  [797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 2),
  [799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 1),
  [803] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 1),
  [805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match, 5),
  [807] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match, 5),
  [809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while, 3),
  [811] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while, 3),
  [813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 4),
  [815] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment, 4),
  [817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 4),
  [819] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_definition, 4),
  [821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 5),
  [823] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_definition, 5),
  [825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else, 2),
  [827] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else, 2),
  [829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 3),
  [831] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment, 3),
  [833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_definition_repeat2, 3),
  [835] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_enum_definition_repeat2, 3),
  [837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 3),
  [839] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 3),
  [841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for, 5),
  [843] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for, 5),
  [845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(815),
  [849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [859] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_repeat1, 2), SHIFT_REPEAT(815),
  [862] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_repeat1, 2), SHIFT_REPEAT(731),
  [865] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_repeat1, 2), SHIFT_REPEAT(81),
  [868] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_repeat1, 2), SHIFT_REPEAT(762),
  [871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_match_repeat1, 2),
  [873] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_repeat1, 2), SHIFT_REPEAT(85),
  [876] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_repeat1, 2), SHIFT_REPEAT(85),
  [879] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_repeat1, 2), SHIFT_REPEAT(86),
  [882] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_repeat1, 2), SHIFT_REPEAT(87),
  [885] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_repeat1, 2), SHIFT_REPEAT(169),
  [888] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_repeat1, 2), SHIFT_REPEAT(816),
  [891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_operator, 1),
  [895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_operator, 1),
  [897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(421),
  [899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(92),
  [905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(692),
  [911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(422),
  [915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(140),
  [921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(356),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(390),
  [933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(740),
  [937] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(390),
  [940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(410),
  [944] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(399),
  [947] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_if_else_repeat1, 2), SHIFT_REPEAT(202),
  [950] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(410),
  [953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(399),
  [955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(469),
  [961] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(469),
  [964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(640),
  [966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(288),
  [968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(592),
  [970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(637),
  [974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(587),
  [980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [984] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(592),
  [987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [1001] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_definition_repeat2, 2), SHIFT_REPEAT(774),
  [1004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(626),
  [1006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [1008] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(587),
  [1011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [1013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(655),
  [1015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [1017] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(395),
  [1020] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(600),
  [1023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2),
  [1025] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(776),
  [1028] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(566),
  [1031] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(457),
  [1034] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(443),
  [1037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(289),
  [1039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [1041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [1043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [1045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(636),
  [1047] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_repeat2, 1),
  [1049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 1),
  [1051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [1053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [1055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [1057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(395),
  [1059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [1061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [1063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [1065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [1067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(457),
  [1069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(443),
  [1071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(608),
  [1073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [1075] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_match_repeat1, 3),
  [1077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_match_repeat1, 3),
  [1079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [1081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [1083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [1085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [1087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [1089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [1091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [1093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [1095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [1097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [1099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [1101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [1103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [1105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [1107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [1109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [1111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [1113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [1115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [1117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [1119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [1121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [1123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_repeat2, 2),
  [1125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [1127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [1129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [1131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [1133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [1135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [1137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [1139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [1141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [1143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [1145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(623),
  [1147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [1149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [1151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [1153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [1155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [1157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [1159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [1161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [1163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [1165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [1167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [1169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [1171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(647),
  [1173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__expression_list, 2),
  [1175] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_match_repeat1, 4),
  [1177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_match_repeat1, 4),
  [1179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(648),
  [1181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_list_repeat1, 2),
  [1183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(761),
  [1185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [1187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(588),
  [1189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [1191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [1193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [1195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(615),
  [1197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(614),
  [1199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(238),
  [1201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [1203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [1205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [1207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(255),
  [1209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(253),
  [1211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(434),
  [1213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [1215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [1217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [1219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(497),
  [1221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(498),
  [1223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [1225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [1227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [1229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [1231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(616),
  [1233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(634),
  [1235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [1237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [1239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [1241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(117),
  [1243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [1245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [1247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [1249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(137),
  [1251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(135),
  [1253] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_math_operator, 1),
  [1255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_math_operator, 1),
  [1257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [1259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [1261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_logic_operator, 1),
  [1263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logic_operator, 1),
  [1265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(676),
  [1267] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(676),
  [1270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(678),
  [1272] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(678),
  [1275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [1277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [1279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [1281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_definition_repeat1, 1),
  [1283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [1285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_specification, 3),
  [1287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [1289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [1291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [1293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [1295] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_repeat1, 2), SHIFT_REPEAT(782),
  [1298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_repeat1, 2),
  [1300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [1302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [1304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [1306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat1, 2), SHIFT_REPEAT(797),
  [1309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_repeat1, 2),
  [1311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [1313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [1315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [1317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [1319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_map_repeat1, 4),
  [1321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [1323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [1325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [1327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [1329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [1331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [1333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [1335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [1337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [1339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [1341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [1343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [1345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [1347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [1349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [1351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [1353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [1355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [1357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [1359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_definition_repeat1, 2),
  [1361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [1363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [1365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [1367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [1369] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_definition_repeat1, 2), SHIFT_REPEAT(682),
  [1372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_definition_repeat1, 2),
  [1374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [1376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [1378] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_definition_repeat1, 2), SHIFT_REPEAT(714),
  [1381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [1383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [1385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [1387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [1389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_map_repeat1, 3),
  [1391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [1393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [1395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [1397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [1399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [1401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [1403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [1405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [1407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [1409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [1411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [1413] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_map_repeat1, 2), SHIFT_REPEAT(752),
  [1416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_map_repeat1, 2),
  [1418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [1420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [1422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_expression, 1),
  [1424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [1426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [1428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [1430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [1432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [1434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_definition_repeat1, 3),
  [1436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [1438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [1440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_pattern, 3),
  [1442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_definition_repeat1, 3),
  [1444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_map_repeat1, 5),
  [1446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [1448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_definition_repeat1, 4),
  [1450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_repeat1, 3),
  [1452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [1454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(383),
  [1456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [1458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [1460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(276),
  [1462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [1464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [1466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [1468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(102),
  [1470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [1472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(381),
  [1474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(250),
  [1476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [1478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [1480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [1482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_pattern, 1),
  [1484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [1486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [1488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [1490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [1492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [1494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(670),
  [1496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(215),
  [1498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(284),
  [1500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_pattern, 6),
  [1502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [1504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [1506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [1508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(389),
  [1510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(674),
  [1512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [1514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_expression, 3),
  [1516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [1518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [1520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [1522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(396),
  [1524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [1526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [1528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [1530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [1532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(105),
  [1534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [1536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [1538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [1540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [1542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [1544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [1546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [1548] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [1550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(424),
  [1552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [1554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [1556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [1558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [1560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [1562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [1564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [1566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [1568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [1570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [1572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [1574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [1576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(256),
  [1578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_dust(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
